libname DEC1980 "/decennial/1980cen/1980S/microdata";
libname DEC1990 "/decennial/1990cen/1990S/microdata";
libname DEC2000 "/decennial/2000cen/microdata";
libname CBRF "/rdcprojects/mc1/mc00535/data/CBRF";
libname OUTDATA "/rdcprojects/mc1/mc00535/data/decennial/01-Raw_Extracts";


**** Include savastata macro for exporting to stata;
%include "/rdcprojects/mc1/mc00535/programs_organize/1.library/savastata.mac";

**** Write state abbreviations (for states with sample_main=1, assigned_tract in {0,1})
**** to a vector of local macros that can be looped over;

%let state1 = al;
%let state2 = ak;
%let state3 = az;
%let state4 = ar;
%let state5 = ca;
%let state6 = co;
%let state7 = ct;
%let state8 = de;
%let state9 = dc;
%let state10 = fl;
%let state11 = ga;
%let state12 = hi;
%let state13 = id;
%let state14 = il;
%let state15 = in;
%let state16 = ia;
%let state17 = ks;
%let state18 = ky;
%let state19 = la;
%let state20 = me;
%let state21 = md;
%let state22 = ma;
%let state23 = mi;
%let state24 = mn;
%let state25 = ms;
%let state26 = mo;
%let state27 = mt;
%let state28 = ne;
%let state29 = nv;
%let state30 = nh;
%let state31 = nj;
%let state32 = nm;
%let state33 = ny;
%let state34 = nc;
%let state35 = nd;
%let state36 = oh;
%let state37 = ok;
%let state38 = or;
%let state39 = pa;
%let state40 = ri;
%let state41 = sc;
%let state42 = sd;
%let state43 = tn;
%let state44 = tx;
%let state45 = ut;
%let state46 = vt;
%let state47 = va;
%let state48 = wa;
%let state49 = wv;
%let state50 = wi;
%let state51 = wy;


%let statenum1 = 01;
%let statenum2 = 02;
%let statenum3 = 04;
%let statenum4 = 05;
%let statenum5 = 06;
%let statenum6 = 08;
%let statenum7 = 09;
%let statenum8 = 10;
%let statenum9 = 11;
%let statenum10 = 12;
%let statenum11 = 13;
%let statenum12 = 17;
%let statenum13 = 18;
%let statenum14 = 19;
%let statenum15 = 20;
%let statenum16 = 21;
%let statenum17 = 22;
%let statenum18 = 24;
%let statenum19 = 25;
%let statenum20 = 26;
%let statenum21 = 27;
%let statenum22 = 28;
%let statenum23 = 29;
%let statenum24 = 31;
%let statenum25 = 32;
%let statenum26 = 33;
%let statenum27 = 34;
%let statenum28 = 35;
%let statenum29 = 36;
%let statenum30 = 37;
%let statenum31 = 39;
%let statenum32 = 40;
%let statenum33 = 41;
%let statenum34 = 42;
%let statenum35 = 44;
%let statenum36 = 45;
%let statenum37 = 47;
%let statenum38 = 48;
%let statenum39 = 49;
%let statenum40 = 51;
%let statenum41 = 53;
%let statenum42 = 54;
%let statenum43 = 55;


**** Define lists of variables to keep;
%let keepvarsP = GIDP PWT PWB PWBS SFN PERN SEX AGE MS RAC SOR REL
      POVS POB CIT SCH HDEG ANCP ANCS LOTE WLW WLWH PWS PWC PWCT MTW TTW IND OCC COW UHW
      PINC MOBS MIGS MIGC
      ESR WW INCW INCP
      HHT YMI YMIA
      SEXA AGEA MSA RACA SORA
      POBA CITA SCHA HDEGA ANCPA ANCSA LOTEA WLWHA PWSA PWSCA
      PWCA PWCCA PWCTA MTWA TTWA INDA OCCA COWA UHWA
      MOBSA MIGSA MIGCA
      ESRA WWA INCWA INCPA;
%let keepvarsH = HWT RM TEN VAL RNT YSB HINC FINC
                 GQT GQI BRM PFAC KIT VS NOC
                 RMA TENA VALA RNTA YSBA
                 BRMA PFACA KITA VSA;
%let keepvarsG = STF COU TRCT BLK blockid90;


%macro loops;
%do st = 1 %to 51 ;

data work.&&state&st  (keep = HHIDP &keepvarsP rename = (HHIDP = HHIDH));
set DEC1990.t13&&state&st..1990sp;


label GIDP = 'Geographic ID'
      HHIDP = 'Household ID'
      PWT = 'Person Weight'
      PERN = 'Earnings'
      SEX = 'SEX'
      AGE = 'AGE'
      MS = 'Marital Status'
      RAC = 'Detailed Race'
      SOR = 'Spanish Origin'
      POVS = 'Poverty Status'
      POB = 'Place of Birth'
      CIT = 'Citizenship Status'
      SCH = 'School Enrollment'
      HDEG = 'Highest Degree Completed'
      ANCP = 'Ancestry - Primary'
      ANCS = 'Ancestry - Secondary'
      LOTE = 'Language Besides English Spoken at Home'
      WLW = 'Worked Last Week'
      WLWH = 'Hours Worked Last Week'
      PWS = 'Place of Work - State'
      PWC = 'Place of Work - County'
      PWCT = 'Place of Work - Census Tract'
      MTW = 'Means of Transportation to Work'
      TTW = 'Travel Time to Work'
      IND = 'Industry'
      OCC = 'Occupation'
      UHW = 'Usual Hours Worked Per Week Last Year'
      INCW = 'Wages or Salary Income'
      INCN = 'Nonfarm Self-Employment Income (Signed)'
      INCF = 'Farm Self-Employment Income (Signed)'
      INCI = 'Interest, Dividends, and Net Rental Income (Signed)'
      INCS = 'Social Security Income'
      INCP = 'Public Assistance Income'
      INCR = 'Retirement Income'
      INCO = 'All Other Income'
      MOBS = 'Mobility Status'
      MIGS = 'Migration - State or Foreign Country'
      MIGC = 'Migration - County';

run;


proc sort data = work.&&state&st;
by HHIDH;


data work.&&state&st (keep = HHIDH GIDH &keepvarsP &keepvarsH rename = (HHIDH = HHID GIDH=GIDG));
merge work.&&state&st (in=inp) DEC1990.t13&&state&st..1990sh (in = inh);
by HHIDH;


household_record = 0;
if (inp = 1) or (inh=1) then household_record = 1;
if household_record=1;

label household_record = 'Household Record Successfully Merged to Person File'
      RM = 'Rooms'
      HWT = 'Housing Weight'
      TEN = 'Tenure'
      VAL = 'Value'
      RNT = 'Monthly Rent'
      YSB = 'Year Structure Built';

run;


proc sort data = work.&&state&st;
by GIDG;
run;

data work.&&state&st (keep = HHID GIDG &keepvarsP &keepvarsH &keepvarsG insample inpowsample in5pctoutside rename=(GIDG=GID));
merge work.&&state&st (in=inp) DEC1990.t13&&state&st..1990sg (in = ing drop=MSA);
by GIDG;

household_record = 0;
if inp = 1 then household_record = 1;
if household_record = 1;

blockid90 = "               ";
if length(trct)=4 then blockid90 = STF||COU||substr(TRCT,1,4)||"00"||BLK ;
if length(trct)=6 then blockid90 = STF||COU||TRCT||BLK ;


***** Keep only if respondent resides or works in a 
***** county appearing on block level admin data file;
insample = 0;
if stf||cou="01015" then insample = 1;
if stf||cou="01073" then insample = 1;
if stf||cou="01097" then insample = 1;
if stf||cou="02090" then insample = 1;
if stf||cou="04013" then insample = 1;
if stf||cou="04019" then insample = 1;
if stf||cou="05069" then insample = 1;
if stf||cou="05119" then insample = 1;
if stf||cou="06001" then insample = 1;
if stf||cou="06019" then insample = 1;
if stf||cou="06037" then insample = 1;
if stf||cou="06059" then insample = 1;
if stf||cou="06067" then insample = 1;
if stf||cou="06073" then insample = 1;
if stf||cou="06075" then insample = 1;
if stf||cou="08001" then insample = 1;
if stf||cou="08031" then insample = 1;
if stf||cou="08123" then insample = 1;
if stf||cou="09001" then insample = 1;
if stf||cou="09003" then insample = 1;
if stf||cou="09009" then insample = 1;
if stf||cou="10003" then insample = 1;
if stf||cou="11001" then insample = 1;
if stf||cou="12011" then insample = 1;
if stf||cou="12031" then insample = 1;
if stf||cou="12057" then insample = 1;
if stf||cou="12025" then insample = 1;
if stf||cou="13051" then insample = 1;
if stf||cou="13089" then insample = 1;
if stf||cou="13095" then insample = 1;
if stf||cou="13121" then insample = 1;
if stf||cou="17031" then insample = 1;
if stf||cou="17143" then insample = 1;
if stf||cou="17163" then insample = 1;
if stf||cou="17167" then insample = 1;
if stf||cou="18089" then insample = 1;
if stf||cou="18097" then insample = 1;
if stf||cou="19153" then insample = 1;
if stf||cou="19193" then insample = 1;
if stf||cou="20209" then insample = 1;
if stf||cou="21111" then insample = 1;
if stf||cou="22017" then insample = 1;
if stf||cou="22019" then insample = 1;
if stf||cou="22051" then insample = 1;
if stf||cou="22071" then insample = 1;
if stf||cou="22073" then insample = 1;
if stf||cou="24510" then insample = 1;
if stf||cou="25009" then insample = 1;
if stf||cou="25013" then insample = 1;
if stf||cou="25017" then insample = 1;
if stf||cou="25025" then insample = 1;
if stf||cou="26021" then insample = 1;
if stf||cou="26049" then insample = 1;
if stf||cou="26121" then insample = 1;
if stf||cou="26163" then insample = 1;
if stf||cou="27053" then insample = 1;
if stf||cou="27123" then insample = 1;
if stf||cou="28049" then insample = 1;
if stf||cou="29095" then insample = 1;
if stf||cou="29189" then insample = 1;
if stf||cou="29510" then insample = 1;
if stf||cou="31055" then insample = 1;
if stf||cou="32003" then insample = 1;
if stf||cou="33011" then insample = 1;
if stf||cou="34007" then insample = 1;
if stf||cou="34011" then insample = 1;
if stf||cou="34013" then insample = 1;
if stf||cou="34017" then insample = 1;
if stf||cou="34039" then insample = 1;
if stf||cou="35001" then insample = 1;
if stf||cou="35013" then insample = 1;
if stf||cou="36005" then insample = 1;
if stf||cou="36029" then insample = 1;
if stf||cou="36055" then insample = 1;
if stf||cou="36061" then insample = 1;
if stf||cou="36063" then insample = 1;
if stf||cou="36067" then insample = 1;
if stf||cou="36071" then insample = 1;
if stf||cou="36093" then insample = 1;
if stf||cou="36119" then insample = 1;
if stf||cou="37119" then insample = 1;
if stf||cou="39017" then insample = 1;
if stf||cou="39035" then insample = 1;
if stf||cou="39049" then insample = 1;
if stf||cou="39061" then insample = 1;
if stf||cou="39081" then insample = 1;
if stf||cou="39087" then insample = 1;
if stf||cou="39099" then insample = 1;
if stf||cou="39153" then insample = 1;
if stf||cou="40109" then insample = 1;
if stf||cou="41051" then insample = 1;
if stf||cou="42003" then insample = 1;
if stf||cou="42043" then insample = 1;
if stf||cou="42045" then insample = 1;
if stf||cou="42101" then insample = 1;
if stf||cou="44007" then insample = 1;
if stf||cou="45019" then insample = 1;
if stf||cou="45053" then insample = 1;
if stf||cou="45079" then insample = 1;
if stf||cou="45085" then insample = 1;
if stf||cou="47037" then insample = 1;
if stf||cou="47065" then insample = 1;
if stf||cou="47093" then insample = 1;
if stf||cou="47157" then insample = 1;
if stf||cou="48029" then insample = 1;
if stf||cou="48113" then insample = 1;
if stf||cou="48141" then insample = 1;
if stf||cou="48201" then insample = 1;
if stf||cou="48245" then insample = 1;
if stf||cou="48309" then insample = 1;
if stf||cou="48355" then insample = 1;
if stf||cou="48361" then insample = 1;
if stf||cou="48439" then insample = 1;
if stf||cou="48453" then insample = 1;
if stf||cou="49057" then insample = 1;
if stf||cou="51710" then insample = 1;
if stf||cou="51740" then insample = 1;
if stf||cou="51760" then insample = 1;
if stf||cou="53033" then insample = 1;
if stf||cou="53053" then insample = 1;
if stf||cou="53077" then insample = 1;
if stf||cou="54009" then insample = 1;
if stf||cou="54011" then insample = 1;
if stf||cou="54039" then insample = 1;
if stf||cou="55079" then insample = 1;


inpowsample = 0;
if substr(pws,2,2)||pwc="01015" then inpowsample = 1;
if substr(pws,2,2)||pwc="01073" then inpowsample = 1;
if substr(pws,2,2)||pwc="01097" then inpowsample = 1;
if substr(pws,2,2)||pwc="02090" then inpowsample = 1;
if substr(pws,2,2)||pwc="04013" then inpowsample = 1;
if substr(pws,2,2)||pwc="04019" then inpowsample = 1;
if substr(pws,2,2)||pwc="05069" then inpowsample = 1;
if substr(pws,2,2)||pwc="05119" then inpowsample = 1;
if substr(pws,2,2)||pwc="06001" then inpowsample = 1;
if substr(pws,2,2)||pwc="06019" then inpowsample = 1;
if substr(pws,2,2)||pwc="06037" then inpowsample = 1;
if substr(pws,2,2)||pwc="06059" then inpowsample = 1;
if substr(pws,2,2)||pwc="06067" then inpowsample = 1;
if substr(pws,2,2)||pwc="06073" then inpowsample = 1;
if substr(pws,2,2)||pwc="06075" then inpowsample = 1;
if substr(pws,2,2)||pwc="08001" then inpowsample = 1;
if substr(pws,2,2)||pwc="08031" then inpowsample = 1;
if substr(pws,2,2)||pwc="08123" then inpowsample = 1;
if substr(pws,2,2)||pwc="09001" then inpowsample = 1;
if substr(pws,2,2)||pwc="09003" then inpowsample = 1;
if substr(pws,2,2)||pwc="09009" then inpowsample = 1;
if substr(pws,2,2)||pwc="10003" then inpowsample = 1;
if substr(pws,2,2)||pwc="11001" then inpowsample = 1;
if substr(pws,2,2)||pwc="12011" then inpowsample = 1;
if substr(pws,2,2)||pwc="12031" then inpowsample = 1;
if substr(pws,2,2)||pwc="12057" then inpowsample = 1;
if substr(pws,2,2)||pwc="12025" then inpowsample = 1;
if substr(pws,2,2)||pwc="13051" then inpowsample = 1;
if substr(pws,2,2)||pwc="13089" then inpowsample = 1;
if substr(pws,2,2)||pwc="13095" then inpowsample = 1;
if substr(pws,2,2)||pwc="13121" then inpowsample = 1;
if substr(pws,2,2)||pwc="17031" then inpowsample = 1;
if substr(pws,2,2)||pwc="17143" then inpowsample = 1;
if substr(pws,2,2)||pwc="17163" then inpowsample = 1;
if substr(pws,2,2)||pwc="17167" then inpowsample = 1;
if substr(pws,2,2)||pwc="18089" then inpowsample = 1;
if substr(pws,2,2)||pwc="18097" then inpowsample = 1;
if substr(pws,2,2)||pwc="19153" then inpowsample = 1;
if substr(pws,2,2)||pwc="19193" then inpowsample = 1;
if substr(pws,2,2)||pwc="20209" then inpowsample = 1;
if substr(pws,2,2)||pwc="21111" then inpowsample = 1;
if substr(pws,2,2)||pwc="22017" then inpowsample = 1;
if substr(pws,2,2)||pwc="22019" then inpowsample = 1;
if substr(pws,2,2)||pwc="22051" then inpowsample = 1;
if substr(pws,2,2)||pwc="22071" then inpowsample = 1;
if substr(pws,2,2)||pwc="22073" then inpowsample = 1;
if substr(pws,2,2)||pwc="24510" then inpowsample = 1;
if substr(pws,2,2)||pwc="25009" then inpowsample = 1;
if substr(pws,2,2)||pwc="25013" then inpowsample = 1;
if substr(pws,2,2)||pwc="25017" then inpowsample = 1;
if substr(pws,2,2)||pwc="25025" then inpowsample = 1;
if substr(pws,2,2)||pwc="26021" then inpowsample = 1;
if substr(pws,2,2)||pwc="26049" then inpowsample = 1;
if substr(pws,2,2)||pwc="26121" then inpowsample = 1;
if substr(pws,2,2)||pwc="26163" then inpowsample = 1;
if substr(pws,2,2)||pwc="27053" then inpowsample = 1;
if substr(pws,2,2)||pwc="27123" then inpowsample = 1;
if substr(pws,2,2)||pwc="28049" then inpowsample = 1;
if substr(pws,2,2)||pwc="29095" then inpowsample = 1;
if substr(pws,2,2)||pwc="29189" then inpowsample = 1;
if substr(pws,2,2)||pwc="29510" then inpowsample = 1;
if substr(pws,2,2)||pwc="31055" then inpowsample = 1;
if substr(pws,2,2)||pwc="32003" then inpowsample = 1;
if substr(pws,2,2)||pwc="33011" then inpowsample = 1;
if substr(pws,2,2)||pwc="34007" then inpowsample = 1;
if substr(pws,2,2)||pwc="34011" then inpowsample = 1;
if substr(pws,2,2)||pwc="34013" then inpowsample = 1;
if substr(pws,2,2)||pwc="34017" then inpowsample = 1;
if substr(pws,2,2)||pwc="34039" then inpowsample = 1;
if substr(pws,2,2)||pwc="35001" then inpowsample = 1;
if substr(pws,2,2)||pwc="35013" then inpowsample = 1;
if substr(pws,2,2)||pwc="36005" then inpowsample = 1;
if substr(pws,2,2)||pwc="36029" then inpowsample = 1;
if substr(pws,2,2)||pwc="36055" then inpowsample = 1;
if substr(pws,2,2)||pwc="36061" then inpowsample = 1;
if substr(pws,2,2)||pwc="36063" then inpowsample = 1;
if substr(pws,2,2)||pwc="36067" then inpowsample = 1;
if substr(pws,2,2)||pwc="36071" then inpowsample = 1;
if substr(pws,2,2)||pwc="36093" then inpowsample = 1;
if substr(pws,2,2)||pwc="36119" then inpowsample = 1;
if substr(pws,2,2)||pwc="37119" then inpowsample = 1;
if substr(pws,2,2)||pwc="39017" then inpowsample = 1;
if substr(pws,2,2)||pwc="39035" then inpowsample = 1;
if substr(pws,2,2)||pwc="39049" then inpowsample = 1;
if substr(pws,2,2)||pwc="39061" then inpowsample = 1;
if substr(pws,2,2)||pwc="39081" then inpowsample = 1;
if substr(pws,2,2)||pwc="39087" then inpowsample = 1;
if substr(pws,2,2)||pwc="39099" then inpowsample = 1;
if substr(pws,2,2)||pwc="39153" then inpowsample = 1;
if substr(pws,2,2)||pwc="40109" then inpowsample = 1;
if substr(pws,2,2)||pwc="41051" then inpowsample = 1;
if substr(pws,2,2)||pwc="42003" then inpowsample = 1;
if substr(pws,2,2)||pwc="42043" then inpowsample = 1;
if substr(pws,2,2)||pwc="42045" then inpowsample = 1;
if substr(pws,2,2)||pwc="42101" then inpowsample = 1;
if substr(pws,2,2)||pwc="44007" then inpowsample = 1;
if substr(pws,2,2)||pwc="45019" then inpowsample = 1;
if substr(pws,2,2)||pwc="45053" then inpowsample = 1;
if substr(pws,2,2)||pwc="45079" then inpowsample = 1;
if substr(pws,2,2)||pwc="45085" then inpowsample = 1;
if substr(pws,2,2)||pwc="47037" then inpowsample = 1;
if substr(pws,2,2)||pwc="47065" then inpowsample = 1;
if substr(pws,2,2)||pwc="47093" then inpowsample = 1;
if substr(pws,2,2)||pwc="47157" then inpowsample = 1;
if substr(pws,2,2)||pwc="48029" then inpowsample = 1;
if substr(pws,2,2)||pwc="48113" then inpowsample = 1;
if substr(pws,2,2)||pwc="48141" then inpowsample = 1;
if substr(pws,2,2)||pwc="48201" then inpowsample = 1;
if substr(pws,2,2)||pwc="48245" then inpowsample = 1;
if substr(pws,2,2)||pwc="48309" then inpowsample = 1;
if substr(pws,2,2)||pwc="48355" then inpowsample = 1;
if substr(pws,2,2)||pwc="48361" then inpowsample = 1;
if substr(pws,2,2)||pwc="48439" then inpowsample = 1;
if substr(pws,2,2)||pwc="48453" then inpowsample = 1;
if substr(pws,2,2)||pwc="49057" then inpowsample = 1;
if substr(pws,2,2)||pwc="51710" then inpowsample = 1;
if substr(pws,2,2)||pwc="51740" then inpowsample = 1;
if substr(pws,2,2)||pwc="51760" then inpowsample = 1;
if substr(pws,2,2)||pwc="53033" then inpowsample = 1;
if substr(pws,2,2)||pwc="53053" then inpowsample = 1;
if substr(pws,2,2)||pwc="53077" then inpowsample = 1;
if substr(pws,2,2)||pwc="54009" then inpowsample = 1;
if substr(pws,2,2)||pwc="54011" then inpowsample = 1;
if substr(pws,2,2)||pwc="54039" then inpowsample = 1;
if substr(pws,2,2)||pwc="55079" then inpowsample = 1;

**** Create a uniformly distributed random number to use when selecting a 5% sample of non-sample-county residents;
randomdraw=ranuni(12345);

in5pctoutside=0;
if (randomdraw<.05) and (insample=0) then in5pctoutside=1;
if (insample=1) or (inpowsample=1) or (in5pctoutside=1);

run;

%end;



data work.allstates;
set
%do st = 1 %to 51;
&&state&st
%end;
;
run;


%do st = 1 %to 43;
data work.export;
set work.allstates;
if insample=1 & stf="&&statenum&st";
run;
%savastata("/rdcprojects/mc1/mc00535/data/decennial/01-Raw_Extracts/dec1990extract&&statenum&st...dta", -replace);

data work.export;
set work.allstates;
if inpowsample=1 & substr(pws,2,2)="&&statenum&st";
run;
%savastata("/rdcprojects/mc1/mc00535/data/decennial/01-Raw_Extracts/powdec1990extract&&statenum&st...dta", -replace);
%end;


data work.export;
set work.allstates;
if in5pctoutside=1;
run;
%savastata("/rdcprojects/mc1/mc00535/data/decennial/01-Raw_Extracts/dec1990extract_5pctnonsample.dta", -replace);


proc datasets library = work;
%do st = 1 %to 51;
&&state&st
%end;
allstates export;
run;


%mend;


%loops;



