clear
set more off
set mem 5000m

adopath ++ "/public/ado"

local statenum1 = "01"
local statenum2 = "02"
local statenum3 = "04"
local statenum4 = "05"
local statenum5 = "06"
local statenum6 = "08"
local statenum7 = "09"
local statenum8 = "10"
local statenum9 = "11"
local statenum10 = "12"
local statenum11 = "13"
local statenum12 = "17"
local statenum13 = "18"
local statenum14 = "19"
local statenum15 = "20"
local statenum16 = "21"
local statenum17 = "22"
local statenum18 = "24"
local statenum19 = "25"
local statenum20 = "26"
local statenum21 = "27"
local statenum22 = "28"
local statenum23 = "29"
local statenum24 = "31"
local statenum25 = "32"
local statenum26 = "33"
local statenum27 = "34"
local statenum28 = "35"
local statenum29 = "36"
local statenum30 = "37"
local statenum31 = "39"
local statenum32 = "40"
local statenum33 = "41"
local statenum34 = "42"
local statenum35 = "44"
local statenum36 = "45"
local statenum37 = "47"
local statenum38 = "48"
local statenum39 = "49"
local statenum40 = "51"
local statenum41 = "53"
local statenum42 = "54"
local statenum43 = "55"


local cendatadir = "/rdcprojects/mc1/mc00535/data/decennial/01-Raw_Extracts/"
local outdata = "/rdcprojects/mc1/mc00535/data/decennial/02-Recoded_State_Files/dec1990recoded"
local powoutdata = "/rdcprojects/mc1/mc00535/data/decennial/02-Recoded_State_Files/powdec1990recoded"



use "/rdcprojects/mc1/mc00535/data/ezdata/blocklevel_admdata.dta"
keep if keep_1990geography==1
ren tract1990 tractid90
collapse progid_cons progid_power progname program1995 program1999 program2001 application_tract assigned_tract black_city_1970 black_city_1980 black_city_1990 black_city_2000 crime_total_city_1970 crime_total_city_1980 crime_total_city_1990 crime_total_city_2000 manufacture_city_1970 manufacture_city_1980 manufacture_city_1990 manufacture_city_2000 pctgov_city_1970 pctgov_city_1980 pctgov_city_1990 pctgov_city_2000 population_city_1970 population_city_1980 population_city_1990 population_city_2000, by(tractid90 city)
tempfile admin
save `admin'
clear

use "/rdcprojects/mc1/mc00535/data/ezdata/blocklevel_admdata.dta"
keep if keep_1990geography==1
ren tract1990 tractid90
collapse progid_cons progid_power progname program1995 program1999 program2001 application_tract assigned_tract black_city_1970 black_city_1980 black_city_1990 black_city_2000 crime_total_city_1970 crime_total_city_1980 crime_total_city_1990 crime_total_city_2000 manufacture_city_1970 manufacture_city_1980 manufacture_city_1990 manufacture_city_2000 pctgov_city_1970 pctgov_city_1980 pctgov_city_1990 pctgov_city_2000 population_city_1970 population_city_1980 population_city_1990 population_city_2000, by(tractid90 city)

foreach var in tractid90 progid_cons progid_power progname program1995 program1999 program2001 application_tract assigned_tract city black_city_1970 black_city_1980 black_city_1990 black_city_2000 crime_total_city_1970 crime_total_city_1980 crime_total_city_1990 crime_total_city_2000 manufacture_city_1970 manufacture_city_1980 manufacture_city_1990 manufacture_city_2000 pctgov_city_1970 pctgov_city_1980 pctgov_city_1990 pctgov_city_2000 population_city_1970 population_city_1980 population_city_1990 population_city_2000 {
ren `var' pow`var'
}
tempfile powadmin
save `powadmin'
clear

forval type = 0/2 {
forval ii = 1/43 {
if `type'<2 | `ii'==1 {

if `type'==0 {
use "`cendatadir'/dec1990extract`statenum`ii''.dta"
}
if `type'==1 {
use "`cendatadir'/powdec1990extract`statenum`ii''.dta"
}
if `type'==2 {
use "`cendatadir'/dec1990extract_5pctnonsample.dta"
}

gen double pid = _n+(`ii'/100)

***keep if uniform()<.02

**** Create a variable to use as a visual divider in the variable list
gen __________ = .

**** Rename and label variables that will not be recoded
*ren age age
label define agelab 115 "115 and above"
label values age agelab

drop gid
ren gidp gid

ren hwt hwgt

ren hhid hid

ren pwt pwgt

label variable noc "Number of Children (own and adopted)"

************ Create a numeric vacancy status variable
gen vacancy = real(vs)
label define vacancy_lab 0 "NA (Occupied housing unit or seasonal, migratory or GQ)" 1 "For rent" 2 "For sale only" 3 "Rented or sold, not occupied" 4 "Held for occasional usa" 5 "Migratory Workers" 6 "Other vacant"
label values vacancy vacancy_lab
label variable vacancy "Vacancy Status"
drop vs

**** Create a householder flag
gen householder=rel=="00"
label variable householder "=1 if person is householder"
drop rel

**** Create a numeric variable for year moved in category
gen ymi90 = real(ymi)
label define ymi90_lab 0 "NA (GQ or vacant)" 1 "1989 or 1990" 2 "1985 to 1988" 3 "1980 to 1984" 4 "1970 to 1979" 5 "1960 to 1969" 6 "1959 or earlier"
label values ymi90 ymi90_lab
label variable ymi90 "Year Moved in (1990 categories)"
drop ymi

**** Create a female householder flag
gen female_head = inlist(hht,"3","6","7") if hht != "0"
label variable female_head "Female Householder"

**** Create a numeric race variable
gen race = .
replace race = 1 if inrange(real(rac),800,869)==1
replace race = 1 if real(rac)==971
replace race = 2 if inrange(real(rac),870,934)==1
replace race = 2 if real(rac)==972
replace race = 3 if inrange(real(rac),600,699)==1
replace race = 3 if inrange(real(rac),976,985)==1
replace race = 4 if inrange(real(rac),  1,599)==1
replace race = 4 if inrange(real(rac),935,970)==1
replace race = 4 if inrange(real(rac),973,975)==1
replace race = 5 if inrange(real(rac),700,748)==1
replace race = 6 if inrange(real(rac),748,799)==1
replace race = 6 if inrange(real(rac),986,999)==1
label define racelab 1 "white" 2 "black" 3 "asian/pi" 4 "nativ am." 5 "hispanic" 6 "other", modify
label values race racelab
label variable race "Race"
drop rac

**** Create a numeric flag for hispanic origin
gen hisp = 1-inlist(sor,"000","199") if sor!=""
label define hisp_lab 0 "non-hispanic" 1 "hispanic"
label values hisp hisp_lab
label variable hisp "Hispanic Origin Flag"
drop sor

compress

**** Create a numeric race/ethnicity variable
gen raceeth = 4
replace raceeth = 1 if race==1 & hisp!=1
replace raceeth = 2 if race==2
replace raceeth = 3 if race==3
label define raceeth_lab 1 "white, non-hispanic" 2 "black" 3 "asian/pi" 4 "other"
label values raceeth raceeth_lab
label variable raceeth "Race/Ethnicity"
drop race

**** Create a numeric education category variable 
**** Code 1990 categories to finest common coarsening of 1990 and 2000 categories
label define educcat_lab 0 "not in universe, age<3" 1 "no schooling completed" 2 "nursery school to 4th grade" 3 "5th grade to 8th grade" 4 "9th grade" 5 "10th grade" 6 "11th grade" 7 "12th grade, no diploma" 8 "high school graduate" 9 "some college" 10 "bachelor's degree+" 11 "above bachelor's degree"
gen educcat = .
replace educcat = 0 if real(hdeg)==0
replace educcat = 1 if real(hdeg)==1
replace educcat = 2 if real(hdeg)==2
replace educcat = 2 if real(hdeg)==3
replace educcat = 2 if real(hdeg)==4
replace educcat = 3 if real(hdeg)==5
replace educcat = 4 if real(hdeg)==6
replace educcat = 5 if real(hdeg)==7
replace educcat = 6 if real(hdeg)==8
replace educcat = 7 if real(hdeg)==9
replace educcat = 8 if real(hdeg)==10
replace educcat = 9 if real(hdeg)==11
replace educcat = 9 if real(hdeg)==12
replace educcat = 9 if real(hdeg)==13
replace educcat = 10 if real(hdeg)==14
replace educcat = 11 if real(hdeg)==15
replace educcat = 11 if real(hdeg)==16
replace educcat = 11 if real(hdeg)==17

label variable educcat "Educational Attainment"
label values educcat educcat_lab
drop hdeg

**** Create a numeric "currently in school" identifier
gen inschool = real(sch)
label define inschool_lab 0 "age<3" 1 "no" 2 "yes, public school or college" 3 "yes, private school or college"
label values inschool inschool_lab
label variable inschool "Currently Attending School?"
drop sch

**** Create a numeric weekly rent variable
gen rentcat = real(rnt)
replace rentcat = 0 if rentcat == 27
label define rentcat_lab 0 "NA/no cash rent" 1 "less than $80" 2 "$80 to $99" 3 "$100 to $124" 4 "$125 to $149" 5 "$150 to $174" 6 "$175 to $199" 7 "$200 to $224" 8 "$225 to $249" 9 "$250 to $274" 10 "$275 to $299" 11 "$300 to $324" 12 "$325 to $349" 13 "$350 to $374" 14 "$375 to $399" 15 "$400 to $424" 16 "$425 to $449" 17 "$450 to $474" 18 "$475 to $499" 19 "$500 to $524" 20 "$525 to $549" 21 "$550 to $599" 22 "$600 to $649" 23 "$650 to $699" 24 "$700 to $749" 25 "$750 to $999" 26 "$1000 or more"
label values rentcat rentcat_lab
label variable rentcat "Rent Category"
drop rnt

compress

**** Create a numeric tenure variable
gen tenure = real(ten)
replace tenure = . if tenure==0
label define tenure_lab 0 "NA (GQ or Vacant)" 1 "owned - with mortgage" 2 "owned - free and clear" 3 "rented for cash rent" 4 "no cash rent"
label values tenure tenure_lab
label variable tenure "Tenure"
drop ten

**** Create a numeric variable describing the number of bedrooms
gen bedrooms = real(brm)
label define bedroomslab 0 "NA (GQ)" 1 "No bedrooms" 2 "1 bedroom" 3 "2 bedrooms" 4 "3 bedrooms" 5 "4 bedrooms" 6 "5 or more bedrooms"
label values bedrooms bedroomslab
label variable bedrooms "Bedrooms"
drop brm

**** Create a numeric variable describing the presence of plumbing facilities
gen plumbing = real(pfac)
label define plumbinglab 0 "NA (GQ)" 1 "Yes, for this household only" 2 "Yes, but shared with another household" 3 "No, some but not all plumbing facilties" 4 "No plumbing facilities in household"
label values plumbing plumbinglab
label variable plumbing "Plumbing"
drop pfac

**** Create a numeric variable describing the presence of kitchen facilities
gen kitchen = real(kit)
label define kitchenlab 0 "NA (GQ)" 1 "Yes" 2 "No"
label values kitchen kitchenlab
label variable kitchen "Kitchen"
drop kit

**** Create a numeric variable describing the number of rooms
gen rooms = real(rm)
replace rooms = . if rooms==0
label define rooms_lab 0 "NA" 1 "1 room" 2 "2 rooms" 3 "3 rooms" 4 "4 rooms" 5 "5 rooms" 6 "6 rooms" 7 "7 rooms" 8 "8 rooms" 9 "9 or more rooms"
label values rooms rooms_lab
label variable rooms "Rooms"
drop rm

compress

**** Create a numerical variable describing when housing unit was built
gen buildingage = real(ysb)
label define buildingage_lab 0 "NA (GQ)" 1 "0-1" 2 "2-5" 3 "6-10" 4 "11-20" 5 "21-30" 6 "31-40" 7 "41-50" 8 "51+"
label values buildingage buildingage_lab
label variable buildingage "Age of Structure"
drop ysb

**** Create a numerical variable describing the value of the housing unit
gen value=.
replace value = 1 if real(val) == 1
replace value = 2 if real(val) == 2
replace value = 3 if real(val) == 3
replace value = 4 if real(val) == 4
replace value = 5 if real(val) == 5
replace value = 6 if real(val) == 6
replace value = 7 if real(val) == 7
replace value = 8 if real(val) == 8
replace value = 8 if real(val) == 9
replace value = 9 if real(val) == 10
replace value = 9 if real(val) == 11
replace value = 10 if real(val) == 12
replace value = 10 if real(val) == 13
replace value = 11 if real(val) == 14
replace value = 11 if real(val) == 15
replace value = 12 if real(val) == 16
replace value = 13 if real(val) == 17
replace value = 14 if real(val) == 18
replace value = 15 if real(val) == 19
replace value = 16 if real(val) == 20
replace value = 17 if real(val) == 21
replace value = 18 if real(val) == 22
replace value = 19 if real(val) == 23
replace value = 20 if real(val) == 24
replace value = 21 if real(val) == 25
replace value = 22 if real(val) == 26

label define value_lab 01 "less than $10,000" 02 "$10,000 to $14,999" 03 "$15,000 to $19,999" 04 "$20,000 to $24,999" 05 "$25,000 to $29,999" 06 "$30,000 to $34,999" 07 "$35,000 to $39,999" 08 "$40,000 to $49,999" 09 "$50,000 to $59,999" 10 "$60,000 to $69,999" 11 "$70,000 to $79,999" 12 "$80,000 to $89,999" 13 "$90,000 to $99,999" 14 "$100,000 to $124,999" 15 "$125,000 to $149,999" 16 "$150,000 to $174,999" 17 "$175,000 to $199,999" 18 "$200,000 to $249,999" 19 "$250,000 to $299,999" 20 "$300,000 to $399,999" 21 "$400,000 to $499,999" 22 "$500,000 or more"
label values value value_lab
label variable value "Value of Current Residence"
drop val

**** Create a numeric employment status recode variable
ren esr esrc
gen esr = real(esrc)
label define esrlab 0 "NA (Under 16 years old)" 1 "In civilian labor force, employed, at work" 2 "employed, but not at work" 3 "unemployed" 4 "In armed forces, at work" 5 "In armed forces, not at work" 6 "Not in labor force"
label values esr esrlab
label variable esr "Employment Status Recode"
drop esrc

**** Create a numeric weekly hours worked variable
gen wklyrwk = real(ww)
label define wklyrwk_lab 0 "NA/No work"
label values wklyrwk wklyrwk_lab
label variable wklyrwk "Weeks worked last year"
drop ww

compress

**** Create a numeric weekly hours worked variable
gen wklyrhr = real(uhw)
label define wklyrhr_lab 99 "99 or more hours"
label values wklyrhr wklyrhr_lab
label variable wklyrhr "Usual Hours Worked Per Week"
drop uhw

**** Create a numeric sex variable
ren sex qsex
gen sex = real(qsex)+1
label define sexlab 1 "male" 2 "female"
label values sex sexlab
label var sex "Sex"
drop qsex

**** Create a numeric citizenship identifier
gen citizen = real(cit)+1
label define citizen_lab 1 "Yes, born in the United States" 2 "US citizen, born in US territory" 3 "US citizen, born abroad to Am. parents" 4 "US citizen, naturalized" 5 "not a US citizen"
label values citizen citizen_lab
label variable citizen "Citizenship Status"
drop cit

**** Create a numeric marital staus variable
gen marstatus  = real(ms)
label define marstatus_lab 1 "married" 2 "widowed" 3 "divorced" 4 "separated" 5 "never married"
label variable marstatus "Marital Status"
label values marstatus marstatus_lab
drop ms

**** Create a numerical commute time variable and an indicator for instances
**** when the variable is censored
gen commutetime=real(ttw)
label define commutetime_lab 99 "99 minutes or more"
label values commutetime commutetime_lab
label variable commutetime "Travel Time to Work (Minutes)"
drop ttw

gen commutetime_cen = commutetime==99
label variable commutetime_cen "Censored Commute Time Identifier"

**** Consolidate geographic variables
gen county90 = stf+cou
gen tractid90 = substr(blockid90,1,11)
label variable county90 "1990 FIPS state+county"
label variable tractid90 "1990 stf+cou+trct"
label variable blockid90 "1990 stf+cou+trct+blk"
drop stf cou trct blk

**** Create a numeric indicator of working the previous week
gen wklwk = real(wlw)
replace wklwk = 0 if wklwk == .
label define wklwk_lab 0 "NA/not in univers" 1 "worked" 2 "did not work"
label values wklwk wklwk_lab
label variable wklwk "Any Work Last Week?"
drop wlw

compress

**** Create a numerical variable describing method of commute to work
gen howcommute = real(mtw)
label define howcommute_lab 0 "Not in universe" 1 "car, truck, or van" 2 "bus or trolley bus" 3 "streetcar or trolley car" 4 "subway or elevated" 5 "railroad" 6 "ferryboat" 7 "taxicab" 8 "motorcycle" 9 "bicycle" 10 "walked" 11 "worked at home" 12 "other method"
label values howcommute howcommute_lab
label variable howcommute "Means of Transportation to Work"
drop mtw

**** Create a single place of work county variable
gen powcounty90 = substr(pws,2,2)+pwc
replace powcounty90 = "" if powcounty90=="00000"
label variable powcounty90 "Place of Work 1990 state+county"

gen powtractid90 = substr(pws,2,2)+pwc+pwct
replace powtractid90 = "" if powtractid90=="00000000000"
label variable powtractid90 "Place of Work 1990 state+county+tract"

gen pwbs_c=" "
replace pwbs_c=" " if pwbs=="00"
replace pwbs_c="A" if pwbs=="01"
replace pwbs_c="B" if pwbs=="02"
replace pwbs_c="C" if pwbs=="03"
replace pwbs_c="D" if pwbs=="04"
replace pwbs_c="E" if pwbs=="05"
replace pwbs_c="F" if pwbs=="06"
replace pwbs_c="G" if pwbs=="07"
replace pwbs_c="H" if pwbs=="08"
replace pwbs_c="I" if pwbs=="09"
replace pwbs_c="J" if pwbs=="10"
replace pwbs_c="K" if pwbs=="11"
replace pwbs_c="L" if pwbs=="12"
replace pwbs_c="M" if pwbs=="13"
replace pwbs_c="N" if pwbs=="14"
replace pwbs_c="O" if pwbs=="15"
replace pwbs_c="P" if pwbs=="16"
replace pwbs_c="Q" if pwbs=="17"
replace pwbs_c="R" if pwbs=="18"
replace pwbs_c="S" if pwbs=="19"
replace pwbs_c="T" if pwbs=="20"
replace pwbs_c="U" if pwbs=="21"
replace pwbs_c="V" if pwbs=="22"
replace pwbs_c="W" if pwbs=="23"
replace pwbs_c="X" if pwbs=="24"
replace pwbs_c="Y" if pwbs=="25"
replace pwbs_c="Z" if pwbs=="26"

gen powblockid90 = substr(pws,2,2)+pwc+pwct+pwb+pwbs_c
replace powblockid90 = "" if substr(powblockid90,1,11)=="00000000000"
label variable powblockid90 "Place of Work 1990 state+county+tract+block"
drop pws pwc pwct pwb pwbs pwbs_c

**** Drop individuals from POW file if POW tract is missing
****   (These individuals are on the raw extract because POW state is nonmissing)
drop if `type'==1 & powblockid90==""

**** flag individuals with censored income vars
label define pinc_cen_lab 0 "no censored income vars" 1 "top-coded income var(s)" 2 "bottom-coded income var(s)" 3 "top- and bottom-coded income vars"

gen pinc_cen = 0
replace pinc_cen = 1 if pinc==2999997
replace pinc_cen = 2 if pinc==-19998
label values pinc_cen pinc_cen_lab
label variable pinc_cen "Censored Income Identifier"

label variable pinc "Persons Total Income"

label variable incw "Wage/Salary Income"

label variable incp "Public Assistance Income"

**** Identify censored earnings values
label define pern_cen_lab 0 "not censored" 1 "top-coded earnings" 2 "bottom-coded earnings"

gen pern_cen = 0
replace pern_cen = 1 if pern==2999997
replace pern_cen = 2 if pern==-19998
label values pern_cen pern_cen_lab
label variable pern_cen "Censored Earnings Identifier"

**** Create a numeric poverty status variable
gen pov = real(povs)
label variable pov "Poverty Status"
label define pov_lab 0 "not applicable" 501 "500% or more"
label values pov pov_lab
drop povs

**** Create a numeric migration variable
gen mig = real(mobs)
drop mobs
label variable mig "Mobility Status"
label define miglabel 0 "under 5 years old" 1 "same house" 2 "not same house"
label values mig miglabel

compress

**** Create a migration county variable for those who lived at a
**** different US house 5 years previous
gen migcounty = substr(migs,2,2)+migc if real(migs)<=56
label variable migcounty "US County of Previous Residence for US Movers"

**** Create a migration country variable for those who lived in a
**** different country 5 years previous
gen migcountry = migs if real(migs)>56
label variable migcountry "Country of Previous Residence for non-US Movers"
drop migs migc

**** Recode allocation flags
gen agef =  real(agea)
label variable agef "Allocation Flag - age"

gen raceethf1 = real(raca)
label variable raceethf1 "Allocation Flag - race component of raceeth"

gen raceethf2 = real(sora)
label variable raceethf2 "Allocation Flag - hisp component of raceeth"

gen sexf = real(sexa)
label variable sexf "Allocation Flag - sex"

gen citizenf = real(cita)
label variable citizenf "Allocation Flag - citizen"

gen educcatf = real(hdega)
label variable educcatf "Allocation Flag - educcat"
compress

gen inschoolf = real(scha)
label variable inschoolf "Allocation Flag - inschool"

gen marstatusf  = real(msa)
label variable marstatusf "Allocation Flag - marstatus"

gen wklyrhrf = real(uhwa)
label variable wklyrhrf "Allocation Flag - wklyrhr"

gen wklyrwkf = real(wwa)
label variable wklyrwkf "Allocation Flag - wklyrwk"

gen indf = real(inda)
label variable indf "Allocation Flag - ind"

gen occf = real(occa)
label variable occf "Allocation Flag - occ"

gen commutetimef = real(ttwa)
label variable commutetimef "Allocation Flag - commutetime"

gen howcommutef = real(mtwa)
label variable howcommutef "Allocation Flag - howcommute"
compress

gen pow90f1 = real(pwsa)
label variable pow90f1 "Allocation Flag - pow state"

gen pow90f2 = real(pwca)
label variable pow90f2 "Allocation Flag - cold deck - pow state"

gen pow90f3 = real(pwsca)
label variable pow90f3 "Allocation Flag - pow county"

gen pow90f4 = real(pwcca)
label variable pow90f4 "Allocation Flag - cold deck - pow county"

gen pow90f5 = real(pwcta)
label variable pow90f5 "Allocation Flag - pow tract"

gen migf1 = real(migsa)
label variable migf1 "Allocation Flag - mig"

gen migf2 = real(migca)
label variable migf2 "Allocation Flag - cold deck - mig"

gen migf3 = real(mobsa)
label variable migf3 "Allocation Flag - migcounty90"
compress

gen incwf = real(incwa)
label variable incwf "Allocation Flag - incw"

gen incpf = real(incpa)
label variable incpf "Allocation Flag - incp"

gen pobf = real(poba)
label variable pobf "Allocation Flag - pob"

gen tenuref = real(tena)
label variable tenuref "Allocation Flag - tenure"

gen buildingagef = real(ysba)
label variable buildingagef "Allocation Flag - buildingage"

gen roomsf = real(rma)
label variable roomsf "Allocation Flag - rooms"

gen rentf = real(rnta)
label variable rentf "Allocation Flag - rent"

gen valuef = real(vala)
label variable valuef "Allocation Flag - value"

gen plumbingf = real(pfaca)
label variable plumbingf "Allocation Flag - plumbing"

gen kitchenf = real(kita)
label variable kitchenf "Allocation Flag - kitchen"

gen bedroomsf = real(brma)
label variable bedroomsf "Allocation Flag - bedrooms"

gen esrf = real(esra)
label variable esrf "Allocation Flag - esr"

gen vacancyf = real(vsa)
label variable vacancyf "Allocation Flag - vacancy"

gen ymif = real(ymia)
label variable ymif "Allocation Flag - ymiYY"

drop sexa agea msa raca sora poba cita scha hdega ancpa ancsa mobsa migsa migca lotea wlwha pwsa pwca pwcta pwsca pwcca mtwa ttwa inda occa uhwa rma tena vala rnta ysba kita pfaca brm wwa incwa incpa esra vsa ymia

compress

memory

**** Reorder the variables
order pid gid hid sfn pwgt hwgt county90 blockid90 age raceeth hisp sex citizen educcat inschool marstatus esr wklwk wklyrhr wklyrwk ind occ commutetime commutetime_cen howcommute powcounty90 powtractid90 powblockid90 pinc pinc_cen incw incp pern pern_cen hinc finc pov mig migcounty ymi90 migcountry pob gqt gqi tenure noc buildingage rooms bedrooms plumbing kitchen rentcat vacancy value __________ agef raceethf1 raceethf2 sexf citizenf educcatf inschoolf marstatusf esrf wklyrhrf wklyrwkf indf occf commutetimef howcommutef pow90f1 pow90f2 pow90f3 pow90f4 pow90f5 incwf incpf migf1 migf2 migf3 pobf tenuref buildingagef roomsf bedroomsf plumbingf kitchenf rentf vacancyf ymif valuef
**su gid-__________

compress

**** Merge on admin data by 1990 tract
joinby tractid90 using `admin', unmatched(master)
tab _merge
drop _merge

joinby powtractid90 using `powadmin', unmatched(master)
tab _merge
drop _merge

**** Create pwgt2 and hwgt2 variables.  In 1980 and 1990 these varaibles are appropriately adjusted versions of the
****   person and housing sampling weights, accounting for imperfect geographic mappings to 1990 geographies.  In 1990
****   there is no uncertainty in that mapping, so the "adjusted" weights are the same as the unadjusted weights.
gen pwgt2 = pwgt
label variable pwgt2 "Person weight / (merge blockidcount from admin file)"

gen hwgt2 = hwgt
label variable hwgt2 "Household weight / (merge blockidcount from admin file)"

**** Create variables defining the sample 
gen sample_winlose = assigned_tract!=.
gen sample_winlose_pow = powassigned_tract!=.
gen sample_placebo = inlist(county90,"06037","13121","17031","24510","26163","36047")==1 | inlist(county90,"34007","36005","36061","39035","42101","36081")==1
gen sample_placebo_pow = inlist(powcounty90,"06037","13121","17031","24510","26163","36047")==1 | inlist(powcounty90,"34007","36005","36061","39035","42101","36081")==1

compress
if `type'==0 {
save `outdata'`statenum`ii'', replace
}
if `type'==1 {
save `powoutdata'`statenum`ii'', replace
}
if `type'==2 {
save `outdata'_5pctnonsample, replace
}

clear

}
}
}
