***DESCRIPTION
*This program combines MU-SSL,SU-SSL and LBD files for the years 1987-2001.Keeps the selected variables and counties in the list. Creates a newtract varible based on the information on SSEL;







 ******************************************YEAR:1987 ************************************************;
 *MACROS;
%let yr=1987;
libname BR '/economic/ssl/microdata/'; 
data ssl&yr.su;
set BR.ssl&yr.su;
run;

************************************************************;
************************************************************;
*(1) Single-Unit File;
************************************************************;
************************************************************;
%let yr=1987;
data ssl&yr.su(keep=  employment employmentsu payrollsu srecnum   pst salereceiptsu newtract 
newtractsu actsu cfnsu lfosu sicsu zipsu  ctygeosu indsu indsubsu lfo1su npisu pdivsu plcesu plgeosu ppnsu
sic56su stgeosu streetsu tocsu acfsu einsu 
AC943E AC943P acap ACEMP ACEMPF ACF ACSR1 ACSR1F ACSR2 ACSR2F ACSR3
ACSR4 ACT ANNPR CFN CTYGEO EIN EMPCD IND INDSUB
LFO LFO1   NPI PDIV PLCE PLGEO PPLCE PPN PSTREET PZIP
RECNUM SIC SIC56 SSABR
SSACL	SSAEMP	STGEO	STREET	TOC ZIP ); 	
 set BR.ssl&yr.su;
Employment=ACEMP;
Employmentsu=ACEMP;
**************Exclude submasters;
if PDIV^='M';
*Exclude inactive units;
acap = (ACQP1+ACQP2+ACQP3+ACQP4)/1000;
if acap>0| AC943P>0;

payrollsu =acap ;
 srecnum=recnum;
salereceiptsu=acsr1;
**************Creating new tract variable;
newtract=' ';   *tract variable does not exists for year <1992;
*Identify the source of the common variables;
newtractsu=newtract;
actsu=act; cfnsu=cfn; lfosu=lfo ; sicsu=sic ;zipsu=zip;  
 ctygeosu=ctygeo; indsu=ind; indsubsu=indsub; lfo1su=lfo1;
 npisu=npi; pdivsu=pdiv; plcesu=plce; plgeosu=plgeo; ppnsu=ppn;
sic56su=sic56; stgeosu=stgeo; streetsu=street; tocsu=toc;  acfsu=acf;
einsu=ein;
 run;


*******
%let yr=1987;
libname BR '/economic/ssl/microdata/';
data ssl&yr.mu;
set BR.ssl&yr.mu;
run;


 *(2) Multi-Unit File;
************************************************************;
************************************************************;
%let yr=1987;
data ssl&yr.mu(keep=employment employmentmu payrollmu mrecnum  newtract  salereceiptmu 
 newtractmu actmu cfnmu lfomu sicmu zipmu  ctygeomu indmu indsubmu lfo1mu npimu 
pdivmu plcemu plgeomu ppnmu
sic56mu stgeomu streetmu tocmu  acfmu einmu 
ACF	 ACT	
CFN	CTYGEO	CYTE	EIN	GAT	IND	INDSUB	LFO	LFO1	NPI	PDIV	
PLCE	PLGEO	PPN	RAP	RAPF	RECNUM	REMP	REMPF	RSR	RSRF	
SIC	SIC56	STGEO	STREET	TOC	ZIP);	
set br.ssl&yr.mu;

**************Creating new tract variable;
NEWTRACT=' ';   *tract variable does not exists for years <1992;
**************Exclude ghosts;
if ACT^='G';
**************Exclude inactive units;
if rap>0| (rap=0 & (RAPF^='Z' & ACT^='D'));

EMPLOYMENT=REMP;
EMPLOYMENTmu=REMP;
PAYROLLmu=RAP;
salereceiptmu=RSR;	
mrecnum=recnum;
*Identify the source of the common variables;
newtractmu=newtract;
actmu=act; cfnmu=cfn; lfomu=lfo ; sicmu=sic ;zipmu=zip;  ctygeomu=ctygeo; indmu=ind; indsubmu=indsub; lfo1mu=lfo1;
 npimu=npi; pdivmu=pdiv; plcemu=plce; plgeomu=plgeo; ppnmu=ppn;
sic56mu=sic56; stgeomu=stgeo; streetmu=street; tocmu=toc;  acfmu=acf;
einmu=ein;
run;
************************************************************;
************************************************************ ;



*LBD File;
************************************************************;
************************************************************;
%let yr=1987;
libname lbd '/economic/lbd/microdata';
data lbd&yr.c;
set lbd.lbd&yr.c;
*Drop missing recnum and MU observations;
recnumx=put(recnum,8.);
MUx=put(MU,1.);
if recnumx^=' '; 
if MUx^=' ';
*Exclude submasters in LBD coming from SU file;
if MU=0 & PDIV='M' then delete;

/*
*Exclude inactive units;
if PAY>0;
*/

*Exclude ghosts in LBD coming from MU file;
if ACT='G' & MU=1 then delete;
run;

**************Creating srecnum mrecnum variables in lbd file and keeping the selected variables;
%let yr=1987;
data work.lbd&yr.c_rec(keep= mrecnum srecnum  payrolllbd employmentlbd
actlbd cfnlbd lfolbd siclbd ziplbd 
ACT	BESTNAICs	BESTSIC	CFN	COUNTY	EMP	FIRMID	FIRSTYEAr	
FLAGA	FLAGB	
LASTYEAR LBDNUM	LFO	MU	PAY	RECNUM	SIC STATE YR ZIP);
set work.lbd&yr.c;

if MU=1 then MRECNUM=RECNUM;
if MU=0 then SRECNUM=RECNUM;

payrolllbd=pay;	
employmentlbd=emp;
actlbd=act;
 cfnlbd=cfn;
 lfolbd=lfo;
 siclbd=sic ;
ziplbd=zip; 
run;

**************Checking mu  in LBD;
%let yr=1987;
proc means data=lbd&yr.c_rec;
var mu;
where mu=1;
run;

%let yr=1987;
proc means data=lbd&yr.c_rec;
var mu;
where mu=0;
run;


**************Checking mrecnum and srecnum variables in SU-SSL and MU-SSL ;
%let yr=1987;
Proc means data=ssl&yr.mu;
var mrecnum;
run;
%let yr=1987;
Proc means data=ssl&yr.su;
var srecnum;
run;

************************************************************;
************************************************************;
*Merging SSL and LBD;
************************************************************;
************************************************************;
*************1)Combine SU SSL and LBD by srecnum;
%let yr=1987;
proc sort data=work.lbd&yr.c_rec out=lbd87_s;
by SRECNUM;
run;

proc sort data=work.ssl&yr.su out=sussl87nt;
by SRECNUM;
run;

data work.su_ssllbd1987;
merge lbd87_s(in=one) sussl87nt(in=two);
fromlbd87_s=one;
fromsussl87nt=two;
by SRECNUM;
run;

data work.su_ssllbd1987;
set work.su_ssllbd1987;
recnumx=put(recnum,8.);
MUx=put(MU,1.);
srecnumx=put(srecnum,8.);
if recnumx^=' '; 
if MUx^=' ';
if srecnumx^=' ';
RUN;

*************2)Combine MU SSL and LBD by Mrecnum;
%let yr=1987;
proc sort data=work.lbd&yr.c_rec out=lbd87_M;
by MRECNUM;
run;

proc sort data=work.ssl&yr.mu out=mussl87nt;
by MRECNUM;
run;

data work.mu_ssllbd1987;
merge lbd87_M(in=one) mussl87nt(in=two);
fromlbd87_m=one;
frommussl87nt =two;
by MRECNUM;
run;

data work.mu_ssllbd1987;
set work.mu_ssllbd1987;
recnumx=put(recnum,8.);
MUx=put(MU,1.);
mrecnumx=put(mrecnum,8.);
if recnumx^=' '; 
if MUx^=' ';
if mrecnumx^=' ';
RUN;


**************3-A)Combine SU-SSLLBD &MUSSL-LBD FILES;
%let yr=1987;
data ssllbd&yr.;
set work.su_ssllbd1987(in=a)
work.mu_ssllbd1987 (in=b);
if a then SU2=1;else SU2=0;
if b then MU2=1;else MU2=0;
year=&yr.;
run;


**Create a newfips variable;
%let yr=1987;
data ssllbd&yr;
length newfips $5;
set work.ssllbd&yr;
ctygeox=put(ctygeo,3.);
stgeox=put(stgeo,2.);
If ctygeox^=' ' & stgeox^=' ' then newfips=stgeox||ctygeox;
else newfips=" ";
run;


data ssllbd&yr;
set work.ssllbd&yr;
**Keeping the counties listed;
where newfips="01015"
or newfips="01073"
or newfips="01097"
or newfips="02090"
or newfips="04013"
or newfips="04019"
or newfips="05069"
or newfips="05119"
or newfips="06001"
or newfips="06019"
or newfips="06037"
or newfips="06059"
or newfips="06067"
or newfips="06073"
or newfips="06075"
or newfips="08001"
or newfips="08031"
or newfips="08123"
or newfips="09001"
or newfips="09003"
or newfips="09009"
or newfips="10003"
or newfips="11001"
or newfips="12011"
or newfips="12031"
or newfips="12057"
or newfips="12086"
or newfips="13051"
or newfips="13089"
or newfips="13095"
or newfips="13121"
or newfips="17031"
or newfips="17143"
or newfips="17163"
or newfips="17167"
or newfips="18089"
or newfips="18097"
or newfips="19153"
or newfips="19193"
or newfips="20209"
or newfips="21111"
or newfips="22017"
or newfips="22019"
or newfips="22051"
or newfips="22071"
or newfips="22073"
or newfips="24510"
or newfips="25009"
or newfips="25013"
or newfips="25017"
or newfips="25025"
or newfips="26021"
or newfips="26049"
or newfips="26121"
or newfips="26163"
or newfips="27053"
or newfips="27123"
or newfips="28049"
or newfips="29047"
or newfips="29095"
or newfips="29165"
or newfips="29189"
or newfips="29510"
or newfips="31055"
or newfips="32003"
or newfips="33011"
or newfips="34007"
or newfips="34011"
or newfips="34013"
or newfips="34017"
or newfips="34039"
or newfips="35001"
or newfips="35013"
or newfips="36005"
or newfips="36029"
or newfips="36047"
or newfips="36055"
or newfips="36061"
or newfips="36063"
or newfips="36067"
or newfips="36071"
or newfips="36081"
or newfips="36085"
or newfips="36093"
or newfips="36119"
or newfips="37119"
or newfips="39017"
or newfips="39035"
or newfips="39045"
or newfips="39049"
or newfips="39061"
or newfips="39081"
or newfips="39087"
or newfips="39099"
or newfips="39153"
or newfips="40017"
or newfips="40027"
or newfips="40109"
or newfips="41051"
or newfips="42003"
or newfips="42043"
or newfips="42045"
or newfips="42101"
or newfips="44007"
or newfips="45019"
or newfips="45079"
or newfips="45085"
or newfips="47037"
or newfips="47065"
or newfips="47093"
or newfips="47157"
or newfips="48029"
or newfips="48085"
or newfips="48113"
or newfips="48121"
or newfips="48141"
or newfips="48157"
or newfips="48201"
or newfips="48245"
or newfips="48309"
or newfips="48355"
or newfips="48361"
or newfips="48439"
or newfips="48453"
or newfips="48491"
or newfips="49057"
or newfips="51710"
or newfips="51740"
or newfips="51760"
or newfips="53033"
or newfips="53053"
or newfips="53077"
or newfips="54009"
or newfips="54011"
or newfips="54039"
or newfips="54099"
or newfips="55079"

or newfips="01117"
or newfips="04027"
or newfips="08005"
or newfips="08059"
or newfips="08035"
or newfips="11031"
or newfips="12025"
or newfips="13063"
or newfips="13135"
or newfips="13177"
or newfips="17005"
or newfips="17043"
or newfips="17097"
or newfips="18057"
or newfips="24005"
or newfips="26125"
or newfips="27003"
or newfips="27163"
or newfips="28121"
or newfips="31153"
or newfips="32009"
or newfips="35043"
or newfips="36105"
or newfips="36001"
or newfips="36079"
or newfips="37179"
or newfips="39085"
or newfips="39041"
or newfips="39025"
or newfips="39155"
or newfips="41005"
or newfips="44003"
or newfips="45063"
or newfips="47187"
or newfips="48251"
or newfips="48367"
or newfips="51810"
or newfips="51041"
or newfips="51087"
or newfips="55133";
run;

**************3-B)Eliminating EINs that appear in both the SU(not submaster)
and MU files,keeping MU information suggested by Miranda(2002);
%let yr=1987;
proc sort data=work.ssllbd&yr OUT=work.ssllbd&yr;by EIN;
proc means data=work.ssllbd&yr noprint;
by EIN;
output out=work.dups(drop=_TYPE_ _FREQ_)
n(EMPLOYMENT)=EIN_COUNT;
run;

data ssllbd&yr;
merge work.ssllbd&yr (in=a) work.dups(in=b);
by EIN;
*We are concerned about EINs that are in the SU(not submaster) and MU;
if EIN_COUNT>1 & SU2=1 & PDIV^='M' then delete;
run;

*save the merged ssllbd data;
data "/rdcprojects/mc00535/data/ssllbd/ssllbd&yr "(compress=yes);
set ssllbd&yr;
drop fromlbd87_s fromlbd87_m frommussl87nt fromsussl87nt  SU2 MU2 srecnum mrecnum EIN_COUNT srecnumx mrecnumx recnumx mux stgeox ctygeox;
run;

proc datasets lib=work;
delete
dups lbd1987c lbd1987c_rec lbd87_m lbd87_s
mussl87nt sussl87nt mu_ssllbd1987 su_ssllbd1987
ssl1987mu ssl1987su ssllbd1987;
run;




 ********************************YEAR:1988 ************************************************************;
 *MACROS;
%let yr=1988;
libname BR '/economic/ssl/microdata/'; 
data ssl&yr.su;
set BR.ssl&yr.su;
run;

************************************************************;
************************************************************;
*(1) Single-Unit File;
************************************************************;
************************************************************;
%let yr=1988;
data ssl&yr.su(keep=  employment employmentsu payrollsu srecnum   pst salereceiptsu newtract
newtractsu actsu cfnsu lfosu sicsu zipsu  ctygeosu indsu indsubsu lfo1su npisu pdivsu plcesu plgeosu ppnsu
sic56su stgeosu streetsu tocsu  acfsu einsu 
AC943E	AC943P	acap	ACEMP	ACEMPF	ACF	ACSR1	ACSR1F
	ACSR2	ACSR2F	ACSR3	
ACSR4		ACT	ANNPR	CFN	CTYGEO	EIN	EMPCD	IND	INDSUB
	LFO	LFO1	NPI
PDIV	PLCE	PLGEO	PPLCE	PPN	PSTREET	PZIP	
RECNUM	SIC	SIC56	SSABR	
SSACL	SSAEMP	STGEO	STREET	TOC ZIP rename=(stgeo=stgeo2)); 	
 set BR.ssl&yr.su;
Employment=ACEMP;
Employmentsu=ACEMP;
**************Exclude submasters;
if PDIV^='M';
*Exclude inactive units;
acap = (ACQP1+ACQP2+ACQP3+ACQP4)/1000;
if acap>0| AC943P>0;

payrollsu =acap;
 srecnum=recnum;
salereceiptsu=acsr1;
**************Creating new tract variable;
newtract=' ';   *tract variable does not exists for year <1992;
*Identify the source of the common variables;
newtractsu=newtract;
actsu=act; cfnsu=cfn; lfosu=lfo ; sicsu=sic ;zipsu=zip;  ctygeosu=ctygeo; indsu=ind; indsubsu=indsub; lfo1su=lfo1;
 npisu=npi; pdivsu=pdiv; plcesu=plce; plgeosu=plgeo; ppnsu=ppn;
sic56su=sic56; stgeosu=stgeo2; streetsu=street; tocsu=toc;  acfsu=acf;
einsu=ein;


 run;


*******
%let yr=1988;
libname BR '/economic/ssl/microdata/';
data ssl&yr.mu_cbp;
set BR.ssl&yr.mu_cbp;
run;


 *(2) Multi-Unit File;
************************************************************;
************************************************************;
%let yr=1988;
data ssl&yr.mu_cbp(keep=employment employmentmu payrollmu mrecnum  newtract stfips88  stgeo2 place88   
 
ACF	 ACT	 CFN	CTYGEO	EIN	GAT	IND	INDSUB	LFO	LFO1	NPI	PDIV	
PLCE  PLGEO	PPN	RAP	RAPF	RECNUM	REMP	REMPF	
SIC 	SIC56 	STREET	TOC	ZIP);	
set br.ssl&yr.mu_cbp;

**************Creating new tract variable;
NEWTRACT=' ';   *tract variable does not exists for years <1992;
**************Exclude ghosts;
if ACT^='G';
**************Exclude inactive units;
if rap>0| (rap=0 & (RAPF^='Z' & ACT^='D'));

EMPLOYMENT=REMP;
EMPLOYMENTmu=REMP;
PAYROLLmu=RAP;
mrecnum=recnum;
*88 MU File was completely reconstructed from CBP Files.The STGEO variable is mostly empty and
users should instead use STFIPS88;
*Converting Census State Codes into State FIPS codes;
*Note:STFIPS88 does not contain State FIPS code as it claims instead it contains Census State Codes.
It is misnamed and conversion from Census State Codes to FIPS codes is required;
*Code to convert from Census county codes to FIPS county codes;
if stfips88='07' then stgeo2='78';
if stfips88='06' then stgeo2='72';
if stfips88='01' then stgeo2='69';
if stfips88='04' then stgeo2='66';
if stfips88='63' then stgeo2='01';
if stfips88='94' then stgeo2='02';
if stfips88='86' then stgeo2='04';
if stfips88='71' then stgeo2='05';
if stfips88='93' then stgeo2='06';
if stfips88='84' then stgeo2='08';
if stfips88='16' then stgeo2='09';
if stfips88='51' then stgeo2='10';
if stfips88='53' then stgeo2='11';
if stfips88='59' then stgeo2='12';
if stfips88='58' then stgeo2='13';
if stfips88='95' then stgeo2='15';
if stfips88='82' then stgeo2='16';
if stfips88='33' then stgeo2='17';
if stfips88='32' then stgeo2='18';
if stfips88='42' then stgeo2='19';
if stfips88='47' then stgeo2='20';
if stfips88='61' then stgeo2='21';
if stfips88='72' then stgeo2='22';
if stfips88='11' then stgeo2='23';
if stfips88='52' then stgeo2='24';
if stfips88='14' then stgeo2='25';
if stfips88='34' then stgeo2='26';
if stfips88='41' then stgeo2='27';
if stfips88='64' then stgeo2='28';
if stfips88='43' then stgeo2='29';
if stfips88='81' then stgeo2='30';
if stfips88='46' then stgeo2='31';
if stfips88='88' then stgeo2='32';
if stfips88='12' then stgeo2='33';
if stfips88='22' then stgeo2='34';
if stfips88='85' then stgeo2='35';
if stfips88='21' then stgeo2='36';
if stfips88='56' then stgeo2='37';
if stfips88='44' then stgeo2='38';
if stfips88='31' then stgeo2='39';
if stfips88='73' then stgeo2='40';
if stfips88='92' then stgeo2='41';
if stfips88='23' then stgeo2='42';
if stfips88='15' then stgeo2='44';
if stfips88='57' then stgeo2='45';
if stfips88='45' then stgeo2='46';
if stfips88='62' then stgeo2='47';
if stfips88='74' then stgeo2='48';
if stfips88='87' then stgeo2='49';
if stfips88='13' then stgeo2='50';
if stfips88='54' then stgeo2='51';
if stfips88='91' then stgeo2='53';
if stfips88='55' then stgeo2='54';
if stfips88='35' then stgeo2='55';
if stfips88='83' then stgeo2='56';
run;
%let yr=1988;
data ssl&yr.mu_cbp;
set work.ssl&yr.mu_cbp;
stgeo=stgeo2;
run;

%let yr=1988;
data ssl&yr.mu_cbp;
set work.ssl&yr.mu_cbp;
*Identify the source of the common variables;
newtractmu=newtract;
actmu=act; cfnmu=cfn; lfomu=lfo ; sicmu=sic ;zipmu=zip; 
 ctygeomu=ctygeo; indmu=ind; indsubmu=indsub; lfo1mu=lfo1;
 npimu=npi; pdivmu=pdiv; plcemu=plce; plgeomu=plgeo; ppnmu=ppn;
sic56mu=sic56; stgeomu=stgeo2; streetmu=street; tocmu=toc;  acfmu=acf;
einmu=ein;
run;
************************************************************;
************************************************************ ;



*LBD File;
************************************************************;
************************************************************;
%let yr=1988;
libname lbd '/economic/lbd/microdata';
data lbd&yr.c;
set lbd.lbd&yr.c;
*Drop missing recnum and mu observations;
recnumx=put(recnum,8.);
mux=put(mu,1.);
if recnumx^=' ';
if mux^=' ';
*Exclude submasters in LBD coming from SU file;
if mu=0 & PDIV='M' then delete;

/*
*Exclude inactive units;
if PAY>0;
*/

*Exclude ghosts in LBD coming from mu file;
if ACT='G' & mu=1 then delete;
run;

**************Creating srecnum mrecnum variables in lbd file and keeping the selected variables;
%let yr=1988;
data work.lbd&yr.c_rec(keep= mrecnum srecnum payrolllbd employmentlbd
actlbd cfnlbd lfolbd siclbd ziplbd 
ACT	BESTNAICs	BESTSIC	CFN	COUNTY	EMP	FIRMID	FIRSTYEAr	
FLAGA	FLAGB	
LASTYEAR	LBDNUM	LFO	MU	PAY	RECNUM	SIC	STATE YR ZIP)	;
set work.lbd&yr.c;

if mu=1 then MRECNUM=RECNUM;
if mu=0 then SRECNUM=RECNUM;

payrolllbd=pay;	
employmentlbd=emp;
actlbd=act;
 cfnlbd=cfn;
 lfolbd=lfo;
 siclbd=sic ;
ziplbd=zip; 
run;

**************Checking mu  in SU-SSL and mu-SSL ;
%let yr=1988;
proc means data=lbd&yr.c_rec;
var mu;
where mu=1;
run;

%let yr=1988;
proc means data=lbd&yr.c_rec;
var mu;
where mu=0;
run;


**************Checking mrecnum and srecnum variables in SU-SSL and mu-SSL ;
%let yr=1988;
Proc means data=ssl&yr.mu_cbp;
var mrecnum;
run;
%let yr=1988;
Proc means data=ssl&yr.su;
var srecnum;
run;

************************************************************;
************************************************************;
*Merging SSL and LBD;
************************************************************;
************************************************************;
*************1)Combine SU SSL and LBD by srecnum;
%let yr=1988;
proc sort data=work.lbd&yr.c_rec out=lbd88_s;
by SRECNUM;
run;

proc sort data=work.ssl&yr.su out=sussl88nt;
by SRECNUM;
run;

data work.su_ssllbd1988;
merge lbd88_s(in=one) sussl88nt(in=two);
fromlbd88_s=one;
fromsussl88nt=two;
by SRECNUM;
run;

data work.su_ssllbd1988;
set work.su_ssllbd1988;
recnumx=put(recnum,8.);
srecnumx=put(srecnum,8.);
mux=put(mu,1.);
if recnumx^=' ';
if mux^=' ';
if srecnumx^=' ';
RUN;

*************2)Combine mu SSL and LBD by Mrecnum;
%let yr=1988;
proc sort data=work.lbd&yr.c_rec out=lbd88_M;
by MRECNUM;
run;

proc sort data=work.ssl&yr.mu_cbp out=mussl88nt;
by MRECNUM;
run;

data work.mu_ssllbd1988;
merge lbd88_M(in=one) mussl88nt(in=two);
fromlbd88_m=one;
frommussl88nt =two;
by MRECNUM;
run;

data work.mu_ssllbd1988;
set work.mu_ssllbd1988;
recnumx=put(recnum,8.);
mrecnumx=put(mrecnum,8.);
mux=put(mu,1.);
if recnumx^=' ';
if mux^=' ';
if mrecnumx^=' ';
run;


**************3-A)Combine SU-SSLLBD &mu SSL-LBD FILES;
%let yr=1988;
data ssllbd&yr.;
set work.su_ssllbd1988(in=a)
work.mu_ssllbd1988 (in=b);
if a then SU2=1;else SU2=0;
if b then mu2=1;else mu2=0;
year=&yr.;
run;



**Create a newfips variable;
%let yr=1988;
data ssllbd&yr;
length newfips $5;
set work.ssllbd&yr;
ctygeox=put(ctygeo,3.);
stgeox=put(stgeo2,2.);
If ctygeox^=' ' & stgeox^=' ' then newfips=stgeox||ctygeox;
else newfips=" ";
run;

data ssllbd&yr;
set work.ssllbd&yr;
**Keeping the counties listed;
where newfips="01015"
or newfips="01073"
or newfips="01097"
or newfips="02090"
or newfips="04013"
or newfips="04019"
or newfips="05069"
or newfips="05119"
or newfips="06001"
or newfips="06019"
or newfips="06037"
or newfips="06059"
or newfips="06067"
or newfips="06073"
or newfips="06075"
or newfips="08001"
or newfips="08031"
or newfips="08123"
or newfips="09001"
or newfips="09003"
or newfips="09009"
or newfips="10003"
or newfips="11001"
or newfips="12011"
or newfips="12031"
or newfips="12057"
or newfips="12086"
or newfips="13051"
or newfips="13089"
or newfips="13095"
or newfips="13121"
or newfips="17031"
or newfips="17143"
or newfips="17163"
or newfips="17167"
or newfips="18089"
or newfips="18097"
or newfips="19153"
or newfips="19193"
or newfips="20209"
or newfips="21111"
or newfips="22017"
or newfips="22019"
or newfips="22051"
or newfips="22071"
or newfips="22073"
or newfips="24510"
or newfips="25009"
or newfips="25013"
or newfips="25017"
or newfips="25025"
or newfips="26021"
or newfips="26049"
or newfips="26121"
or newfips="26163"
or newfips="27053"
or newfips="27123"
or newfips="28049"
or newfips="29047"
or newfips="29095"
or newfips="29165"
or newfips="29189"
or newfips="29510"
or newfips="31055"
or newfips="32003"
or newfips="33011"
or newfips="34007"
or newfips="34011"
or newfips="34013"
or newfips="34017"
or newfips="34039"
or newfips="35001"
or newfips="35013"
or newfips="36005"
or newfips="36029"
or newfips="36047"
or newfips="36055"
or newfips="36061"
or newfips="36063"
or newfips="36067"
or newfips="36071"
or newfips="36081"
or newfips="36085"
or newfips="36093"
or newfips="36119"
or newfips="37119"
or newfips="39017"
or newfips="39035"
or newfips="39045"
or newfips="39049"
or newfips="39061"
or newfips="39081"
or newfips="39087"
or newfips="39099"
or newfips="39153"
or newfips="40017"
or newfips="40027"
or newfips="40109"
or newfips="41051"
or newfips="42003"
or newfips="42043"
or newfips="42045"
or newfips="42101"
or newfips="44007"
or newfips="45019"
or newfips="45079"
or newfips="45085"
or newfips="47037"
or newfips="47065"
or newfips="47093"
or newfips="47157"
or newfips="48029"
or newfips="48085"
or newfips="48113"
or newfips="48121"
or newfips="48141"
or newfips="48157"
or newfips="48201"
or newfips="48245"
or newfips="48309"
or newfips="48355"
or newfips="48361"
or newfips="48439"
or newfips="48453"
or newfips="48491"
or newfips="49057"
or newfips="51710"
or newfips="51740"
or newfips="51760"
or newfips="53033"
or newfips="53053"
or newfips="53077"
or newfips="54009"
or newfips="54011"
or newfips="54039"
or newfips="54099"
or newfips="55079"

or newfips="01117"
or newfips="04027"
or newfips="08005"
or newfips="08059"
or newfips="08035"
or newfips="11031"
or newfips="12025"
or newfips="13063"
or newfips="13135"
or newfips="13177"
or newfips="17005"
or newfips="17043"
or newfips="17097"
or newfips="18057"
or newfips="24005"
or newfips="26125"
or newfips="27003"
or newfips="27163"
or newfips="28121"
or newfips="31153"
or newfips="32009"
or newfips="35043"
or newfips="36105"
or newfips="36001"
or newfips="36079"
or newfips="37179"
or newfips="39085"
or newfips="39041"
or newfips="39025"
or newfips="39155"
or newfips="41005"
or newfips="44003"
or newfips="45063"
or newfips="47187"
or newfips="48251"
or newfips="48367"
or newfips="51810"
or newfips="51041"
or newfips="51087"
or newfips="55133";
run;

**************3-B)Eliminating EINs that appear in both the SU(not submaster)
and MU files,keeping MU information suggested by Miranda(2002);
%let yr=1988;
proc sort data=work.ssllbd&yr OUT=work.ssllbd&yr;by EIN;
proc means data=work.ssllbd&yr noprint;
by EIN;
output out=work.dups(drop=_TYPE_ _FREQ_)
n(EMPLOYMENT)=EIN_COUNT;
run;

data ssllbd&yr;
merge work.ssllbd&yr (in=a) work.dups(in=b);
by EIN;
*We are concerned about EINs that are in the SU(not submaster) and MU;
if EIN_COUNT>1 & SU2=1 & PDIV^='M' then delete;
run;


*save the merged ssllbd data;
data "/rdcprojects/mc00535/data/ssllbd/ssllbd&yr "(compress=yes);
set ssllbd&yr;
RENAME STGEO2=STGEO;
drop fromlbd88_s fromlbd88_m frommussl88nt fromsussl88nt  SU2 MU2 srecnum mrecnum EIN_COUNT  srecnumx mrecnumx recnumx mux stgeox ctygeox;
run;

proc datasets lib=work;
delete
dups lbd1988c lbd1988c_rec lbd88_m lbd88_s
mussl88nt su_ssl88nt mu_ssllbd1988 su_ssllbd1988
ssl1988mu_cbp ssl1988su ssllbd1988;
run;




 *************************YEAR:1989 ******************************************;
 *MACROS;
%let yr=1989;
libname BR '/economic/ssl/microdata/';
data ssl&yr.su;
set BR.ssl&yr.su;
run;

************************************************************;
************************************************************;
*(1) Single-Unit File;
************************************************************;
************************************************************;
%let yr=1989;
data ssl&yr.su(keep=  employment employmentsu payrollsu srecnum   pst salereceiptsu newtract mstreet mplce mst mzip
same_as
newtractsu actsu cfnsu lfosu sicsu zipsu  ctygeosu indsu indsubsu lfo1su npisu pdivsu plcesu plgeosu ppnsu
sic56su stgeosu streetsu tocsu  acfsu einsu 

AC943E	AC943P	acap	ACEMP	ACEMPF	ACF	ACSR1	ACSR1F
ACSR2	ACSR2F	ACSR3	
ACSR4	ACT	ANNPR	CFN	CTYGEO	EIN	EMPCD	IND	INDSUB
LFO	LFO1	NPI
PDIV	PLCE	PLGEO	PPLCE	PPN	PSTREET	PZIP	
RECNUM	SIC	SIC56	SSABR	
SSACL	SSAEMP	STGEO	STREET	TOC ZIP rename=(STGEO=STGEO2) );
 set BR.ssl&yr.su;
Employment=ACEMP;
Employmentsu=ACEMP;
**************Exclude submasters;
if PDIV^='M';
*Exclude inactive units;
acap = ACQP1+ACQP2+ACQP3+ACQP4;
if acap>0| AC943P>0;

payrollsu =acap;
 srecnum=recnum;
salereceiptsu=acsr1;
**************Creating new tract variable;
newtract=' ';   *tract variable does not exists for year <1992;
*Identify the source of the common variables;
newtractsu=newtract;
actsu=act; cfnsu=cfn; lfosu=lfo ; sicsu=sic ;zipsu=zip;  ctygeosu=ctygeo; indsu=ind; indsubsu=indsub; lfo1su=lfo1;
 npisu=npi; pdivsu=pdiv; plcesu=plce; plgeosu=plgeo; ppnsu=ppn;
sic56su=sic56; stgeosu=stgeo2; streetsu=street; tocsu=toc;  acfsu=acf;
einsu=ein;

 run;


*******
%let yr=1989;
libname BR '/economic/ssl/microdata/';
data ssl&yr.mu;
set BR.ssl&yr.mu;
run;


 *(2) Multi-Unit File;
************************************************************;
************************************************************;
%let yr=1989;
data ssl&yr.mu_CBP(keep=employment employmentmu payrollmu mrecnum  newtract  salereceiptmu  stgeo2
ACF	 ACT	
CFN	CTYGEO	CYTE	EIN	GAT	IND	INDSUB	LFO	LFO1	NPI	PDIV	
PLCE	PLGEO	PPN	RAP	RAPF	RECNUM	REMP	REMPF	RSR	RSRF	
SIC	SIC56		STREET	TOC	ZIP);
set br.ssl&yr.mu_cbp;

**************Creating new tract variable;
NEWTRACT=' ';   *tract variable does not exists for years <1992;
**************Exclude ghosts;
if ACT^='G';
**************Exclude inactive units;
if rap>0| (rap=0 & (RAPF^='Z' & ACT^='D'));

EMPLOYMENT=REMP;
EMPLOYMENTmu=REMP;
PAYROLLmu=RAP;
salereceiptmu=RSR;	
mrecnum=recnum;

*Converting Census State Codes into State FIPS codes;
*Establishments with CFNs starting with 1 in the 1989 SSEL MU file
must be recoded from State Census Codes to FIPS codes;
*Code to convert from Census county codes to FIPS county codes;
if substr(CFN,1,1)='1' & stgeo='07' then stgeo2='78';
if substr(CFN,1,1)='1' & stgeo='06' then stgeo2='72';
if substr(CFN,1,1)='1' & stgeo='01' then stgeo2='69';
if substr(CFN,1,1)='1' & stgeo='04' then stgeo2='66';
if substr(CFN,1,1)='1' & stgeo='63' then stgeo2='01';
if substr(CFN,1,1)='1' & stgeo='94' then stgeo2='02';
if substr(CFN,1,1)='1' & stgeo='86' then stgeo2='04';
if substr(CFN,1,1)='1' & stgeo='71' then stgeo2='05';
if substr(CFN,1,1)='1' & stgeo='93' then stgeo2='06';
if substr(CFN,1,1)='1' & stgeo='84' then stgeo2='08';
if substr(CFN,1,1)='1' & stgeo='16' then stgeo2='09';
if substr(CFN,1,1)='1' & stgeo='51' then stgeo2='10';
if substr(CFN,1,1)='1' & stgeo='53' then stgeo2='11';
if substr(CFN,1,1)='1' & stgeo='59' then stgeo2='12';
if substr(CFN,1,1)='1' & stgeo='58' then stgeo2='13';
if substr(CFN,1,1)='1' & stgeo='95' then stgeo2='15';
if substr(CFN,1,1)='1' & stgeo='82' then stgeo2='16';
if substr(CFN,1,1)='1' & stgeo='33' then stgeo2='17';
if substr(CFN,1,1)='1' & stgeo='32' then stgeo2='18';
if substr(CFN,1,1)='1' & stgeo='42' then stgeo2='19';
if substr(CFN,1,1)='1' & stgeo='47' then stgeo2='20';
if substr(CFN,1,1)='1' & stgeo='61' then stgeo2='21';
if substr(CFN,1,1)='1' & stgeo='72' then stgeo2='22';
if substr(CFN,1,1)='1' & stgeo='11' then stgeo2='23';
if substr(CFN,1,1)='1' & stgeo='52' then stgeo2='24';
if substr(CFN,1,1)='1' & stgeo='14' then stgeo2='25';
if substr(CFN,1,1)='1' & stgeo='34' then stgeo2='26';
if substr(CFN,1,1)='1' & stgeo='41' then stgeo2='27';
if substr(CFN,1,1)='1' & stgeo='64' then stgeo2='28';
if substr(CFN,1,1)='1' & stgeo='43' then stgeo2='29';
if substr(CFN,1,1)='1' & stgeo='81' then stgeo2='30';
if substr(CFN,1,1)='1' & stgeo='46' then stgeo2='31';
if substr(CFN,1,1)='1' & stgeo='88' then stgeo2='32';
if substr(CFN,1,1)='1' & stgeo='12' then stgeo2='33';
if substr(CFN,1,1)='1' & stgeo='22' then stgeo2='34';
if substr(CFN,1,1)='1' & stgeo='85' then stgeo2='35';
if substr(CFN,1,1)='1' & stgeo='21' then stgeo2='36';
if substr(CFN,1,1)='1' & stgeo='56' then stgeo2='37';
if substr(CFN,1,1)='1' & stgeo='44' then stgeo2='38';
if substr(CFN,1,1)='1' & stgeo='31' then stgeo2='39';
if substr(CFN,1,1)='1' & stgeo='73' then stgeo2='40';
if substr(CFN,1,1)='1' & stgeo='92' then stgeo2='41';
if substr(CFN,1,1)='1' & stgeo='23' then stgeo2='42';
if substr(CFN,1,1)='1' & stgeo='15' then stgeo2='44';
if substr(CFN,1,1)='1' & stgeo='57' then stgeo2='45';
if substr(CFN,1,1)='1' & stgeo='45' then stgeo2='46';
if substr(CFN,1,1)='1' & stgeo='62' then stgeo2='47';
if substr(CFN,1,1)='1' & stgeo='74' then stgeo2='48';
if substr(CFN,1,1)='1' & stgeo='87' then stgeo2='49';
if substr(CFN,1,1)='1' & stgeo='13' then stgeo2='50';
if substr(CFN,1,1)='1' & stgeo='54' then stgeo2='51';
if substr(CFN,1,1)='1' & stgeo='91' then stgeo2='53';
if substr(CFN,1,1)='1' & stgeo='55' then stgeo2='54';
if substr(CFN,1,1)='1' & stgeo='35' then stgeo2='55';
if substr(CFN,1,1)='1' & stgeo='83' then stgeo2='56';
if substr(CFN,1,1)^='1' then stgeo2=STGEO;
run;

data ssl&yr.mu_cbp;
set work.ssl&yr.mu_cbp;
*Identify the source of the common variables;
newtractmu=newtract;
actmu=act; cfnmu=cfn; lfomu=lfo ; sicmu=sic ;zipmu=zip; 
 ctygeomu=ctygeo; indmu=ind; indsubmu=indsub; lfo1mu=lfo1;
 npimu=npi; pdivmu=pdiv; plcemu=plce; plgeomu=plgeo; ppnmu=ppn;
sic56mu=sic56; stgeomu=stgeo2; streetmu=street; tocmu=toc;  acfmu=acf;
einmu=ein;
run;
************************************************************;
************************************************************ ;




*LBD File;
************************************************************;
************************************************************;
%let yr=1989;
libname lbd '/economic/lbd/microdata';
data lbd&yr.c;
set lbd.lbd&yr.c;
*Drop missing recnum and MU observations;
recnumx=put(recnum,8.);
MUx=put(mu,1.);
if recnumx^=' ';
if MUx^=' ';
*Exclude submasters in LBD coming from SU file;
if MU=0 & PDIV='M' then delete;

/*
*Exclude inactive units;
if PAY>0;
*/

*Exclude ghosts in LBD coming from MU file;
if ACT='G' & MU=1 then delete;
run;

**************Creating srecnum mrecnum variables in lbd file and keeping the selected variables;
%let yr=1989;
data work.lbd&yr.c_rec(keep= mrecnum srecnum  payrolllbd employmentlbd
actlbd cfnlbd lfolbd siclbd ziplbd 
ACT	BESTNAICs	BESTSIC	CFN	COUNTY	EMP	FIRMID	FIRSTYEAr	
FLAGA	FLAGB	
LASTYEAR	LBDNUM	LFO	MU	PAY	RECNUM	SIC	STATE	YR ZIP)	;		
set work.lbd&yr.c;

if MU=1 then MRECNUM=RECNUM;
if MU=0  then SRECNUM=RECNUM;

payrolllbd=pay;	
employmentlbd=emp;
actlbd=act;
 cfnlbd=cfn;
 lfolbd=lfo;
 siclbd=sic ;
ziplbd=zip; 
run;

**************Checking mu  in LBD;
%let yr=1989;
proc means data=lbd&yr.c_rec;
var mu;
where mu=1;
run;

%let yr=1989;
proc means data=lbd&yr.c_rec;
var mu;
where mu=0;
run;


**************Checking mrecnum and srecnum variables in SU-SSL and MU-SSL ;
%let yr=1989;
Proc means data=ssl&yr.mu_cbp;
var mrecnum;
run;
%let yr=1989;
Proc means data=ssl&yr.su;
var srecnum;
run;

************************************************************;
************************************************************;
*Merging SSL and LBD;
************************************************************;
************************************************************;
*************1)Combine SU SSL and LBD by srecnum;
%let yr=1989;
proc sort data=work.lbd&yr.c_rec out=lbd89_s;
by SRECNUM;
run;

proc sort data=work.ssl&yr.su out=sussl89nt;
by SRECNUM;
run;

data work.su_ssllbd1989;
merge lbd89_s(in=one) sussl89nt(in=two);
fromlbd89_s=one;
fromsussl89nt=two;
by SRECNUM;
run;

data work.su_ssllbd1989;
set work.su_ssllbd1989;
srecnumx=put(srecnum,8.);
recnumx=put(recnum,8.);
mux=put(mu,1.);
if recnumx^=' ';
if MUx^=' ';
if srecnumx^=' ';
RUN;

*************2)Combine MU SSL and LBD by Mrecnum;
%let yr=1989;
proc sort data=work.lbd&yr.c_rec out=lbd89_M;
by MRECNUM;
run;

proc sort data=work.ssl&yr.mu_cbp out=mussl89nt;
by MRECNUM;
run;

data work.mu_ssllbd1989;
merge lbd89_M(in=one) mussl89nt(in=two);
fromlbd89_m=one;
frommussl89nt =two;
by MRECNUM;
run;

data work.mu_ssllbd1989;
set work.mu_ssllbd1989;
mrecnumx=put(mrecnum,8.);
recnumx=put(recnum,8.);
mux=put(mu,1.);
if recnumx^=' ';
if MUx^=' ';
if mrecnumx^=' ';
RUN;


**************3-A)Combine SU-SSLLBD &MUSSL-LBD FILES;
%let yr=1989;
data ssllbd&yr.;
set work.su_ssllbd1989(in=a)
work.mu_ssllbd1989 (in=b);
if a then SU2=1;else SU2=0;
if b then MU2=1;else MU2=0;
year=&yr.;
run;

**Create a newfips variable;
%let yr=1989;
data ssllbd&yr;
length newfips $5;
set work.ssllbd&yr;
ctygeox=put(ctygeo,3.);
stgeo2x=put(stgeo2,2.);
If ctygeox^=' ' & stgeo2x^=' ' then newfips=stgeo2x||ctygeox;
else newfips=" ";
run;


data ssllbd&yr;
set work.ssllbd&yr;
**Keeping the counties listed;
where newfips="01015"
or newfips="01073"
or newfips="01097"
or newfips="02090"
or newfips="04013"
or newfips="04019"
or newfips="05069"
or newfips="05119"
or newfips="06001"
or newfips="06019"
or newfips="06037"
or newfips="06059"
or newfips="06067"
or newfips="06073"
or newfips="06075"
or newfips="08001"
or newfips="08031"
or newfips="08123"
or newfips="09001"
or newfips="09003"
or newfips="09009"
or newfips="10003"
or newfips="11001"
or newfips="12011"
or newfips="12031"
or newfips="12057"
or newfips="12086"
or newfips="13051"
or newfips="13089"
or newfips="13095"
or newfips="13121"
or newfips="17031"
or newfips="17143"
or newfips="17163"
or newfips="17167"
or newfips="18089"
or newfips="18097"
or newfips="19153"
or newfips="19193"
or newfips="20209"
or newfips="21111"
or newfips="22017"
or newfips="22019"
or newfips="22051"
or newfips="22071"
or newfips="22073"
or newfips="24510"
or newfips="25009"
or newfips="25013"
or newfips="25017"
or newfips="25025"
or newfips="26021"
or newfips="26049"
or newfips="26121"
or newfips="26163"
or newfips="27053"
or newfips="27123"
or newfips="28049"
or newfips="29047"
or newfips="29095"
or newfips="29165"
or newfips="29189"
or newfips="29510"
or newfips="31055"
or newfips="32003"
or newfips="33011"
or newfips="34007"
or newfips="34011"
or newfips="34013"
or newfips="34017"
or newfips="34039"
or newfips="35001"
or newfips="35013"
or newfips="36005"
or newfips="36029"
or newfips="36047"
or newfips="36055"
or newfips="36061"
or newfips="36063"
or newfips="36067"
or newfips="36071"
or newfips="36081"
or newfips="36085"
or newfips="36093"
or newfips="36119"
or newfips="37119"
or newfips="39017"
or newfips="39035"
or newfips="39045"
or newfips="39049"
or newfips="39061"
or newfips="39081"
or newfips="39087"
or newfips="39099"
or newfips="39153"
or newfips="40017"
or newfips="40027"
or newfips="40109"
or newfips="41051"
or newfips="42003"
or newfips="42043"
or newfips="42045"
or newfips="42101"
or newfips="44007"
or newfips="45019"
or newfips="45079"
or newfips="45085"
or newfips="47037"
or newfips="47065"
or newfips="47093"
or newfips="47157"
or newfips="48029"
or newfips="48085"
or newfips="48113"
or newfips="48121"
or newfips="48141"
or newfips="48157"
or newfips="48201"
or newfips="48245"
or newfips="48309"
or newfips="48355"
or newfips="48361"
or newfips="48439"
or newfips="48453"
or newfips="48491"
or newfips="49057"
or newfips="51710"
or newfips="51740"
or newfips="51760"
or newfips="53033"
or newfips="53053"
or newfips="53077"
or newfips="54009"
or newfips="54011"
or newfips="54039"
or newfips="54099"
or newfips="55079"

or newfips="01117"
or newfips="04027"
or newfips="08005"
or newfips="08059"
or newfips="08035"
or newfips="11031"
or newfips="12025"
or newfips="13063"
or newfips="13135"
or newfips="13177"
or newfips="17005"
or newfips="17043"
or newfips="17097"
or newfips="18057"
or newfips="24005"
or newfips="26125"
or newfips="27003"
or newfips="27163"
or newfips="28121"
or newfips="31153"
or newfips="32009"
or newfips="35043"
or newfips="36105"
or newfips="36001"
or newfips="36079"
or newfips="37179"
or newfips="39085"
or newfips="39041"
or newfips="39025"
or newfips="39155"
or newfips="41005"
or newfips="44003"
or newfips="45063"
or newfips="47187"
or newfips="48251"
or newfips="48367"
or newfips="51810"
or newfips="51041"
or newfips="51087"
or newfips="55133";
run;

**************3-B)Eliminating EINs that appear in both the SU(not submaster)
and MU files,keeping MU information suggested by Miranda(2002);
%let yr=1989;
proc sort data=work.ssllbd&yr OUT=work.ssllbd&yr;by EIN;
proc means data=work.ssllbd&yr noprint;
by EIN;
output out=work.dups(drop=_TYPE_ _FREQ_)
n(EMPLOYMENT)=EIN_COUNT;
run;

data ssllbd&yr;
merge work.ssllbd&yr (in=a) work.dups(in=b);
by EIN;
*We are concerned about EINs that are in the SU(not submaster) and MU;
if EIN_COUNT>1 & SU2=1 & PDIV^='M' then delete;
run;

*save the merged ssllbd data;
data "/rdcprojects/mc00535/data/ssllbd/ssllbd&yr "(compress=yes);
set ssllbd&yr;
RENAME STGEO2=STGEO;
drop fromlbd89_s fromlbd89_m frommussl89nt fromsussl89nt  SU2 MU2 srecnum mrecnum EIN_COUNT srecnumx mrecnumx recnumx mux stgeo2x ctygeox; 
run;


proc datasets lib=work;
delete
dups lbd1989c lbd1989c_rec lbd89_m lbd89_s
mussl89nt sussl89nt mu_ssllbd1989 su_ssllbd1989
ssl1989mu ssl1989su ssllbd1989;
run;




 ******************************************YEAR:1990 ************************************************;
 *MACROS;
%let yr=1990;
libname BR '/economic/ssl/microdata/'; 
data ssl&yr.su;
set BR.ssl&yr.su;
run;

************************************************************;
************************************************************;
*(1) Single-Unit File;
************************************************************;
************************************************************;
%let yr=1990;
data ssl&yr.su(keep=  employment employmentsu payrollsu srecnum   pst salereceiptsu
 newtract mstreet mplce mst mzip same_as
newtractsu actsu cfnsu lfosu sicsu zipsu  ctygeosu indsu indsubsu lfo1su npisu pdivsu plcesu plgeosu ppnsu
sic56su stgeosu streetsu tocsu  acfsu einsu 
AC943E AC943P acap ACEMP ACEMPF ACF ACSR1 ACSR1F ACSR2 ACSR2F ACSR3
ACSR4 ACT ANNPR CFN CTYGEO EIN EMPCD IND INDSUB
LFO LFO1   NPI PDIV PLCE PLGEO PPLCE PPN PSTREET PZIP
RECNUM SIC SIC56 SSABR
SSACL	SSAEMP	STGEO	STREET	TOC ZIP ); 	
set BR.ssl&yr.su;
Employment=ACEMP;
Employmentsu=ACEMP;
**************Exclude submasters;
if PDIV^='M';
*Exclude inactive units;
acap = ACQP1+ACQP2+ACQP3+ACQP4;
if acap>0| AC943P>0;

payrollsu =acap;
 srecnum=recnum;
salereceiptsu=acsr1;
**************Creating new tract variable;
newtract=' ';   *tract variable does not exists for year <1992;
*Identify the source of the common variables;
newtractsu=newtract;
actsu=act; cfnsu=cfn; lfosu=lfo ; sicsu=sic ;zipsu=zip; 
 ctygeosu=ctygeo; indsu=ind; indsubsu=indsub; lfo1su=lfo1;
 npisu=npi; pdivsu=pdiv; plcesu=plce; plgeosu=plgeo; ppnsu=ppn;
sic56su=sic56; stgeosu=stgeo; streetsu=street; tocsu=toc; acfsu=acf;
einsu=ein;
run;


*******
%let yr=1990;
libname BR '/economic/ssl/microdata/';
data ssl&yr.mu;
set BR.ssl&yr.mu;
run;


 *(2) Multi-Unit File;
************************************************************;
************************************************************;
%let yr=1990;
data ssl&yr.mu(keep=employment employmentmu payrollmu mrecnum  newtract  salereceiptmu  
 newtractmu actmu cfnmu lfomu sicmu zipmu  ctygeomu indmu indsubmu lfo1mu npimu 
pdivmu plcemu plgeomu ppnmu
sic56mu stgeomu streetmu tocmu  acfmu einmu 
ACF	 ACT	
CFN	CTYGEO	CYTE	EIN	GAT	IND	INDSUB	LFO	LFO1	NPI	PDIV	
PLCE	PLGEO	PPN	RAP	RAPF	RECNUM	REMP	REMPF	RSR	RSRF	
SIC	SIC56	STGEO	STREET	TOC	ZIP);	
set br.ssl&yr.mu;

**************Creating new tract variable;
NEWTRACT=' ';   *tract variable does not exists for years <1992;
**************Exclude ghosts;
if ACT^='G';
**************Exclude inactive units;
if rap>0| (rap=0 & (RAPF^='Z' & ACT^='D'));

EMPLOYMENT=REMP;
EMPLOYMENTmu=REMP;
PAYROLLmu=RAP;
salereceiptmu=RSR;	
mrecnum=recnum;
*Identify the source of the common variables;
newtractmu=newtract;
actmu=act; cfnmu=cfn; lfomu=lfo ; sicmu=sic ;zipmu=zip; 
ctygeomu=ctygeo; indmu=ind; indsubmu=indsub; lfo1mu=lfo1;
 npimu=npi; pdivmu=pdiv; plcemu=plce; plgeomu=plgeo; ppnmu=ppn;
sic56mu=sic56; stgeomu=stgeo; streetmu=street; tocmu=toc;  acfmu=acf;
einmu=ein;
run;
************************************************************;
************************************************************ ;



*LBD File;
************************************************************;
************************************************************;
%let yr=1990;
libname lbd '/economic/lbd/microdata';
data lbd&yr.c;
set lbd.lbd&yr.c;
*Drop missing recnum and MU observations;
recnumx=put(recnum,8.);
mux=put(mu,1.);
if recnumx^=' ';
if MUx^=' ';
*Exclude submasters in LBD coming from SU file;
if MU=0 & PDIV='M' then delete;

/*
*Exclude inactive units;
if PAY>0;
*/

*Exclude ghosts in LBD coming from MU file;
if ACT='G' & MU=1 then delete;
run;

**************Creating srecnum mrecnum variables in lbd file and keeping the selected variables;
%let yr=1990;
data work.lbd&yr.c_rec(keep= mrecnum srecnum  payrolllbd employmentlbd
actlbd cfnlbd lfolbd siclbd ziplbd 
ACT	BESTNAICs	BESTSIC	CFN	COUNTY	EMP	FIRMID	FIRSTYEAr	
FLAGA	FLAGB	
LASTYEAR LBDNUM	LFO	MU	PAY	RECNUM	SIC STATE YR ZIP);
set work.lbd&yr.c;

if MU=1 then MRECNUM=RECNUM;
if MU=0 then SRECNUM=RECNUM;

payrolllbd=pay;	
employmentlbd=emp;
actlbd=act;
 cfnlbd=cfn;
 lfolbd=lfo;
 siclbd=sic ;
ziplbd=zip; 
run;

**************Checking mu  in LBD;
%let yr=1990;
proc means data=lbd&yr.c_rec;
var mu;
where mu=1;
run;

%let yr=1990;
proc means data=lbd&yr.c_rec;
var mu;
where mu=0;
run;


**************Checking mrecnum and srecnum variables in SU-SSL and MU-SSL ;
%let yr=1990;
Proc means data=ssl&yr.mu;
var mrecnum;
run;
%let yr=1990;
Proc means data=ssl&yr.su;
var srecnum;
run;

************************************************************;
************************************************************;
*Merging SSL and LBD;
************************************************************;
************************************************************;
*************1)Combine SU SSL and LBD by srecnum;
%let yr=1990;
proc sort data=work.lbd&yr.c_rec out=lbd90_s;
by SRECNUM;
run;

proc sort data=work.ssl&yr.su out=sussl90nt;
by SRECNUM;
run;

data work.su_ssllbd1990;
merge lbd90_s(in=one) sussl90nt(in=two);
fromlbd90_s=one;
fromsussl90nt=two;
by SRECNUM;
run;

data work.su_ssllbd1990;
set work.su_ssllbd1990;
srecnumx=put(srecnum,8.);
recnumx=put(recnum,8.);
mux=put(mu,1.);
if recnumx^=' ';
if MUx^=' ';
if srecnumx^=' ';
RUN;

*************2)Combine MU SSL and LBD by Mrecnum;
%let yr=1990;
proc sort data=work.lbd&yr.c_rec out=lbd90_M;
by MRECNUM;
run;

proc sort data=work.ssl&yr.mu out=mussl90nt;
by MRECNUM;
run;

data work.mu_ssllbd1990;
merge lbd90_M(in=one) mussl90nt(in=two);
fromlbd90_m=one;
frommussl90nt =two;
by MRECNUM;
run;

data work.mu_ssllbd1990;
set work.mu_ssllbd1990;
mrecnumx=put(mrecnum,8.);
recnumx=put(recnum,8.);
mux=put(mu,1.);
if recnumx^=' ';
if MUx^=' ';
if mrecnumx^=' ';
RUN;


**************3-A)Combine SU-SSLLBD &MUSSL-LBD FILES;
%let yr=1990;
data ssllbd&yr.;
set work.su_ssllbd1990(in=a)
work.mu_ssllbd1990 (in=b);
if a then SU2=1;else SU2=0;
if b then MU2=1;else MU2=0;
year=&yr.;
run;



**Create a newfips variable;
%let yr=1990;
data ssllbd&yr;
length newfips $5;
set work.ssllbd&yr;
ctygeox=put(ctygeo,3.);
stgeox=put(stgeo,2.);
If ctygeox^=' ' & stgeox^=' ' then newfips=stgeox||ctygeox;
else newfips=" ";
run;


data ssllbd&yr;
set work.ssllbd&yr;
**Keeping the counties listed;
where newfips="01015"
or newfips="01073"
or newfips="01097"
or newfips="02090"
or newfips="04013"
or newfips="04019"
or newfips="05069"
or newfips="05119"
or newfips="06001"
or newfips="06019"
or newfips="06037"
or newfips="06059"
or newfips="06067"
or newfips="06073"
or newfips="06075"
or newfips="08001"
or newfips="08031"
or newfips="08123"
or newfips="09001"
or newfips="09003"
or newfips="09009"
or newfips="10003"
or newfips="11001"
or newfips="12011"
or newfips="12031"
or newfips="12057"
or newfips="12086"
or newfips="13051"
or newfips="13089"
or newfips="13095"
or newfips="13121"
or newfips="17031"
or newfips="17143"
or newfips="17163"
or newfips="17167"
or newfips="18089"
or newfips="18097"
or newfips="19153"
or newfips="19193"
or newfips="20209"
or newfips="21111"
or newfips="22017"
or newfips="22019"
or newfips="22051"
or newfips="22071"
or newfips="22073"
or newfips="24510"
or newfips="25009"
or newfips="25013"
or newfips="25017"
or newfips="25025"
or newfips="26021"
or newfips="26049"
or newfips="26121"
or newfips="26163"
or newfips="27053"
or newfips="27123"
or newfips="28049"
or newfips="29047"
or newfips="29095"
or newfips="29165"
or newfips="29189"
or newfips="29510"
or newfips="31055"
or newfips="32003"
or newfips="33011"
or newfips="34007"
or newfips="34011"
or newfips="34013"
or newfips="34017"
or newfips="34039"
or newfips="35001"
or newfips="35013"
or newfips="36005"
or newfips="36029"
or newfips="36047"
or newfips="36055"
or newfips="36061"
or newfips="36063"
or newfips="36067"
or newfips="36071"
or newfips="36081"
or newfips="36085"
or newfips="36093"
or newfips="36119"
or newfips="37119"
or newfips="39017"
or newfips="39035"
or newfips="39045"
or newfips="39049"
or newfips="39061"
or newfips="39081"
or newfips="39087"
or newfips="39099"
or newfips="39153"
or newfips="40017"
or newfips="40027"
or newfips="40109"
or newfips="41051"
or newfips="42003"
or newfips="42043"
or newfips="42045"
or newfips="42101"
or newfips="44007"
or newfips="45019"
or newfips="45079"
or newfips="45085"
or newfips="47037"
or newfips="47065"
or newfips="47093"
or newfips="47157"
or newfips="48029"
or newfips="48085"
or newfips="48113"
or newfips="48121"
or newfips="48141"
or newfips="48157"
or newfips="48201"
or newfips="48245"
or newfips="48309"
or newfips="48355"
or newfips="48361"
or newfips="48439"
or newfips="48453"
or newfips="48491"
or newfips="49057"
or newfips="51710"
or newfips="51740"
or newfips="51760"
or newfips="53033"
or newfips="53053"
or newfips="53077"
or newfips="54009"
or newfips="54011"
or newfips="54039"
or newfips="54099"
or newfips="55079"

or newfips="01117"
or newfips="04027"
or newfips="08005"
or newfips="08059"
or newfips="08035"
or newfips="11031"
or newfips="12025"
or newfips="13063"
or newfips="13135"
or newfips="13177"
or newfips="17005"
or newfips="17043"
or newfips="17097"
or newfips="18057"
or newfips="24005"
or newfips="26125"
or newfips="27003"
or newfips="27163"
or newfips="28121"
or newfips="31153"
or newfips="32009"
or newfips="35043"
or newfips="36105"
or newfips="36001"
or newfips="36079"
or newfips="37179"
or newfips="39085"
or newfips="39041"
or newfips="39025"
or newfips="39155"
or newfips="41005"
or newfips="44003"
or newfips="45063"
or newfips="47187"
or newfips="48251"
or newfips="48367"
or newfips="51810"
or newfips="51041"
or newfips="51087"
or newfips="55133";
run;
**************3-B)Eliminating EINs that appear in both the SU(not submaster)
and MU files,keeping MU information suggested by Miranda(2002);
%let yr=1990;
proc sort data=work.ssllbd&yr OUT=work.ssllbd&yr;by EIN;
proc means data=work.ssllbd&yr noprint;
by EIN;
output out=work.dups(drop=_TYPE_ _FREQ_)
n(EMPLOYMENT)=EIN_COUNT;
run;

data ssllbd&yr;
merge work.ssllbd&yr (in=a) work.dups(in=b);
by EIN;
*We are concerned about EINs that are in the SU(not submaster) and MU;
if EIN_COUNT>1 & SU2=1 & PDIV^='M' then delete;
run;

*save the merged ssllbd data;
data "/rdcprojects/mc00535/data/ssllbd/ssllbd&yr "(compress=yes);
set ssllbd&yr;
drop fromlbd90_s fromlbd90_m frommussl90nt fromsussl90nt  SU2 MU2 srecnum mrecnum EIN_COUNT srecnumx mrecnumx recnumx mux stgeox ctygeox;
run;

proc datasets lib=work;
delete
dups lbd1990c lbd1990c_rec lbd90_m lbd90_s
mussl90nt sussl90nt mu_ssllbd1990 su_ssllbd1990
ssl1990mu ssl1990su ssllbd1990;
run;





 ******************************************YEAR:1991 ************************************************;
 *MACROS;
%let yr=1991;
libname BR '/economic/ssl/microdata/'; 
data ssl&yr.su;
set BR.ssl&yr.su;
run;

************************************************************;
************************************************************;
*(1) Single-Unit File;
************************************************************;
************************************************************;
%let yr=1991;
data ssl&yr.su(keep=  employment employmentsu payrollsu srecnum   pst salereceiptsu
 newtract mstreet mplce mst mzip same_as
newtractsu actsu cfnsu lfosu sicsu zipsu  ctygeosu indsu indsubsu lfo1su npisu pdivsu plcesu plgeosu ppnsu
sic56su stgeosu streetsu tocsu  acfsu einsu 
AC943E AC943P acap ACEMP ACEMPF ACF ACSR1 ACSR1F ACSR2 ACSR2F ACSR3
ACSR4 ACT ANNPR CFN CTYGEO EIN EMPCD IND INDSUB
LFO LFO1   NPI PDIV PLCE PLGEO PPLCE PPN PSTREET PZIP
RECNUM SIC SIC56 SSABR
SSACL	SSAEMP	STGEO	STREET	TOC ZIP ); 	
set BR.ssl&yr.su;
Employment=ACEMP;
Employmentsu=ACEMP;
**************Exclude submasters;
if PDIV^='M';
*Exclude inactive units;
acap = ACQP1+ACQP2+ACQP3+ACQP4;
if acap>0| AC943P>0;

payrollsu =acap;
 srecnum=recnum;
salereceiptsu=acsr1;
**************Creating new tract variable;
newtract=' ';   *tract variable does not exists for year <1992;
*Identify the source of the common variables;
newtractsu=newtract;
actsu=act; cfnsu=cfn; lfosu=lfo ; sicsu=sic ;zipsu=zip; 
 ctygeosu=ctygeo; indsu=ind; indsubsu=indsub; lfo1su=lfo1;
 npisu=npi; pdivsu=pdiv; plcesu=plce; plgeosu=plgeo; ppnsu=ppn;
sic56su=sic56; stgeosu=stgeo; streetsu=street; tocsu=toc; acfsu=acf;
einsu=ein;
run;


*******
%let yr=1991;
libname BR '/economic/ssl/microdata/';
data ssl&yr.mu;
set BR.ssl&yr.mu;
run;


 *(2) Multi-Unit File;
************************************************************;
************************************************************;
%let yr=1991;
data ssl&yr.mu(keep=employment employmentmu payrollmu mrecnum  newtract  salereceiptmu  
 newtractmu actmu cfnmu lfomu sicmu zipmu  ctygeomu indmu indsubmu lfo1mu npimu 
pdivmu plcemu plgeomu ppnmu
sic56mu stgeomu streetmu tocmu  acfmu einmu 
ACF	 ACT	
CFN	CTYGEO	CYTE	EIN	GAT	IND	INDSUB	LFO	LFO1	NPI	PDIV	
PLCE	PLGEO	PPN	RAP	RAPF	RECNUM	REMP	REMPF	RSR	RSRF	
SIC	SIC56	STGEO	STREET	TOC	ZIP);	
set br.ssl&yr.mu;

**************Creating new tract variable;
NEWTRACT=' ';   *tract variable does not exists for years <1992;
**************Exclude ghosts;
if ACT^='G';
**************Exclude inactive units;
if rap>0| (rap=0 & (RAPF^='Z' & ACT^='D'));

EMPLOYMENT=REMP;
EMPLOYMENTmu=REMP;
PAYROLLmu=RAP;
salereceiptmu=RSR;	
mrecnum=recnum;
*Identify the source of the common variables;
newtractmu=newtract;
actmu=act; cfnmu=cfn; lfomu=lfo ; sicmu=sic ;zipmu=zip; 
ctygeomu=ctygeo; indmu=ind; indsubmu=indsub; lfo1mu=lfo1;
 npimu=npi; pdivmu=pdiv; plcemu=plce; plgeomu=plgeo; ppnmu=ppn;
sic56mu=sic56; stgeomu=stgeo; streetmu=street; tocmu=toc;  acfmu=acf;
einmu=ein;
run;
************************************************************;
************************************************************ ;



*LBD File;
************************************************************;
************************************************************;
%let yr=1991;
libname lbd '/economic/lbd/microdata';
data lbd&yr.c;
set lbd.lbd&yr.c;
*Drop missing recnum and MU observations;
recnumx=put(recnum,8.);
mux=put(mu,1.);
if recnumx^=' ';
if MUx^=' ';
*Exclude submasters in LBD coming from SU file;
if MU=0 & PDIV='M' then delete;

/*
*Exclude inactive units;
if PAY>0;
*/

*Exclude ghosts in LBD coming from MU file;
if ACT='G' & MU=1 then delete;
run;

**************Creating srecnum mrecnum variables in lbd file and keeping the selected variables;
%let yr=1991;
data work.lbd&yr.c_rec(keep= mrecnum srecnum  payrolllbd employmentlbd
actlbd cfnlbd lfolbd siclbd ziplbd 
ACT	BESTNAICs	BESTSIC	CFN	COUNTY	EMP	FIRMID	FIRSTYEAr	
FLAGA	FLAGB	
LASTYEAR LBDNUM	LFO	MU	PAY	RECNUM	SIC STATE YR ZIP);
set work.lbd&yr.c;

if MU=1 then MRECNUM=RECNUM;
if MU=0 then SRECNUM=RECNUM;

payrolllbd=pay;	
employmentlbd=emp;
actlbd=act;
 cfnlbd=cfn;
 lfolbd=lfo;
 siclbd=sic ;
ziplbd=zip; 
run;

**************Checking mu  in LBD;
%let yr=1991;
proc means data=lbd&yr.c_rec;
var mu;
where mu=1;
run;

%let yr=1991;
proc means data=lbd&yr.c_rec;
var mu;
where mu=0;
run;


**************Checking mrecnum and srecnum variables in SU-SSL and MU-SSL ;
%let yr=1991;
Proc means data=ssl&yr.mu;
var mrecnum;
run;
%let yr=1991;
Proc means data=ssl&yr.su;
var srecnum;
run;

************************************************************;
************************************************************;
*Merging SSL and LBD;
************************************************************;
************************************************************;
*************1)Combine SU SSL and LBD by srecnum;
%let yr=1991;
proc sort data=work.lbd&yr.c_rec out=lbd91_s;
by SRECNUM;
run;

proc sort data=work.ssl&yr.su out=sussl91nt;
by SRECNUM;
run;

data work.su_ssllbd1991;
merge lbd91_s(in=one) sussl91nt(in=two);
fromlbd91_s=one;
fromsussl91nt=two;
by SRECNUM;
run;

data work.su_ssllbd1991;
set work.su_ssllbd1991;
srecnumx=put(srecnum,8.);
recnumx=put(recnum,8.);
mux=put(mu,1.);
if recnumx^=' ';
if MUx^=' ';
if srecnumx^=' ';
RUN;

*************2)Combine MU SSL and LBD by Mrecnum;
%let yr=1991;
proc sort data=work.lbd&yr.c_rec out=lbd91_M;
by MRECNUM;
run;

proc sort data=work.ssl&yr.mu out=mussl91nt;
by MRECNUM;
run;

data work.mu_ssllbd1991;
merge lbd91_M(in=one) mussl91nt(in=two);
fromlbd91_m=one;
frommussl91nt =two;
by MRECNUM;
run;

data work.mu_ssllbd1991;
set work.mu_ssllbd1991;
mrecnumx=put(mrecnum,8.);
recnumx=put(recnum,8.);
mux=put(mu,1.);
if recnumx^=' ';
if MUx^=' ';
if mrecnumx^=' ';
RUN;


**************3-A)Combine SU-SSLLBD &MUSSL-LBD FILES;
%let yr=1991;
data ssllbd&yr.;
set work.su_ssllbd1991(in=a)
work.mu_ssllbd1991 (in=b);
if a then SU2=1;else SU2=0;
if b then MU2=1;else MU2=0;
year=&yr.;
run;



**Create a newfips variable;
%let yr=1991;
data ssllbd&yr;
length newfips $5;
set work.ssllbd&yr;
ctygeox=put(ctygeo,3.);
stgeox=put(stgeo,2.);
If ctygeox^=' ' & stgeox^=' ' then newfips=stgeox||ctygeox;
else newfips=" ";
run;


data ssllbd&yr;
set work.ssllbd&yr;
**Keeping the counties listed;
where newfips="01015"
or newfips="01073"
or newfips="01097"
or newfips="02090"
or newfips="04013"
or newfips="04019"
or newfips="05069"
or newfips="05119"
or newfips="06001"
or newfips="06019"
or newfips="06037"
or newfips="06059"
or newfips="06067"
or newfips="06073"
or newfips="06075"
or newfips="08001"
or newfips="08031"
or newfips="08123"
or newfips="09001"
or newfips="09003"
or newfips="09009"
or newfips="10003"
or newfips="11001"
or newfips="12011"
or newfips="12031"
or newfips="12057"
or newfips="12086"
or newfips="13051"
or newfips="13089"
or newfips="13095"
or newfips="13121"
or newfips="17031"
or newfips="17143"
or newfips="17163"
or newfips="17167"
or newfips="18089"
or newfips="18097"
or newfips="19153"
or newfips="19193"
or newfips="20209"
or newfips="21111"
or newfips="22017"
or newfips="22019"
or newfips="22051"
or newfips="22071"
or newfips="22073"
or newfips="24510"
or newfips="25009"
or newfips="25013"
or newfips="25017"
or newfips="25025"
or newfips="26021"
or newfips="26049"
or newfips="26121"
or newfips="26163"
or newfips="27053"
or newfips="27123"
or newfips="28049"
or newfips="29047"
or newfips="29095"
or newfips="29165"
or newfips="29189"
or newfips="29510"
or newfips="31055"
or newfips="32003"
or newfips="33011"
or newfips="34007"
or newfips="34011"
or newfips="34013"
or newfips="34017"
or newfips="34039"
or newfips="35001"
or newfips="35013"
or newfips="36005"
or newfips="36029"
or newfips="36047"
or newfips="36055"
or newfips="36061"
or newfips="36063"
or newfips="36067"
or newfips="36071"
or newfips="36081"
or newfips="36085"
or newfips="36093"
or newfips="36119"
or newfips="37119"
or newfips="39017"
or newfips="39035"
or newfips="39045"
or newfips="39049"
or newfips="39061"
or newfips="39081"
or newfips="39087"
or newfips="39099"
or newfips="39153"
or newfips="40017"
or newfips="40027"
or newfips="40109"
or newfips="41051"
or newfips="42003"
or newfips="42043"
or newfips="42045"
or newfips="42101"
or newfips="44007"
or newfips="45019"
or newfips="45079"
or newfips="45085"
or newfips="47037"
or newfips="47065"
or newfips="47093"
or newfips="47157"
or newfips="48029"
or newfips="48085"
or newfips="48113"
or newfips="48121"
or newfips="48141"
or newfips="48157"
or newfips="48201"
or newfips="48245"
or newfips="48309"
or newfips="48355"
or newfips="48361"
or newfips="48439"
or newfips="48453"
or newfips="48491"
or newfips="49057"
or newfips="51710"
or newfips="51740"
or newfips="51760"
or newfips="53033"
or newfips="53053"
or newfips="53077"
or newfips="54009"
or newfips="54011"
or newfips="54039"
or newfips="54099"
or newfips="55079"

or newfips="01117"
or newfips="04027"
or newfips="08005"
or newfips="08059"
or newfips="08035"
or newfips="11031"
or newfips="12025"
or newfips="13063"
or newfips="13135"
or newfips="13177"
or newfips="17005"
or newfips="17043"
or newfips="17097"
or newfips="18057"
or newfips="24005"
or newfips="26125"
or newfips="27003"
or newfips="27163"
or newfips="28121"
or newfips="31153"
or newfips="32009"
or newfips="35043"
or newfips="36105"
or newfips="36001"
or newfips="36079"
or newfips="37179"
or newfips="39085"
or newfips="39041"
or newfips="39025"
or newfips="39155"
or newfips="41005"
or newfips="44003"
or newfips="45063"
or newfips="47187"
or newfips="48251"
or newfips="48367"
or newfips="51810"
or newfips="51041"
or newfips="51087"
or newfips="55133";
run;
**************3-B)Eliminating EINs that appear in both the SU(not submaster)
and MU files,keeping MU information suggested by Miranda(2002);
%let yr=1991;
proc sort data=work.ssllbd&yr OUT=work.ssllbd&yr;by EIN;
proc means data=work.ssllbd&yr noprint;
by EIN;
output out=work.dups(drop=_TYPE_ _FREQ_)
n(EMPLOYMENT)=EIN_COUNT;
run;

data ssllbd&yr;
merge work.ssllbd&yr (in=a) work.dups(in=b);
by EIN;
*We are concerned about EINs that are in the SU(not submaster) and MU;
if EIN_COUNT>1 & SU2=1 & PDIV^='M' then delete;
run;

*save the merged ssllbd data;
data "/rdcprojects/mc00535/data/ssllbd/ssllbd&yr "(compress=yes);
set ssllbd&yr;
drop fromlbd91_s fromlbd91_m frommussl91nt fromsussl91nt  SU2 MU2 srecnum mrecnum EIN_COUNT srecnumx mrecnumx recnumx mux stgeox ctygeox;
run;

proc datasets lib=work;
delete
dups lbd1991c lbd1991c_rec lbd91_m lbd91_s
mussl91nt sussl91nt mu_ssllbd1991 su_ssllbd1991
ssl1991mu ssl1991su ssllbd1991;
run;



 ******************************************YEAR:1992 ************************************************;
 *MACROS;
%let yr=1992;
libname BR '/economic/ssl/microdata/';
data ssl&yr.su;
set BR.ssl&yr.su;
run;

************************************************************;
************************************************************;
*(1) Single-Unit File;
************************************************************;
************************************************************;
%let yr=1992;
data ssl&yr.su(keep=  employment employmentsu payrollsu srecnum   pst salereceiptsu newtract mstreet
mplce mst mzip same_as
newtractsu actsu cfnsu lfosu sicsu zipsu blkgeosu blksfxsu cdgeosu ctygeosu indsu indsubsu lfo1su npisu pdivsu plcesu plgeosu ppnsu
sic56su stgeosu streetsu tocsu tractsu acfsu einsu 
AC943E AC943P acap ACEMP ACEMPF ACF ACSR1 ACSR1F ACSR2 ACSR2F ACSR3 ACSR3F
ACSR4 ACSR4F ACT ANNPR BLKGEO BLKSFX CDGEO CFN CTYGEO EIN EMPCD IND INDSUB
LFO LFO1   NPI PDIV PLCE PLGEO PPLCE PPN PSTREET PZIP
RECNUM SIC SIC56 SSABR
SSACL SSAEMP STGEO STREET TOC TRACT ZIP );	
 set BR.ssl&yr.su;
 *************Creating new tract variable;

length NEWTRACT $ 11;
If tract^=' ' & STGEO^=' ' & CTYGEO^=' ' then NEWTRACT=STGEO||CTYGEO||TRACT;
else newtract=" ";



Employment=ACEMP;
Employmentsu=ACEMP;
**************Exclude submasters;
if PDIV^='M';
*Exclude inactive units;
acap = ACQP1+ACQP2+ACQP3+ACQP4;
if acap>0| AC943P>0;

payrollsu =acap;
 srecnum=recnum;
salereceiptsu=acsr1;
*Identify the source of the common variables;
newtractsu=newtract;
actsu=act; cfnsu=cfn; lfosu=lfo ; sicsu=sic ;zipsu=zip; blkgeosu=blkgeo; blksfxsu=blksfx;
cdgeosu=cdgeo; ctygeosu=ctygeo; indsu=ind; indsubsu=indsub; lfo1su=lfo1;
 npisu=npi; pdivsu=pdiv; plcesu=plce; plgeosu=plgeo; ppnsu=ppn;
sic56su=sic56; stgeosu=stgeo; streetsu=street; tocsu=toc; tractsu=tract; acfsu=acf;
einsu=ein;
run;


*******
%let yr=1992;
libname BR '/economic/ssl/microdata/';
data ssl&yr.mu;
set BR.ssl&yr.mu;
run;


 *(2) Multi-Unit File;
************************************************************;
************************************************************;
%let yr=1992;
data ssl&yr.mu(keep=employment employmentmu payrollmu mrecnum  newtract  salereceiptmu  
newtractmu actmu cfnmu lfomu sicmu zipmu blkgeomu blksfxmu cdgeomu ctygeomu indmu indsubmu lfo1mu npimu 
pdivmu plcemu plgeomu ppnmu
sic56mu stgeomu streetmu tocmu tractmu acfmu einmu 
ACF ACT
BLKGEO BLKSFX CDGEO
CFN CTYGEO CYTE EIN GAT IND INDSUB LFO LFO1 NPI PDIV
PLCE PLGEO PPN RAP RAPF RECNUM REMP REMPF RSR RSRF
SIC	SIC56	STGEO	STREET	TOC TRACT ZIP);	
 set BR.ssl&yr.mu;
 *************Creating new tract variable;

length NEWTRACT $ 11;
If tract^=' ' & STGEO^=' ' & CTYGEO^=' ' then NEWTRACT=STGEO||CTYGEO||TRACT;
else newtract=" ";

**************Exclude ghosts;
if ACT^='G';
**************Exclude inactive units;
if rap>0| (rap=0 & (RAPF^='Z' & ACT^='D'));

EMPLOYMENT=REMP;
EMPLOYMENTmu=REMP;
PAYROLLmu=RAP;
salereceiptmu=RSR;	
mrecnum=recnum;
*Identify the source of the common variables;
newtractmu=newtract;
actmu=act; cfnmu=cfn; lfomu=lfo ; sicmu=sic ;zipmu=zip; blkgeomu=blkgeo; blksfxmu=blksfx;
cdgeomu=cdgeo; ctygeomu=ctygeo; indmu=ind; indsubmu=indsub; lfo1mu=lfo1;
 npimu=npi; pdivmu=pdiv; plcemu=plce; plgeomu=plgeo; ppnmu=ppn;
sic56mu=sic56; stgeomu=stgeo; streetmu=street; tocmu=toc; tractmu=tract; acfmu=acf;
einmu=ein;
run;
************************************************************;
************************************************************ ;



*LBD File;
************************************************************;
************************************************************;
%let yr=1992;
libname lbd '/economic/lbd/microdata';
data lbd&yr.c;
set lbd.lbd&yr.c;
*Drop missing recnum and MU observations;
recnumx=put(recnum,8.);
mux=put(mu,1.);
if recnumx^=' ';
if MUx^=' ';
*Exclude submasters in LBD coming from SU file;
if MU=0 & PDIV='M' then delete;

/*
*Exclude inactive units;
if PAY>0;
*/

*Exclude ghosts in LBD coming from MU file;
if ACT='G' & MU=1 then delete;
run;

**************Creating srecnum mrecnum variables in lbd file and keeping the selected variables;
%let yr=1992;
data work.lbd&yr.c_rec(keep= mrecnum srecnum  payrolllbd employmentlbd
actlbd cfnlbd lfolbd siclbd ziplbd 
ACT	BESTNAICs	BESTSIC	CFN	COUNTY	EMP	FIRMID	FIRSTYEAr	
FLAGA	FLAGB	
LASTYEAR LBDNUM	LFO	MU	PAY	RECNUM	SIC STATE YR ZIP);
set work.lbd&yr.c;

if MU=1 then MRECNUM=RECNUM;
if MU=0 then SRECNUM=RECNUM;

payrolllbd=pay;	
employmentlbd=emp;
actlbd=act;
 cfnlbd=cfn;
 lfolbd=lfo;
 siclbd=sic ;
ziplbd=zip; 
run;

**************Checking mu  in LBD;
%let yr=1992;
proc means data=lbd&yr.c_rec;
var mu;
where mu=1;
run;

%let yr=1992;
proc means data=lbd&yr.c_rec;
var mu;
where mu=0;
run;


**************Checking mrecnum and srecnum variables in SU-SSL and MU-SSL ;
%let yr=1992;
Proc means data=ssl&yr.mu;
var mrecnum;
run;
%let yr=1992;
Proc means data=ssl&yr.su;
var srecnum;
run;

************************************************************;
************************************************************;
*Merging SSL and LBD;
************************************************************;
************************************************************;
*************1)Combine SU SSL and LBD by srecnum;
%let yr=1992;
proc sort data=work.lbd&yr.c_rec out=lbd92_s;
by SRECNUM;
run;

proc sort data=work.ssl&yr.su out=sussl92nt;
by SRECNUM;
run;

data work.su_ssllbd1992;
merge lbd92_s(in=one) sussl92nt(in=two);
fromlbd92_s=one;
fromsussl92nt=two;
by SRECNUM;
run;

data work.su_ssllbd1992;
set work.su_ssllbd1992;
srecnumx=put(srecnum,8.);
recnumx=put(recnum,8.);
mux=put(mu,1.);
if recnumx^=' ';
if MUx^=' ';
if srecnumx^=' ';
RUN;

*************2)Combine MU SSL and LBD by Mrecnum;
%let yr=1992;
proc sort data=work.lbd&yr.c_rec out=lbd92_M;
by MRECNUM;
run;

proc sort data=work.ssl&yr.mu out=mussl92nt;
by MRECNUM;
run;

data work.mu_ssllbd1992;
merge lbd92_M(in=one) mussl92nt(in=two);
fromlbd92_m=one;
frommussl92nt =two;
by MRECNUM;
run;

data work.mu_ssllbd1992;
set work.mu_ssllbd1992;
mrecnumx=put(mrecnum,8.);
recnumx=put(recnum,8.);
mux=put(mu,1.);
if recnumx^=' ';
if MUx^=' ';
if mrecnumx^=' ';
RUN;


**************3-A)Combine SU-SSLLBD &MUSSL-LBD FILES;
%let yr=1992;
data ssllbd&yr.;
set work.su_ssllbd1992(in=a)
work.mu_ssllbd1992 (in=b);
if a then SU2=1;else SU2=0;
if b then MU2=1;else MU2=0;
year=&yr.;
run;


**Create a newfips variable;
%let yr=1992;
data ssllbd&yr;
length newfips $5;
set work.ssllbd&yr;
ctygeox=put(ctygeo,3.);
stgeox=put(stgeo,2.);
If ctygeox^=' ' & stgeox^=' ' then newfips=stgeox||ctygeox;
else newfips=" ";
run;


data ssllbd&yr;
set work.ssllbd&yr;
**Keeping the counties listed;
where newfips="01015"
or newfips="01073"
or newfips="01097"
or newfips="02090"
or newfips="04013"
or newfips="04019"
or newfips="05069"
or newfips="05119"
or newfips="06001"
or newfips="06019"
or newfips="06037"
or newfips="06059"
or newfips="06067"
or newfips="06073"
or newfips="06075"
or newfips="08001"
or newfips="08031"
or newfips="08123"
or newfips="09001"
or newfips="09003"
or newfips="09009"
or newfips="10003"
or newfips="11001"
or newfips="12011"
or newfips="12031"
or newfips="12057"
or newfips="12086"
or newfips="13051"
or newfips="13089"
or newfips="13095"
or newfips="13121"
or newfips="17031"
or newfips="17143"
or newfips="17163"
or newfips="17167"
or newfips="18089"
or newfips="18097"
or newfips="19153"
or newfips="19193"
or newfips="20209"
or newfips="21111"
or newfips="22017"
or newfips="22019"
or newfips="22051"
or newfips="22071"
or newfips="22073"
or newfips="24510"
or newfips="25009"
or newfips="25013"
or newfips="25017"
or newfips="25025"
or newfips="26021"
or newfips="26049"
or newfips="26121"
or newfips="26163"
or newfips="27053"
or newfips="27123"
or newfips="28049"
or newfips="29047"
or newfips="29095"
or newfips="29165"
or newfips="29189"
or newfips="29510"
or newfips="31055"
or newfips="32003"
or newfips="33011"
or newfips="34007"
or newfips="34011"
or newfips="34013"
or newfips="34017"
or newfips="34039"
or newfips="35001"
or newfips="35013"
or newfips="36005"
or newfips="36029"
or newfips="36047"
or newfips="36055"
or newfips="36061"
or newfips="36063"
or newfips="36067"
or newfips="36071"
or newfips="36081"
or newfips="36085"
or newfips="36093"
or newfips="36119"
or newfips="37119"
or newfips="39017"
or newfips="39035"
or newfips="39045"
or newfips="39049"
or newfips="39061"
or newfips="39081"
or newfips="39087"
or newfips="39099"
or newfips="39153"
or newfips="40017"
or newfips="40027"
or newfips="40109"
or newfips="41051"
or newfips="42003"
or newfips="42043"
or newfips="42045"
or newfips="42101"
or newfips="44007"
or newfips="45019"
or newfips="45079"
or newfips="45085"
or newfips="47037"
or newfips="47065"
or newfips="47093"
or newfips="47157"
or newfips="48029"
or newfips="48085"
or newfips="48113"
or newfips="48121"
or newfips="48141"
or newfips="48157"
or newfips="48201"
or newfips="48245"
or newfips="48309"
or newfips="48355"
or newfips="48361"
or newfips="48439"
or newfips="48453"
or newfips="48491"
or newfips="49057"
or newfips="51710"
or newfips="51740"
or newfips="51760"
or newfips="53033"
or newfips="53053"
or newfips="53077"
or newfips="54009"
or newfips="54011"
or newfips="54039"
or newfips="54099"
or newfips="55079"

or newfips="01117"
or newfips="04027"
or newfips="08005"
or newfips="08059"
or newfips="08035"
or newfips="11031"
or newfips="12025"
or newfips="13063"
or newfips="13135"
or newfips="13177"
or newfips="17005"
or newfips="17043"
or newfips="17097"
or newfips="18057"
or newfips="24005"
or newfips="26125"
or newfips="27003"
or newfips="27163"
or newfips="28121"
or newfips="31153"
or newfips="32009"
or newfips="35043"
or newfips="36105"
or newfips="36001"
or newfips="36079"
or newfips="37179"
or newfips="39085"
or newfips="39041"
or newfips="39025"
or newfips="39155"
or newfips="41005"
or newfips="44003"
or newfips="45063"
or newfips="47187"
or newfips="48251"
or newfips="48367"
or newfips="51810"
or newfips="51041"
or newfips="51087"
or newfips="55133";
run;

**************3-B)Eliminating EINs that appear in both the SU(not submaster)
and MU files,keeping MU information suggested by Miranda(2002);
%let yr=1992;
proc sort data=work.ssllbd&yr OUT=work.ssllbd&yr;by EIN;
proc means data=work.ssllbd&yr noprint;
by EIN;
output out=work.dups(drop=_TYPE_ _FREQ_)
n(EMPLOYMENT)=EIN_COUNT;
run;

data ssllbd&yr;
merge work.ssllbd&yr (in=a) work.dups(in=b);
by EIN;
*We are concerned about EINs that are in the SU(not submaster) and MU;
if EIN_COUNT>1 & SU2=1 & PDIV^='M' then delete;
run;

*save the merged ssllbd data;
data "/rdcprojects/mc00535/data/ssllbd/ssllbd&yr "(compress=yes);
set ssllbd&yr;
drop fromlbd92_s fromlbd92_m frommussl92nt fromsussl92nt  SU2 MU2 srecnum mrecnum EIN_COUNT srecnumx mrecnumx recnumx mux stgeox ctygeox;
run;

proc datasets lib=work;
delete
dups lbd1992c lbd1992c_rec lbd92_m lbd92_s
mussl92nt sussl92nt mu_ssllbd1992 su_ssllbd1992
ssl1992mu ssl1992su ssllbd1992;
run;


