***DESCRIPTION
*This program combines MU-SSL,SU-SSL and LBD files for the years 1987-2001.Keeps the selected variables and counties in the list. Creates a newtract varible based on the information on SSEL;



 ******************************************YEAR:1993 ************************************************;
 *MACROS;
%let yr=1993;
libname BR '/economic/ssl/microdata/';
data ssl&yr.su;
set BR.ssl&yr.su;
run;

************************************************************;
************************************************************;
*(1) Single-Unit File;
************************************************************;
************************************************************;
%let yr=1993;
data ssl&yr.su(keep=  employment employmentsu payrollsu srecnum   pst salereceiptsu newtract mstreet
mplce mst mzip same_as
newtractsu actsu cfnsu lfosu sicsu zipsu blkgeosu blksfxsu cdgeosu ctygeosu indsu indsubsu lfo1su npisu pdivsu plcesu plgeosu ppnsu
sic56su stgeosu streetsu tocsu tractsu acfsu einsu 
AC943E AC943P acap ACEMP ACEMPF ACF ACSR1 ACSR1F ACSR2 ACSR2F ACSR3 ACSR3F
ACSR4 ACSR4F ACT ANNPR BLKGEO BLKSFX CDGEO CFN CTYGEO EIN EMPCD IND INDSUB
LFO LFO1   NPI PDIV PLCE PLGEO PPLCE PPN PSTREET PZIP
RECNUM SIC SIC56 SSABR
SSACL SSAEMP STGEO STREET TOC TRACT ZIP );	
 set BR.ssl&yr.su;
 *************Creating new tract variable;

length NEWTRACT $ 11;
If tract^=' ' & STGEO^=' ' & CTYGEO^=' ' then NEWTRACT=STGEO||CTYGEO||TRACT;
else newtract=" ";



Employment=ACEMP;
Employmentsu=ACEMP;
**************Exclude submasters;
if PDIV^='M';
*Exclude inactive units;
acap = ACQP1+ACQP2+ACQP3+ACQP4;
if acap>0| AC943P>0;

payrollsu =acap;
 srecnum=recnum;
salereceiptsu=acsr1;
*Identify the source of the common variables;
newtractsu=newtract;
actsu=act; cfnsu=cfn; lfosu=lfo ; sicsu=sic ;zipsu=zip; blkgeosu=blkgeo; blksfxsu=blksfx;
cdgeosu=cdgeo; ctygeosu=ctygeo; indsu=ind; indsubsu=indsub; lfo1su=lfo1;
 npisu=npi; pdivsu=pdiv; plcesu=plce; plgeosu=plgeo; ppnsu=ppn;
sic56su=sic56; stgeosu=stgeo; streetsu=street; tocsu=toc; tractsu=tract; acfsu=acf;
einsu=ein;
run;


*******
%let yr=1993;
libname BR '/economic/ssl/microdata/';
data ssl&yr.mu;
set BR.ssl&yr.mu;
run;


 *(2) Multi-Unit File;
************************************************************;
************************************************************;
%let yr=1993;
data ssl&yr.mu(keep=employment employmentmu payrollmu mrecnum  newtract  salereceiptmu  
 newtractmu actmu cfnmu lfomu sicmu zipmu blkgeomu blksfxmu cdgeomu ctygeomu indmu indsubmu lfo1mu npimu 
pdivmu plcemu plgeomu ppnmu
sic56mu stgeomu streetmu tocmu tractmu acfmu einmu
ACF ACT
BLKGEO BLKSFX CDGEO
CFN CTYGEO CYTE EIN GAT IND INDSUB LFO LFO1 NPI PDIV
PLCE PLGEO PPN RAP RAPF RECNUM REMP REMPF RSR RSRF
SIC	SIC56	STGEO	STREET	TOC TRACT ZIP);	
 set BR.ssl&yr.mu;
 *************Creating new tract variable;

length NEWTRACT $ 11;
If tract^=' ' & STGEO^=' ' & CTYGEO^=' ' then NEWTRACT=STGEO||CTYGEO||TRACT;
else newtract=" ";

**************Exclude ghosts;
if ACT^='G';
**************Exclude inactive units;
if rap>0| (rap=0 & (RAPF^='Z' & ACT^='D'));

EMPLOYMENT=REMP;
EMPLOYMENTmu=REMP;
PAYROLLmu=RAP;
salereceiptmu=RSR;	
mrecnum=recnum;
*Identify the source of the common variables;
newtractmu=newtract;
actmu=act; cfnmu=cfn; lfomu=lfo ; sicmu=sic ;zipmu=zip; blkgeomu=blkgeo; blksfxmu=blksfx;
cdgeomu=cdgeo; ctygeomu=ctygeo; indmu=ind; indsubmu=indsub; lfo1mu=lfo1;
 npimu=npi; pdivmu=pdiv; plcemu=plce; plgeomu=plgeo; ppnmu=ppn;
sic56mu=sic56; stgeomu=stgeo; streetmu=street; tocmu=toc; tractmu=tract; acfmu=acf;
einmu=ein;
run;
************************************************************;
************************************************************ ;



*LBD File;
************************************************************;
************************************************************;
%let yr=1993;
libname lbd '/economic/lbd/microdata';
data lbd&yr.c;
set lbd.lbd&yr.c;
*Drop missing recnum and MU observations;
recnumx=put(recnum,8.);
mux=put(mu,1.);
if recnumx^=' ';
if MUx^=' ';
*Exclude submasters in LBD coming from SU file;
if MU=0 & PDIV='M' then delete;

/*
*Exclude inactive units;
if PAY>0;
*/

*Exclude ghosts in LBD coming from MU file;
if ACT='G' & MU=1 then delete;
run;

**************Creating srecnum mrecnum variables in lbd file and keeping the selected variables;
%let yr=1993;
data work.lbd&yr.c_rec(keep= mrecnum srecnum  payrolllbd employmentlbd
actlbd cfnlbd lfolbd siclbd ziplbd 
ACT	BESTNAICs	BESTSIC	CFN	COUNTY	EMP	FIRMID	FIRSTYEAr	
FLAGA	FLAGB	
LASTYEAR LBDNUM	LFO	MU	PAY	RECNUM	SIC STATE YR ZIP);
set work.lbd&yr.c;

if MU=1 then MRECNUM=RECNUM;
if MU=0 then SRECNUM=RECNUM;

payrolllbd=pay;	
employmentlbd=emp;
actlbd=act;
 cfnlbd=cfn;
 lfolbd=lfo;
 siclbd=sic ;
ziplbd=zip; 
run;

**************Checking mu  in LBD;
%let yr=1993;
proc means data=lbd&yr.c_rec;
var mu;
where mu=1;
run;

%let yr=1993;
proc means data=lbd&yr.c_rec;
var mu;
where mu=0;
run;


**************Checking mrecnum and srecnum variables in SU-SSL and MU-SSL ;
%let yr=1993;
Proc means data=ssl&yr.mu;
var mrecnum;
run;
%let yr=1993;
Proc means data=ssl&yr.su;
var srecnum;
run;

************************************************************;
************************************************************;
*Merging SSL and LBD;
************************************************************;
************************************************************;
*************1)Combine SU SSL and LBD by srecnum;
%let yr=1993;
proc sort data=work.lbd&yr.c_rec out=lbd93_s;
by SRECNUM;
run;

proc sort data=work.ssl&yr.su out=sussl93nt;
by SRECNUM;
run;

data work.su_ssllbd1993;
merge lbd93_s(in=one) sussl93nt(in=two);
fromlbd93_s=one;
fromsussl93nt=two;
by SRECNUM;
run;

data work.su_ssllbd1993;
set work.su_ssllbd1993;
srecnumx=put(srecnum,8.);
recnumx=put(recnum,8.);
mux=put(mu,1.);
if recnumx^=' ';
if MUx^=' ';
if srecnumx^=' ';
RUN;

*************2)Combine MU SSL and LBD by Mrecnum;
%let yr=1993;
proc sort data=work.lbd&yr.c_rec out=lbd93_M;
by MRECNUM;
run;

proc sort data=work.ssl&yr.mu out=mussl93nt;
by MRECNUM;
run;

data work.mu_ssllbd1993;
merge lbd93_M(in=one) mussl93nt(in=two);
fromlbd93_m=one;
frommussl93nt =two;
by MRECNUM;
run;

data work.mu_ssllbd1993;
set work.mu_ssllbd1993;
mrecnumx=put(mrecnum,8.);
recnumx=put(recnum,8.);
mux=put(mu,1.);
if recnumx^=' ';
if MUx^=' ';
if mrecnumx^=' ';
RUN;


**************3-A)Combine SU-SSLLBD &MUSSL-LBD FILES;
%let yr=1993;
data ssllbd&yr.;
set work.su_ssllbd1993(in=a)
work.mu_ssllbd1993 (in=b);
if a then SU2=1;else SU2=0;
if b then MU2=1;else MU2=0;
year=&yr.;
run;



**Create a newfips variable;
%let yr=1993;
data ssllbd&yr;
length newfips $5;
set work.ssllbd&yr;
ctygeox=put(ctygeo,3.);
stgeox=put(stgeo,2.);
If ctygeox^=' ' & stgeox^=' ' then newfips=stgeox||ctygeox;
else newfips=" ";
run;

data ssllbd&yr;
set work.ssllbd&yr;
**Keeping the counties listed;
where newfips="01015"
or newfips="01073"
or newfips="01097"
or newfips="02090"
or newfips="04013"
or newfips="04019"
or newfips="05069"
or newfips="05119"
or newfips="06001"
or newfips="06019"
or newfips="06037"
or newfips="06059"
or newfips="06067"
or newfips="06073"
or newfips="06075"
or newfips="08001"
or newfips="08031"
or newfips="08123"
or newfips="09001"
or newfips="09003"
or newfips="09009"
or newfips="10003"
or newfips="11001"
or newfips="12011"
or newfips="12031"
or newfips="12057"
or newfips="12086"
or newfips="13051"
or newfips="13089"
or newfips="13095"
or newfips="13121"
or newfips="17031"
or newfips="17143"
or newfips="17163"
or newfips="17167"
or newfips="18089"
or newfips="18097"
or newfips="19153"
or newfips="19193"
or newfips="20209"
or newfips="21111"
or newfips="22017"
or newfips="22019"
or newfips="22051"
or newfips="22071"
or newfips="22073"
or newfips="24510"
or newfips="25009"
or newfips="25013"
or newfips="25017"
or newfips="25025"
or newfips="26021"
or newfips="26049"
or newfips="26121"
or newfips="26163"
or newfips="27053"
or newfips="27123"
or newfips="28049"
or newfips="29047"
or newfips="29095"
or newfips="29165"
or newfips="29189"
or newfips="29510"
or newfips="31055"
or newfips="32003"
or newfips="33011"
or newfips="34007"
or newfips="34011"
or newfips="34013"
or newfips="34017"
or newfips="34039"
or newfips="35001"
or newfips="35013"
or newfips="36005"
or newfips="36029"
or newfips="36047"
or newfips="36055"
or newfips="36061"
or newfips="36063"
or newfips="36067"
or newfips="36071"
or newfips="36081"
or newfips="36085"
or newfips="36093"
or newfips="36119"
or newfips="37119"
or newfips="39017"
or newfips="39035"
or newfips="39045"
or newfips="39049"
or newfips="39061"
or newfips="39081"
or newfips="39087"
or newfips="39099"
or newfips="39153"
or newfips="40017"
or newfips="40027"
or newfips="40109"
or newfips="41051"
or newfips="42003"
or newfips="42043"
or newfips="42045"
or newfips="42101"
or newfips="44007"
or newfips="45019"
or newfips="45079"
or newfips="45085"
or newfips="47037"
or newfips="47065"
or newfips="47093"
or newfips="47157"
or newfips="48029"
or newfips="48085"
or newfips="48113"
or newfips="48121"
or newfips="48141"
or newfips="48157"
or newfips="48201"
or newfips="48245"
or newfips="48309"
or newfips="48355"
or newfips="48361"
or newfips="48439"
or newfips="48453"
or newfips="48491"
or newfips="49057"
or newfips="51710"
or newfips="51740"
or newfips="51760"
or newfips="53033"
or newfips="53053"
or newfips="53077"
or newfips="54009"
or newfips="54011"
or newfips="54039"
or newfips="54099"
or newfips="55079"


or newfips="01117"
or newfips="04027"
or newfips="08005"
or newfips="08059"
or newfips="08035"
or newfips="11031"
or newfips="12025"
or newfips="13063"
or newfips="13135"
or newfips="13177"
or newfips="17005"
or newfips="17043"
or newfips="17097"
or newfips="18057"
or newfips="24005"
or newfips="26125"
or newfips="27003"
or newfips="27163"
or newfips="28121"
or newfips="31153"
or newfips="32009"
or newfips="35043"
or newfips="36105"
or newfips="36001"
or newfips="36079"
or newfips="37179"
or newfips="39085"
or newfips="39041"
or newfips="39025"
or newfips="39155"
or newfips="41005"
or newfips="44003"
or newfips="45063"
or newfips="47187"
or newfips="48251"
or newfips="48367"
or newfips="51810"
or newfips="51041"
or newfips="51087"
or newfips="55133";
run;
**************3-B)Eliminating EINs that appear in both the SU(not submaster)
and MU files,keeping MU information suggested by Miranda(2002);
%let yr=1993;
proc sort data=work.ssllbd&yr OUT=work.ssllbd&yr;by EIN;
proc means data=work.ssllbd&yr noprint;
by EIN;
output out=work.dups(drop=_TYPE_ _FREQ_)
n(EMPLOYMENT)=EIN_COUNT;
run;

data ssllbd&yr;
merge work.ssllbd&yr (in=a) work.dups(in=b);
by EIN;
*We are concerned about EINs that are in the SU(not submaster) and MU;
if EIN_COUNT>1 & SU2=1 & PDIV^='M' then delete;
run;

*save the merged ssllbd data;
data "/rdcprojects/mc00535/data/ssllbd/ssllbd&yr "(compress=yes);
set ssllbd&yr;
drop fromlbd93_s fromlbd93_m frommussl93nt fromsussl93nt  SU2 MU2 srecnum mrecnum EIN_COUNT srecnumx mrecnumx recnumx mux stgeox ctygeox;
run;

proc datasets lib=work;
delete
dups lbd1993c lbd1993c_rec lbd93_m lbd93_s
mussl93nt sussl93nt mu_ssllbd1993 su_ssllbd1993
ssl1993mu ssl1993su ssllbd1993;
run;




 ******************************************YEAR:1994 ************************************************;
 *MACROS;
%let yr=1994;
libname BR '/economic/ssl/microdata/';
data ssl&yr.su;
set BR.ssl&yr.su;
run;

************************************************************;
************************************************************;
*(1) Single-Unit File;
************************************************************;
************************************************************;
%let yr=1994;
data ssl&yr.su(keep=  employment employmentsu payrollsu srecnum   pst salereceiptsu newtract mstreet
mplce mst mzip same_as
newtractsu actsu cfnsu lfosu sicsu zipsu blkgeosu blksfxsu cdgeosu ctygeosu indsu indsubsu lfo1su npisu pdivsu plcesu plgeosu ppnsu
sic56su stgeosu streetsu tocsu tractsu acfsu einsu 
AC943E AC943P acap ACEMP ACEMPF ACF ACSR1 ACSR1F ACSR2 ACSR2F ACSR3 ACSR3F
ACSR4 ACSR4F ACT ANNPR BLKGEO BLKSFX CDGEO CFN CTYGEO EIN EMPCD IND INDSUB
LFO LFO1   NPI PDIV PLCE PLGEO PPLCE PPN PSTREET PZIP
RECNUM SIC SIC56 SSABR
SSACL SSAEMP STGEO STREET TOC TRACT ZIP );	
 set BR.ssl&yr.su;
 *************Creating new tract variable;

length NEWTRACT $ 11;
If tract^=' ' & STGEO^=' ' & CTYGEO^=' ' then NEWTRACT=STGEO||CTYGEO||TRACT;
else newtract=" ";



Employment=ACEMP;
Employmentsu=ACEMP;
**************Exclude submasters;
if PDIV^='M';
*Exclude inactive units;
acap = ACQP1+ACQP2+ACQP3+ACQP4;
if acap>0| AC943P>0;

payrollsu =acap;
 srecnum=recnum;
salereceiptsu=acsr1;
*Identify the source of the common variables;
newtractsu=newtract;
actsu=act; cfnsu=cfn; lfosu=lfo ; sicsu=sic ;zipsu=zip; blkgeosu=blkgeo; blksfxsu=blksfx;
cdgeosu=cdgeo; ctygeosu=ctygeo; indsu=ind; indsubsu=indsub; lfo1su=lfo1;
 npisu=npi; pdivsu=pdiv; plcesu=plce; plgeosu=plgeo; ppnsu=ppn;
sic56su=sic56; stgeosu=stgeo; streetsu=street; tocsu=toc; tractsu=tract; acfsu=acf;
einsu=ein;
run;


*******
%let yr=1994;
libname BR '/economic/ssl/microdata/';
data ssl&yr.mu;
set BR.ssl&yr.mu;
run;


 *(2) Multi-Unit File;
************************************************************;
************************************************************;
%let yr=1994;
data ssl&yr.mu(keep=employment employmentmu payrollmu mrecnum  newtract  salereceiptmu  
 newtractmu actmu cfnmu lfomu sicmu zipmu blkgeomu blksfxmu cdgeomu ctygeomu indmu indsubmu lfo1mu npimu 
pdivmu plcemu plgeomu ppnmu
sic56mu stgeomu streetmu tocmu tractmu acfmu einmu 
ACF ACT
BLKGEO BLKSFX CDGEO
CFN CTYGEO CYTE EIN GAT IND INDSUB LFO LFO1 NPI PDIV
PLCE PLGEO PPN RAP RAPF RECNUM REMP REMPF RSR RSRF
SIC	SIC56	STGEO	STREET	TOC TRACT ZIP);	
 set BR.ssl&yr.mu;
 *************Creating new tract variable;

length NEWTRACT $ 11;
If tract^=' ' & STGEO^=' ' & CTYGEO^=' ' then NEWTRACT=STGEO||CTYGEO||TRACT;
else newtract=" ";

**************Exclude ghosts;
if ACT^='G';
**************Exclude inactive units;
if rap>0| (rap=0 & (RAPF^='Z' & ACT^='D'));

EMPLOYMENT=REMP;
EMPLOYMENTmu=REMP;
PAYROLLmu=RAP;
salereceiptmu=RSR;	
mrecnum=recnum;
*Identify the source of the common variables;
newtractmu=newtract;
actmu=act; cfnmu=cfn; lfomu=lfo ; sicmu=sic ;zipmu=zip; blkgeomu=blkgeo; blksfxmu=blksfx;
cdgeomu=cdgeo; ctygeomu=ctygeo; indmu=ind; indsubmu=indsub; lfo1mu=lfo1;
 npimu=npi; pdivmu=pdiv; plcemu=plce; plgeomu=plgeo; ppnmu=ppn;
sic56mu=sic56; stgeomu=stgeo; streetmu=street; tocmu=toc; tractmu=tract; acfmu=acf;
einmu=ein;
run;
************************************************************;
************************************************************ ;



*LBD File;
************************************************************;
************************************************************;
%let yr=1994;
libname lbd '/economic/lbd/microdata';
data lbd&yr.c;
set lbd.lbd&yr.c;
*Drop missing recnum and MU observations;
recnumx=put(recnum,8.);
mux=put(mu,1.);
if recnumx^=' ';
if MUx^=' ';
*Exclude submasters in LBD coming from SU file;
if MU=0 & PDIV='M' then delete;

/*
*Exclude inactive units;
if PAY>0;
*/

*Exclude ghosts in LBD coming from MU file;
if ACT='G' & MU=1 then delete;
run;

**************Creating srecnum mrecnum variables in lbd file and keeping the selected variables;
%let yr=1994;
data work.lbd&yr.c_rec(keep= mrecnum srecnum  payrolllbd employmentlbd
actlbd cfnlbd lfolbd siclbd ziplbd 
ACT	BESTNAICs	BESTSIC	CFN	COUNTY	EMP	FIRMID	FIRSTYEAr	
FLAGA	FLAGB	
LASTYEAR LBDNUM	LFO	MU	PAY	RECNUM	SIC STATE YR ZIP);
set work.lbd&yr.c;

if MU=1 then MRECNUM=RECNUM;
if MU=0 then SRECNUM=RECNUM;

payrolllbd=pay;	
employmentlbd=emp;
actlbd=act;
 cfnlbd=cfn;
 lfolbd=lfo;
 siclbd=sic ;
ziplbd=zip; 
run;

**************Checking mu  in LBD;
%let yr=1994;
proc means data=lbd&yr.c_rec;
var mu;
where mu=1;
run;

%let yr=1994;
proc means data=lbd&yr.c_rec;
var mu;
where mu=0;
run;


**************Checking mrecnum and srecnum variables in SU-SSL and MU-SSL ;
%let yr=1994;
Proc means data=ssl&yr.mu;
var mrecnum;
run;
%let yr=1994;
Proc means data=ssl&yr.su;
var srecnum;
run;

************************************************************;
************************************************************;
*Merging SSL and LBD;
************************************************************;
************************************************************;
*************1)Combine SU SSL and LBD by srecnum;
%let yr=1994;
proc sort data=work.lbd&yr.c_rec out=lbd94_s;
by SRECNUM;
run;

proc sort data=work.ssl&yr.su out=sussl94nt;
by SRECNUM;
run;

data work.su_ssllbd1994;
merge lbd94_s(in=one) sussl94nt(in=two);
fromlbd94_s=one;
fromsussl94nt=two;
by SRECNUM;
run;

data work.su_ssllbd1994;
set work.su_ssllbd1994;
srecnumx=put(srecnum,8.);
recnumx=put(recnum,8.);
mux=put(mu,1.);
if recnumx^=' ';
if MUx^=' ';
if srecnumx^=' ';
RUN;

*************2)Combine MU SSL and LBD by Mrecnum;
%let yr=1994;
proc sort data=work.lbd&yr.c_rec out=lbd94_M;
by MRECNUM;
run;

proc sort data=work.ssl&yr.mu out=mussl94nt;
by MRECNUM;
run;

data work.mu_ssllbd1994;
merge lbd94_M(in=one) mussl94nt(in=two);
fromlbd94_m=one;
frommussl94nt =two;
by MRECNUM;
run;

data work.mu_ssllbd1994;
set work.mu_ssllbd1994;
mrecnumx=put(srecnum,8.);
recnumx=put(recnum,8.);
mux=put(mu,1.);
if recnumx^=' ';
if MUx^=' ';
if mrecnumx^=' ';
RUN;


**************3-A)Combine SU-SSLLBD &MUSSL-LBD FILES;
%let yr=1994;
data ssllbd&yr.;
set work.su_ssllbd1994(in=a)
work.mu_ssllbd1994 (in=b);
if a then SU2=1;else SU2=0;
if b then MU2=1;else MU2=0;
year=&yr.;
run;



**Create a newfips variable;
%let yr=1994;
data ssllbd&yr;
length newfips $5;
set work.ssllbd&yr;
ctygeox=put(ctygeo,3.);
stgeox=put(stgeo,2.);
If ctygeox^=' ' & stgeox^=' ' then newfips=stgeox||ctygeox;
else newfips=" ";
run;

data ssllbd&yr;
set work.ssllbd&yr;
**Keeping the counties listed;
where newfips="01015"
or newfips="01073"
or newfips="01097"
or newfips="02090"
or newfips="04013"
or newfips="04019"
or newfips="05069"
or newfips="05119"
or newfips="06001"
or newfips="06019"
or newfips="06037"
or newfips="06059"
or newfips="06067"
or newfips="06073"
or newfips="06075"
or newfips="08001"
or newfips="08031"
or newfips="08123"
or newfips="09001"
or newfips="09003"
or newfips="09009"
or newfips="10003"
or newfips="11001"
or newfips="12011"
or newfips="12031"
or newfips="12057"
or newfips="12086"
or newfips="13051"
or newfips="13089"
or newfips="13095"
or newfips="13121"
or newfips="17031"
or newfips="17143"
or newfips="17163"
or newfips="17167"
or newfips="18089"
or newfips="18097"
or newfips="19153"
or newfips="19193"
or newfips="20209"
or newfips="21111"
or newfips="22017"
or newfips="22019"
or newfips="22051"
or newfips="22071"
or newfips="22073"
or newfips="24510"
or newfips="25009"
or newfips="25013"
or newfips="25017"
or newfips="25025"
or newfips="26021"
or newfips="26049"
or newfips="26121"
or newfips="26163"
or newfips="27053"
or newfips="27123"
or newfips="28049"
or newfips="29047"
or newfips="29095"
or newfips="29165"
or newfips="29189"
or newfips="29510"
or newfips="31055"
or newfips="32003"
or newfips="33011"
or newfips="34007"
or newfips="34011"
or newfips="34013"
or newfips="34017"
or newfips="34039"
or newfips="35001"
or newfips="35013"
or newfips="36005"
or newfips="36029"
or newfips="36047"
or newfips="36055"
or newfips="36061"
or newfips="36063"
or newfips="36067"
or newfips="36071"
or newfips="36081"
or newfips="36085"
or newfips="36093"
or newfips="36119"
or newfips="37119"
or newfips="39017"
or newfips="39035"
or newfips="39045"
or newfips="39049"
or newfips="39061"
or newfips="39081"
or newfips="39087"
or newfips="39099"
or newfips="39153"
or newfips="40017"
or newfips="40027"
or newfips="40109"
or newfips="41051"
or newfips="42003"
or newfips="42043"
or newfips="42045"
or newfips="42101"
or newfips="44007"
or newfips="45019"
or newfips="45079"
or newfips="45085"
or newfips="47037"
or newfips="47065"
or newfips="47093"
or newfips="47157"
or newfips="48029"
or newfips="48085"
or newfips="48113"
or newfips="48121"
or newfips="48141"
or newfips="48157"
or newfips="48201"
or newfips="48245"
or newfips="48309"
or newfips="48355"
or newfips="48361"
or newfips="48439"
or newfips="48453"
or newfips="48491"
or newfips="49057"
or newfips="51710"
or newfips="51740"
or newfips="51760"
or newfips="53033"
or newfips="53053"
or newfips="53077"
or newfips="54009"
or newfips="54011"
or newfips="54039"
or newfips="54099"
or newfips="55079"

or newfips="01117"
or newfips="04027"
or newfips="08005"
or newfips="08059"
or newfips="08035"
or newfips="11031"
or newfips="12025"
or newfips="13063"
or newfips="13135"
or newfips="13177"
or newfips="17005"
or newfips="17043"
or newfips="17097"
or newfips="18057"
or newfips="24005"
or newfips="26125"
or newfips="27003"
or newfips="27163"
or newfips="28121"
or newfips="31153"
or newfips="32009"
or newfips="35043"
or newfips="36105"
or newfips="36001"
or newfips="36079"
or newfips="37179"
or newfips="39085"
or newfips="39041"
or newfips="39025"
or newfips="39155"
or newfips="41005"
or newfips="44003"
or newfips="45063"
or newfips="47187"
or newfips="48251"
or newfips="48367"
or newfips="51810"
or newfips="51041"
or newfips="51087"
or newfips="55133";
run;

**************3-B)Eliminating EINs that appear in both the SU(not submaster)
and MU files,keeping MU information suggested by Miranda(2002);
%let yr=1994;
proc sort data=work.ssllbd&yr OUT=work.ssllbd&yr;by EIN;
proc means data=work.ssllbd&yr noprint;
by EIN;
output out=work.dups(drop=_TYPE_ _FREQ_)
n(EMPLOYMENT)=EIN_COUNT;
run;

data ssllbd&yr;
merge work.ssllbd&yr (in=a) work.dups(in=b);
by EIN;
*We are concerned about EINs that are in the SU(not submaster) and MU;
if EIN_COUNT>1 & SU2=1 & PDIV^='M' then delete;
run;

*save the merged ssllbd data;
data "/rdcprojects/mc00535/data/ssllbd/ssllbd&yr "(compress=yes);
set ssllbd&yr;
drop fromlbd94_s fromlbd94_m frommussl94nt fromsussl94nt  SU2 MU2 srecnum mrecnum EIN_COUNT srecnumx mrecnumx recnumx mux stgeox ctygeox;
run;

proc datasets lib=work;
delete
dups lbd1994c lbd1994c_rec lbd94_m lbd94_s
mussl94nt sussl94nt mu_ssllbd1994 su_ssllbd1994
ssl1994mu ssl1994su ssllbd1994;
run;




 ******************************************YEAR:1995 ************************************************;
 *MACROS;
%let yr=1995;
libname BR '/economic/ssl/microdata/';
data ssl&yr.su;
set BR.ssl&yr.su;
run;

************************************************************;
************************************************************;
*(1) Single-Unit File;
************************************************************;
************************************************************;
%let yr=1995;
data ssl&yr.su(keep=  employment employmentsu payrollsu srecnum   pst salereceiptsu newtract mstreet
mplce mst mzip same_as
newtractsu actsu cfnsu lfosu sicsu zipsu blkgeosu blksfxsu cdgeosu ctygeosu indsu indsubsu lfo1su npisu pdivsu plcesu plgeosu ppnsu
sic56su stgeosu streetsu tocsu tractsu acfsu einsu 
AC943E AC943P acap ACEMP ACEMPF ACF ACSR1 ACSR1F ACSR2 ACSR2F ACSR3 ACSR3F
ACSR4 ACSR4F ACT ANNPR BLKGEO BLKSFX CDGEO CFN CTYGEO EIN EMPCD IND INDSUB
LFO LFO1   NPI PDIV PLCE PLGEO PPLCE PPN PSTREET PZIP
RECNUM SIC SIC56 SSABR
SSACL SSAEMP STGEO STREET TOC TRACT ZIP );	
 set BR.ssl&yr.su;
 *************Creating new tract variable;

length NEWTRACT $ 11;
If tract^=' ' & STGEO^=' ' & CTYGEO^=' ' then NEWTRACT=STGEO||CTYGEO||TRACT;
else newtract=" ";



Employment=ACEMP;
Employmentsu=ACEMP;
**************Exclude submasters;
if PDIV^='M';
*Exclude inactive units;
acap = ACQP1+ACQP2+ACQP3+ACQP4;
if acap>0| AC943P>0;

payrollsu =acap;
 srecnum=recnum;
salereceiptsu=acsr1;
*Identify the source of the common variables;
newtractsu=newtract;
actsu=act; cfnsu=cfn; lfosu=lfo ; sicsu=sic ;zipsu=zip; blkgeosu=blkgeo; blksfxsu=blksfx;
cdgeosu=cdgeo; ctygeosu=ctygeo; indsu=ind; indsubsu=indsub; lfo1su=lfo1;
 npisu=npi; pdivsu=pdiv; plcesu=plce; plgeosu=plgeo; ppnsu=ppn;
sic56su=sic56; stgeosu=stgeo; streetsu=street; tocsu=toc; tractsu=tract; acfsu=acf;
einsu=ein;
run;


*******
%let yr=1995;
libname BR '/economic/ssl/microdata/';
data ssl&yr.mu;
set BR.ssl&yr.mu;
run;


 *(2) Multi-Unit File;
************************************************************;
************************************************************;
%let yr=1995;
data ssl&yr.mu(keep=employment employmentmu payrollmu mrecnum  newtract  salereceiptmu  
 newtractmu actmu cfnmu lfomu sicmu zipmu blkgeomu blksfxmu cdgeomu ctygeomu indmu indsubmu lfo1mu npimu 
pdivmu plcemu plgeomu ppnmu
sic56mu stgeomu streetmu tocmu tractmu acfmu einmu 
ACF ACT
BLKGEO BLKSFX CDGEO
CFN CTYGEO CYTE EIN GAT IND INDSUB LFO LFO1 NPI PDIV
PLCE PLGEO PPN RAP RAPF RECNUM REMP REMPF RSR RSRF
SIC	SIC56	STGEO	STREET	TOC TRACT ZIP);	
 set BR.ssl&yr.mu;
 *************Creating new tract variable;

length NEWTRACT $ 11;
If tract^=' ' & STGEO^=' ' & CTYGEO^=' ' then NEWTRACT=STGEO||CTYGEO||TRACT;
else newtract=" ";

**************Exclude ghosts;
if ACT^='G';
**************Exclude inactive units;
if rap>0| (rap=0 & (RAPF^='Z' & ACT^='D'));

EMPLOYMENT=REMP;
EMPLOYMENTmu=REMP;
PAYROLLmu=RAP;
salereceiptmu=RSR;	
mrecnum=recnum;
*Identify the source of the common variables;
newtractmu=newtract;
actmu=act; cfnmu=cfn; lfomu=lfo ; sicmu=sic ;zipmu=zip; blkgeomu=blkgeo; blksfxmu=blksfx;
cdgeomu=cdgeo; ctygeomu=ctygeo; indmu=ind; indsubmu=indsub; lfo1mu=lfo1;
 npimu=npi; pdivmu=pdiv; plcemu=plce; plgeomu=plgeo; ppnmu=ppn;
sic56mu=sic56; stgeomu=stgeo; streetmu=street; tocmu=toc; tractmu=tract; acfmu=acf;
einmu=ein;
run;
************************************************************;
************************************************************ ;



*LBD File;
************************************************************;
************************************************************;
%let yr=1995;
libname lbd '/economic/lbd/microdata';
data lbd&yr.c;
set lbd.lbd&yr.c;
*Drop missing recnum and MU observations;
recnumx=put(recnum,8.);
mux=put(mu,1.);
if recnumx^=' ';
if MUx^=' ';
*Exclude submasters in LBD coming from SU file;
if MU=0 & PDIV='M' then delete;

/*
*Exclude inactive units;
if PAY>0;
*/

*Exclude ghosts in LBD coming from MU file;
if ACT='G' & MU=1 then delete;
run;

**************Creating srecnum mrecnum variables in lbd file and keeping the selected variables;
%let yr=1995;
data work.lbd&yr.c_rec(keep= mrecnum srecnum  payrolllbd employmentlbd
actlbd cfnlbd lfolbd siclbd ziplbd 
ACT	BESTNAICs	BESTSIC	CFN	COUNTY	EMP	FIRMID	FIRSTYEAr	
FLAGA	FLAGB	
LASTYEAR LBDNUM	LFO	MU	PAY	RECNUM	SIC STATE YR ZIP);
set work.lbd&yr.c;

if MU=1 then MRECNUM=RECNUM;
if MU=0 then SRECNUM=RECNUM;

payrolllbd=pay;	
employmentlbd=emp;
actlbd=act;
 cfnlbd=cfn;
 lfolbd=lfo;
 siclbd=sic ;
ziplbd=zip; 
run;

**************Checking mu  in LBD;
%let yr=1995;
proc means data=lbd&yr.c_rec;
var mu;
where mu=1;
run;

%let yr=1995;
proc means data=lbd&yr.c_rec;
var mu;
where mu=0;
run;


**************Checking mrecnum and srecnum variables in SU-SSL and MU-SSL ;
%let yr=1995;
Proc means data=ssl&yr.mu;
var mrecnum;
run;
%let yr=1995;
Proc means data=ssl&yr.su;
var srecnum;
run;

************************************************************;
************************************************************;
*Merging SSL and LBD;
************************************************************;
************************************************************;
*************1)Combine SU SSL and LBD by srecnum;
%let yr=1995;
proc sort data=work.lbd&yr.c_rec out=lbd95_s;
by SRECNUM;
run;

proc sort data=work.ssl&yr.su out=sussl95nt;
by SRECNUM;
run;

data work.su_ssllbd1995;
merge lbd95_s(in=one) sussl95nt(in=two);
fromlbd95_s=one;
fromsussl95nt=two;
by SRECNUM;
run;

data work.su_ssllbd1995;
set work.su_ssllbd1995;
srecnumx=put(srecnum,8.);
recnumx=put(recnum,8.);
mux=put(mu,1.);
if recnumx^=' ';
if MUx^=' ';
if srecnumx^=' ';
RUN;

*************2)Combine MU SSL and LBD by Mrecnum;
%let yr=1995;
proc sort data=work.lbd&yr.c_rec out=lbd95_M;
by MRECNUM;
run;

proc sort data=work.ssl&yr.mu out=mussl95nt;
by MRECNUM;
run;

data work.mu_ssllbd1995;
merge lbd95_M(in=one) mussl95nt(in=two);
fromlbd95_m=one;
frommussl95nt =two;
by MRECNUM;
run;

data work.mu_ssllbd1995;
set work.mu_ssllbd1995;
mrecnumx=put(mrecnum,8.);
recnumx=put(recnum,8.);
mux=put(mu,1.);
if recnumx^=' ';
if MUx^=' ';
if mrecnumx^=' ';
RUN;


**************3-A)Combine SU-SSLLBD &MUSSL-LBD FILES;
%let yr=1995;
data ssllbd&yr.;
set work.su_ssllbd1995(in=a)
work.mu_ssllbd1995 (in=b);
if a then SU2=1;else SU2=0;
if b then MU2=1;else MU2=0;
year=&yr.;
run;



**Create a newfips variable;
%let yr=1995;
data ssllbd&yr;
length newfips $5;
set work.ssllbd&yr;
ctygeox=put(ctygeo,3.);
stgeox=put(stgeo,2.);
If ctygeox^=' ' & stgeox^=' ' then newfips=stgeox||ctygeox;
else newfips=" ";
run;


data ssllbd&yr;
set work.ssllbd&yr;
**Keeping the counties listed;
where newfips="01015"
or newfips="01073"
or newfips="01097"
or newfips="02090"
or newfips="04013"
or newfips="04019"
or newfips="05069"
or newfips="05119"
or newfips="06001"
or newfips="06019"
or newfips="06037"
or newfips="06059"
or newfips="06067"
or newfips="06073"
or newfips="06075"
or newfips="08001"
or newfips="08031"
or newfips="08123"
or newfips="09001"
or newfips="09003"
or newfips="09009"
or newfips="10003"
or newfips="11001"
or newfips="12011"
or newfips="12031"
or newfips="12057"
or newfips="12086"
or newfips="13051"
or newfips="13089"
or newfips="13095"
or newfips="13121"
or newfips="17031"
or newfips="17143"
or newfips="17163"
or newfips="17167"
or newfips="18089"
or newfips="18097"
or newfips="19153"
or newfips="19193"
or newfips="20209"
or newfips="21111"
or newfips="22017"
or newfips="22019"
or newfips="22051"
or newfips="22071"
or newfips="22073"
or newfips="24510"
or newfips="25009"
or newfips="25013"
or newfips="25017"
or newfips="25025"
or newfips="26021"
or newfips="26049"
or newfips="26121"
or newfips="26163"
or newfips="27053"
or newfips="27123"
or newfips="28049"
or newfips="29047"
or newfips="29095"
or newfips="29165"
or newfips="29189"
or newfips="29510"
or newfips="31055"
or newfips="32003"
or newfips="33011"
or newfips="34007"
or newfips="34011"
or newfips="34013"
or newfips="34017"
or newfips="34039"
or newfips="35001"
or newfips="35013"
or newfips="36005"
or newfips="36029"
or newfips="36047"
or newfips="36055"
or newfips="36061"
or newfips="36063"
or newfips="36067"
or newfips="36071"
or newfips="36081"
or newfips="36085"
or newfips="36093"
or newfips="36119"
or newfips="37119"
or newfips="39017"
or newfips="39035"
or newfips="39045"
or newfips="39049"
or newfips="39061"
or newfips="39081"
or newfips="39087"
or newfips="39099"
or newfips="39153"
or newfips="40017"
or newfips="40027"
or newfips="40109"
or newfips="41051"
or newfips="42003"
or newfips="42043"
or newfips="42045"
or newfips="42101"
or newfips="44007"
or newfips="45019"
or newfips="45079"
or newfips="45085"
or newfips="47037"
or newfips="47065"
or newfips="47093"
or newfips="47157"
or newfips="48029"
or newfips="48085"
or newfips="48113"
or newfips="48121"
or newfips="48141"
or newfips="48157"
or newfips="48201"
or newfips="48245"
or newfips="48309"
or newfips="48355"
or newfips="48361"
or newfips="48439"
or newfips="48453"
or newfips="48491"
or newfips="49057"
or newfips="51710"
or newfips="51740"
or newfips="51760"
or newfips="53033"
or newfips="53053"
or newfips="53077"
or newfips="54009"
or newfips="54011"
or newfips="54039"
or newfips="54099"
or newfips="55079"

or newfips="01117"
or newfips="04027"
or newfips="08005"
or newfips="08059"
or newfips="08035"
or newfips="11031"
or newfips="12025"
or newfips="13063"
or newfips="13135"
or newfips="13177"
or newfips="17005"
or newfips="17043"
or newfips="17097"
or newfips="18057"
or newfips="24005"
or newfips="26125"
or newfips="27003"
or newfips="27163"
or newfips="28121"
or newfips="31153"
or newfips="32009"
or newfips="35043"
or newfips="36105"
or newfips="36001"
or newfips="36079"
or newfips="37179"
or newfips="39085"
or newfips="39041"
or newfips="39025"
or newfips="39155"
or newfips="41005"
or newfips="44003"
or newfips="45063"
or newfips="47187"
or newfips="48251"
or newfips="48367"
or newfips="51810"
or newfips="51041"
or newfips="51087"
or newfips="55133";
run;

**************3-B)Eliminating EINs that appear in both the SU(not submaster)
and MU files,keeping MU information suggested by Miranda(2002);
%let yr=1995;
proc sort data=work.ssllbd&yr OUT=work.ssllbd&yr;by EIN;
proc means data=work.ssllbd&yr noprint;
by EIN;
output out=work.dups(drop=_TYPE_ _FREQ_)
n(EMPLOYMENT)=EIN_COUNT;
run;

data ssllbd&yr;
merge work.ssllbd&yr (in=a) work.dups(in=b);
by EIN;
*We are concerned about EINs that are in the SU(not submaster) and MU;
if EIN_COUNT>1 & SU2=1 & PDIV^='M' then delete;
run;

*save the merged ssllbd data;
data "/rdcprojects/mc00535/data/ssllbd/ssllbd&yr "(compress=yes);
set ssllbd&yr;
drop fromlbd95_s fromlbd95_m frommussl95nt fromsussl95nt  SU2 MU2 srecnum mrecnum EIN_COUNT srecnumx mrecnumx recnumx mux stgeox ctygeox;
run;

proc datasets lib=work;
delete
dups lbd1995c lbd1995c_rec lbd95_m lbd95_s
mussl95nt sussl95nt mu_ssllbd1995 su_ssllbd1995
ssl1995mu ssl1995su ssllbd1995;
run;




 ******************************************YEAR:1996 ************************************************;
 *MACROS;
%let yr=1996;
libname BR '/economic/ssl/microdata/';
data ssl&yr.su;
set BR.ssl&yr.su;
run;

************************************************************;
************************************************************;
*(1) Single-Unit File;
************************************************************;
************************************************************;
%let yr=1996;
data ssl&yr.su(keep=  employment employmentsu payrollsu srecnum   pst salereceiptsu newtract mstreet
mplce mst mzip same_as
newtractsu actsu cfnsu lfosu sicsu zipsu blkgeosu blksfxsu cdgeosu ctygeosu indsu indsubsu lfo1su npisu pdivsu plcesu plgeosu ppnsu
sic56su stgeosu streetsu tocsu tractsu acfsu einsu 
AC943E AC943P acap ACEMP ACEMPF ACF ACSR1 ACSR1F ACSR2 ACSR2F ACSR3 ACSR3F
ACSR4 ACSR4F ACT ANNPR BLKGEO BLKSFX CDGEO CFN CTYGEO EIN EMPCD IND INDSUB
LFO LFO1   NPI PDIV PLCE PLGEO PPLCE PPN PSTREET PZIP
RECNUM SIC SIC56 SSABR
SSACL SSAEMP STGEO STREET TOC TRACT ZIP );	
 set BR.ssl&yr.su;
 *************Creating new tract variable;

length NEWTRACT $ 11;
If tract^=' ' & STGEO^=' ' & CTYGEO^=' ' then NEWTRACT=STGEO||CTYGEO||TRACT;
else newtract=" ";



Employment=ACEMP;
Employmentsu=ACEMP;
**************Exclude submasters;
if PDIV^='M';
*Exclude inactive units;
acap = ACQP1+ACQP2+ACQP3+ACQP4;
if acap>0| AC943P>0;

payrollsu =acap;
 srecnum=recnum;
salereceiptsu=acsr1;
*Identify the source of the common variables;
newtractsu=newtract;
actsu=act; cfnsu=cfn; lfosu=lfo ; sicsu=sic ;zipsu=zip; blkgeosu=blkgeo; blksfxsu=blksfx;
cdgeosu=cdgeo; ctygeosu=ctygeo; indsu=ind; indsubsu=indsub; lfo1su=lfo1;
 npisu=npi; pdivsu=pdiv; plcesu=plce; plgeosu=plgeo; ppnsu=ppn;
sic56su=sic56; stgeosu=stgeo; streetsu=street; tocsu=toc; tractsu=tract; acfsu=acf;
einsu=ein;
run;


*******
%let yr=1996;
libname BR '/economic/ssl/microdata/';
data ssl&yr.mu;
set BR.ssl&yr.mu;
run;


 *(2) Multi-Unit File;
************************************************************;
************************************************************;
%let yr=1996;
data ssl&yr.mu(keep=employment employmentmu payrollmu mrecnum  newtract  salereceiptmu  
 newtractmu actmu cfnmu lfomu sicmu zipmu blkgeomu blksfxmu cdgeomu ctygeomu indmu indsubmu lfo1mu npimu 
pdivmu plcemu plgeomu ppnmu
sic56mu stgeomu streetmu tocmu tractmu acfmu einmu
ACF ACT
BLKGEO BLKSFX CDGEO
CFN CTYGEO CYTE EIN GAT IND INDSUB LFO LFO1 NPI PDIV
PLCE PLGEO PPN RAP RAPF RECNUM REMP REMPF RSR RSRF
SIC	SIC56	STGEO	STREET	TOC TRACT ZIP);	
 set BR.ssl&yr.mu;
 *************Creating new tract variable;

length NEWTRACT $ 11;
If tract^=' ' & STGEO^=' ' & CTYGEO^=' ' then NEWTRACT=STGEO||CTYGEO||TRACT;
else newtract=" ";

**************Exclude ghosts;
if ACT^='G';
**************Exclude inactive units;
if rap>0| (rap=0 & (RAPF^='Z' & ACT^='D'));

EMPLOYMENT=REMP;
EMPLOYMENTmu=REMP;
PAYROLLmu=RAP;
salereceiptmu=RSR;	
mrecnum=recnum;
*Identify the source of the common variables;
newtractmu=newtract;
actmu=act; cfnmu=cfn; lfomu=lfo ; sicmu=sic ;zipmu=zip; blkgeomu=blkgeo; blksfxmu=blksfx;
cdgeomu=cdgeo; ctygeomu=ctygeo; indmu=ind; indsubmu=indsub; lfo1mu=lfo1;
 npimu=npi; pdivmu=pdiv; plcemu=plce; plgeomu=plgeo; ppnmu=ppn;
sic56mu=sic56; stgeomu=stgeo; streetmu=street; tocmu=toc; tractmu=tract; acfmu=acf;
einmu=ein;
run;
************************************************************;
************************************************************ ;



*LBD File;
************************************************************;
************************************************************;
%let yr=1996;
libname lbd '/economic/lbd/microdata';
data lbd&yr.c;
set lbd.lbd&yr.c;
*Drop missing recnum and MU observations;
recnumx=put(recnum,8.);
mux=put(mu,1.);
if recnumx^=' ';
if MUx^=' ';
*Exclude submasters in LBD coming from SU file;
if MU=0 & PDIV='M' then delete;

/*
*Exclude inactive units;
if PAY>0;
*/

*Exclude ghosts in LBD coming from MU file;
if ACT='G' & MU=1 then delete;
run;

**************Creating srecnum mrecnum variables in lbd file and keeping the selected variables;
%let yr=1996;
data work.lbd&yr.c_rec(keep= mrecnum srecnum  payrolllbd employmentlbd
actlbd cfnlbd lfolbd siclbd ziplbd 
ACT	BESTNAICs	BESTSIC	CFN	COUNTY	EMP	FIRMID	FIRSTYEAr	
FLAGA	FLAGB	
LASTYEAR LBDNUM	LFO	MU	PAY	RECNUM	SIC STATE YR ZIP);
set work.lbd&yr.c;

if MU=1 then MRECNUM=RECNUM;
if MU=0 then SRECNUM=RECNUM;

payrolllbd=pay;	
employmentlbd=emp;
actlbd=act;
 cfnlbd=cfn;
 lfolbd=lfo;
 siclbd=sic ;
ziplbd=zip; 
run;

**************Checking mu  in LBD;
%let yr=1996;
proc means data=lbd&yr.c_rec;
var mu;
where mu=1;
run;

%let yr=1996;
proc means data=lbd&yr.c_rec;
var mu;
where mu=0;
run;


**************Checking mrecnum and srecnum variables in SU-SSL and MU-SSL ;
%let yr=1996;
Proc means data=ssl&yr.mu;
var mrecnum;
run;
%let yr=1996;
Proc means data=ssl&yr.su;
var srecnum;
run;

************************************************************;
************************************************************;
*Merging SSL and LBD;
************************************************************;
************************************************************;
*************1)Combine SU SSL and LBD by srecnum;
%let yr=1996;
proc sort data=work.lbd&yr.c_rec out=lbd96_s;
by SRECNUM;
run;

proc sort data=work.ssl&yr.su out=sussl96nt;
by SRECNUM;
run;

data work.su_ssllbd1996;
merge lbd96_s(in=one) sussl96nt(in=two);
fromlbd96_s=one;
fromsussl96nt=two;
by SRECNUM;
run;

data work.su_ssllbd1996;
set work.su_ssllbd1996;
srecnumx=put(srecnum,8.);
recnumx=put(recnum,8.);
mux=put(mu,1.);
if recnumx^=' ';
if MUx^=' ';
if srecnumx^=' ';
RUN;

*************2)Combine MU SSL and LBD by Mrecnum;
%let yr=1996;
proc sort data=work.lbd&yr.c_rec out=lbd96_M;
by MRECNUM;
run;

proc sort data=work.ssl&yr.mu out=mussl96nt;
by MRECNUM;
run;

data work.mu_ssllbd1996;
merge lbd96_M(in=one) mussl96nt(in=two);
fromlbd96_m=one;
frommussl96nt =two;
by MRECNUM;
run;

data work.mu_ssllbd1996;
set work.mu_ssllbd1996;
mrecnumx=put(srecnum,8.);
recnumx=put(recnum,8.);
mux=put(mu,1.);
if recnumx^=' ';
if MUx^=' ';
if mrecnumx^=' ';
RUN;


**************3-A)Combine SU-SSLLBD &MUSSL-LBD FILES;
%let yr=1996;
data ssllbd&yr.;
set work.su_ssllbd1996(in=a)
work.mu_ssllbd1996 (in=b);
if a then SU2=1;else SU2=0;
if b then MU2=1;else MU2=0;
year=&yr.;
run;



**Create a newfips variable;
%let yr=1996;
data ssllbd&yr;
length newfips $5;
set work.ssllbd&yr;
ctygeox=put(ctygeo,3.);
stgeox=put(stgeo,2.);
If ctygeox^=' ' & stgeox^=' ' then newfips=stgeox||ctygeox;
else newfips=" ";
run;


data ssllbd&yr;
set work.ssllbd&yr;
**Keeping the counties listed;
where newfips="01015"
or newfips="01073"
or newfips="01097"
or newfips="02090"
or newfips="04013"
or newfips="04019"
or newfips="05069"
or newfips="05119"
or newfips="06001"
or newfips="06019"
or newfips="06037"
or newfips="06059"
or newfips="06067"
or newfips="06073"
or newfips="06075"
or newfips="08001"
or newfips="08031"
or newfips="08123"
or newfips="09001"
or newfips="09003"
or newfips="09009"
or newfips="10003"
or newfips="11001"
or newfips="12011"
or newfips="12031"
or newfips="12057"
or newfips="12086"
or newfips="13051"
or newfips="13089"
or newfips="13095"
or newfips="13121"
or newfips="17031"
or newfips="17143"
or newfips="17163"
or newfips="17167"
or newfips="18089"
or newfips="18097"
or newfips="19153"
or newfips="19193"
or newfips="20209"
or newfips="21111"
or newfips="22017"
or newfips="22019"
or newfips="22051"
or newfips="22071"
or newfips="22073"
or newfips="24510"
or newfips="25009"
or newfips="25013"
or newfips="25017"
or newfips="25025"
or newfips="26021"
or newfips="26049"
or newfips="26121"
or newfips="26163"
or newfips="27053"
or newfips="27123"
or newfips="28049"
or newfips="29047"
or newfips="29095"
or newfips="29165"
or newfips="29189"
or newfips="29510"
or newfips="31055"
or newfips="32003"
or newfips="33011"
or newfips="34007"
or newfips="34011"
or newfips="34013"
or newfips="34017"
or newfips="34039"
or newfips="35001"
or newfips="35013"
or newfips="36005"
or newfips="36029"
or newfips="36047"
or newfips="36055"
or newfips="36061"
or newfips="36063"
or newfips="36067"
or newfips="36071"
or newfips="36081"
or newfips="36085"
or newfips="36093"
or newfips="36119"
or newfips="37119"
or newfips="39017"
or newfips="39035"
or newfips="39045"
or newfips="39049"
or newfips="39061"
or newfips="39081"
or newfips="39087"
or newfips="39099"
or newfips="39153"
or newfips="40017"
or newfips="40027"
or newfips="40109"
or newfips="41051"
or newfips="42003"
or newfips="42043"
or newfips="42045"
or newfips="42101"
or newfips="44007"
or newfips="45019"
or newfips="45079"
or newfips="45085"
or newfips="47037"
or newfips="47065"
or newfips="47093"
or newfips="47157"
or newfips="48029"
or newfips="48085"
or newfips="48113"
or newfips="48121"
or newfips="48141"
or newfips="48157"
or newfips="48201"
or newfips="48245"
or newfips="48309"
or newfips="48355"
or newfips="48361"
or newfips="48439"
or newfips="48453"
or newfips="48491"
or newfips="49057"
or newfips="51710"
or newfips="51740"
or newfips="51760"
or newfips="53033"
or newfips="53053"
or newfips="53077"
or newfips="54009"
or newfips="54011"
or newfips="54039"
or newfips="54099"
or newfips="55079"


or newfips="01117"
or newfips="04027"
or newfips="08005"
or newfips="08059"
or newfips="08035"
or newfips="11031"
or newfips="12025"
or newfips="13063"
or newfips="13135"
or newfips="13177"
or newfips="17005"
or newfips="17043"
or newfips="17097"
or newfips="18057"
or newfips="24005"
or newfips="26125"
or newfips="27003"
or newfips="27163"
or newfips="28121"
or newfips="31153"
or newfips="32009"
or newfips="35043"
or newfips="36105"
or newfips="36001"
or newfips="36079"
or newfips="37179"
or newfips="39085"
or newfips="39041"
or newfips="39025"
or newfips="39155"
or newfips="41005"
or newfips="44003"
or newfips="45063"
or newfips="47187"
or newfips="48251"
or newfips="48367"
or newfips="51810"
or newfips="51041"
or newfips="51087"
or newfips="55133";
run;


**************3-B)Eliminating EINs that appear in both the SU(not submaster)
and MU files,keeping MU information suggested by Miranda(2002);
%let yr=1996;
proc sort data=work.ssllbd&yr OUT=work.ssllbd&yr;by EIN;
proc means data=work.ssllbd&yr noprint;
by EIN;
output out=work.dups(drop=_TYPE_ _FREQ_)
n(EMPLOYMENT)=EIN_COUNT;
run;

data ssllbd&yr;
merge work.ssllbd&yr (in=a) work.dups(in=b);
by EIN;
*We are concerned about EINs that are in the SU(not submaster) and MU;
if EIN_COUNT>1 & SU2=1 & PDIV^='M' then delete;
run;



*save the merged ssllbd data;
data "/rdcprojects/mc00535/data/ssllbd/ssllbd&yr "(compress=yes);
set ssllbd&yr;
drop fromlbd96_s fromlbd96_m frommussl96nt fromsussl96nt  SU2 MU2 srecnum mrecnum EIN_COUNT srecnumx mrecnumx recnumx mux stgeox ctygeox;
run;

proc datasets lib=work;
delete
dups lbd1996c lbd1996c_rec lbd96_m lbd96_s
mussl96nt sussl96nt mu_ssllbd1996 su_ssllbd1996
ssl1996mu ssl1996su ssllbd1996;
run;





 ******************************************YEAR:1997 ************************************************;
 *MACROS;
%let yr=1997;
libname BR '/economic/ssl/microdata/';
data ssl&yr.su;
set BR.ssl&yr.su;
run;

************************************************************;
************************************************************;
*(1) Single-Unit File;
************************************************************;
************************************************************;
%let yr=1997;
data ssl&yr.su(keep=  employment employmentsu payrollsu srecnum   pst salereceiptsu newtract mstreet
mplce mst mzip same_as
newtractsu actsu cfnsu lfosu sicsu zipsu blkgeosu blksfxsu cdgeosu ctygeosu indsu indsubsu lfo1su npisu pdivsu plcesu plgeosu ppnsu
sic56su stgeosu streetsu tocsu tractsu acfsu einsu 
AC943E AC943P acap ACEMP ACEMPF ACF ACSR1 ACSR1F ACSR2 ACSR2F ACSR3 ACSR3F
ACSR4 ACSR4F ACT ANNPR BLKGEO BLKSFX CDGEO CFN CTYGEO EIN EMPCD IND INDSUB
LFO LFO1   NPI PDIV PLCE PLGEO PPLCE PPN PSTREET PZIP
RECNUM SIC SIC56 SSABR
SSACL SSAEMP STGEO STREET TOC TRACT ZIP );	
 set BR.ssl&yr.su;
 *************Creating new tract variable;

length NEWTRACT $ 11;
If tract^=' ' & STGEO^=' ' & CTYGEO^=' ' then NEWTRACT=STGEO||CTYGEO||TRACT;
else newtract=" ";



Employment=ACEMP;
Employmentsu=ACEMP;
**************Exclude submasters;
if PDIV^='M';
*Exclude inactive units;
acap = ACQP1+ACQP2+ACQP3+ACQP4;
if acap>0| AC943P>0;

payrollsu =acap;
 srecnum=recnum;
salereceiptsu=acsr1;
*Identify the source of the common variables;
newtractsu=newtract;
actsu=act; cfnsu=cfn; lfosu=lfo ; sicsu=sic ;zipsu=zip; blkgeosu=blkgeo; blksfxsu=blksfx;
cdgeosu=cdgeo; ctygeosu=ctygeo; indsu=ind; indsubsu=indsub; lfo1su=lfo1;
 npisu=npi; pdivsu=pdiv; plcesu=plce; plgeosu=plgeo; ppnsu=ppn;
sic56su=sic56; stgeosu=stgeo; streetsu=street; tocsu=toc; tractsu=tract; acfsu=acf;
einsu=ein;
run;


*******
%let yr=1997;
libname BR '/economic/ssl/microdata/';
data ssl&yr.mu;
set BR.ssl&yr.mu;
run;


 *(2) Multi-Unit File;
************************************************************;
************************************************************;
%let yr=1997;
data ssl&yr.mu(keep=employment employmentmu payrollmu mrecnum  newtract  salereceiptmu  
 newtractmu actmu cfnmu lfomu sicmu zipmu blkgeomu blksfxmu cdgeomu ctygeomu indmu 
indsubmu lfo1mu npimu 
pdivmu plcemu plgeomu ppnmu
sic56mu stgeomu streetmu tocmu tractmu acfmu einmu 
ACF ACT
BLKGEO BLKSFX CDGEO
CFN CTYGEO CYTE EIN GAT IND INDSUB LFO LFO1 NPI PDIV
PLCE PLGEO PPN RAP RAPF RECNUM REMP REMPF RSR RSRF
SIC	SIC56	STGEO	STREET	TOC TRACT ZIP);	
 set BR.ssl&yr.mu;
 *************Creating new tract variable;

length NEWTRACT $ 11;
If tract^=' ' & STGEO^=' ' & CTYGEO^=' ' then NEWTRACT=STGEO||CTYGEO||TRACT;
else newtract=" ";

**************Exclude ghosts;
if ACT^='G';
**************Exclude inactive units;
if rap>0| (rap=0 & (RAPF^='Z' & ACT^='D'));

EMPLOYMENT=REMP;
EMPLOYMENTmu=REMP;
PAYROLLmu=RAP;
salereceiptmu=RSR;	
mrecnum=recnum;
*Identify the source of the common variables;
newtractmu=newtract;
actmu=act; cfnmu=cfn; lfomu=lfo ; sicmu=sic ;zipmu=zip; blkgeomu=blkgeo; blksfxmu=blksfx;
cdgeomu=cdgeo; ctygeomu=ctygeo; indmu=ind; indsubmu=indsub; lfo1mu=lfo1;
 npimu=npi; pdivmu=pdiv; plcemu=plce; plgeomu=plgeo; ppnmu=ppn;
sic56mu=sic56; stgeomu=stgeo; streetmu=street; tocmu=toc; tractmu=tract; acfmu=acf;
einmu=ein;
run;
************************************************************;
************************************************************ ;



*LBD File;
************************************************************;
************************************************************;
%let yr=1997;
libname lbd '/economic/lbd/microdata';
data lbd&yr.c;
set lbd.lbd&yr.c;
*Drop missing recnum and MU observations;
recnumx=put(recnum,8.);
mux=put(mu,1.);
if recnumx^=' ';
if MUx^=' ';
*Exclude submasters in LBD coming from SU file;
if MU=0 & PDIV='M' then delete;

/*
*Exclude inactive units;
if PAY>0;
*/

*Exclude ghosts in LBD coming from MU file;
if ACT='G' & MU=1 then delete;
run;

**************Creating srecnum mrecnum variables in lbd file and keeping the selected variables;
%let yr=1997;
data work.lbd&yr.c_rec(keep= mrecnum srecnum  payrolllbd employmentlbd
actlbd cfnlbd lfolbd siclbd ziplbd 
ACT	BESTNAICs	BESTSIC	CFN	COUNTY	EMP	FIRMID	FIRSTYEAr	
FLAGA	FLAGB	
LASTYEAR LBDNUM	LFO	MU	PAY	RECNUM	SIC STATE YR ZIP);
set work.lbd&yr.c;

if MU=1 then MRECNUM=RECNUM;
if MU=0 then SRECNUM=RECNUM;

payrolllbd=pay;	
employmentlbd=emp;
actlbd=act;
 cfnlbd=cfn;
 lfolbd=lfo;
 siclbd=sic ;
ziplbd=zip; 
run;

**************Checking mu  in LBD;
%let yr=1997;
proc means data=lbd&yr.c_rec;
var mu;
where mu=1;
run;

%let yr=1997;
proc means data=lbd&yr.c_rec;
var mu;
where mu=0;
run;


**************Checking mrecnum and srecnum variables in SU-SSL and MU-SSL ;
%let yr=1997;
Proc means data=ssl&yr.mu;
var mrecnum;
run;
%let yr=1997;
Proc means data=ssl&yr.su;
var srecnum;
run;

************************************************************;
************************************************************;
*Merging SSL and LBD;
************************************************************;
************************************************************;
*************1)Combine SU SSL and LBD by srecnum;
%let yr=1997;
proc sort data=work.lbd&yr.c_rec out=lbd97_s;
by SRECNUM;
run;

proc sort data=work.ssl&yr.su out=sussl97nt;
by SRECNUM;
run;

data work.su_ssllbd1997;
merge lbd97_s(in=one) sussl97nt(in=two);
fromlbd97_s=one;
fromsussl97nt=two;
by SRECNUM;
run;

data work.su_ssllbd1997;
set work.su_ssllbd1997;
srecnumx=put(srecnum,8.);
recnumx=put(recnum,8.);
mux=put(mu,1.);
if recnumx^=' ';
if MUx^=' ';
if srecnumx^=' ';
RUN;

*************2)Combine MU SSL and LBD by Mrecnum;
%let yr=1997;
proc sort data=work.lbd&yr.c_rec out=lbd97_M;
by MRECNUM;
run;

proc sort data=work.ssl&yr.mu out=mussl97nt;
by MRECNUM;
run;

data work.mu_ssllbd1997;
merge lbd97_M(in=one) mussl97nt(in=two);
fromlbd97_m=one;
frommussl97nt =two;
by MRECNUM;
run;

data work.mu_ssllbd1997;
set work.mu_ssllbd1997;
mrecnumx=put(mrecnum,8.);
recnumx=put(recnum,8.);
mux=put(mu,1.);
if recnumx^=' ';
if MUx^=' ';
if mrecnumx^=' ';
RUN;


**************3-A)Combine SU-SSLLBD &MUSSL-LBD FILES;
%let yr=1997;
data ssllbd&yr.;
set work.su_ssllbd1997(in=a)
work.mu_ssllbd1997 (in=b);
if a then SU2=1;else SU2=0;
if b then MU2=1;else MU2=0;
year=&yr.;
run;


**Create a newfips variable;
%let yr=1997;
data ssllbd&yr;
length newfips $5;
set work.ssllbd&yr;
ctygeox=put(ctygeo,3.);
stgeox=put(stgeo,2.);
If ctygeox^=' ' & stgeox^=' ' then newfips=stgeox||ctygeox;
else newfips=" ";
run;

data ssllbd&yr;
set work.ssllbd&yr;
**Keeping the counties listed;
where newfips="01015"
or newfips="01073"
or newfips="01097"
or newfips="02090"
or newfips="04013"
or newfips="04019"
or newfips="05069"
or newfips="05119"
or newfips="06001"
or newfips="06019"
or newfips="06037"
or newfips="06059"
or newfips="06067"
or newfips="06073"
or newfips="06075"
or newfips="08001"
or newfips="08031"
or newfips="08123"
or newfips="09001"
or newfips="09003"
or newfips="09009"
or newfips="10003"
or newfips="11001"
or newfips="12011"
or newfips="12031"
or newfips="12057"
or newfips="12086"
or newfips="13051"
or newfips="13089"
or newfips="13095"
or newfips="13121"
or newfips="17031"
or newfips="17143"
or newfips="17163"
or newfips="17167"
or newfips="18089"
or newfips="18097"
or newfips="19153"
or newfips="19193"
or newfips="20209"
or newfips="21111"
or newfips="22017"
or newfips="22019"
or newfips="22051"
or newfips="22071"
or newfips="22073"
or newfips="24510"
or newfips="25009"
or newfips="25013"
or newfips="25017"
or newfips="25025"
or newfips="26021"
or newfips="26049"
or newfips="26121"
or newfips="26163"
or newfips="27053"
or newfips="27123"
or newfips="28049"
or newfips="29047"
or newfips="29095"
or newfips="29165"
or newfips="29189"
or newfips="29510"
or newfips="31055"
or newfips="32003"
or newfips="33011"
or newfips="34007"
or newfips="34011"
or newfips="34013"
or newfips="34017"
or newfips="34039"
or newfips="35001"
or newfips="35013"
or newfips="36005"
or newfips="36029"
or newfips="36047"
or newfips="36055"
or newfips="36061"
or newfips="36063"
or newfips="36067"
or newfips="36071"
or newfips="36081"
or newfips="36085"
or newfips="36093"
or newfips="36119"
or newfips="37119"
or newfips="39017"
or newfips="39035"
or newfips="39045"
or newfips="39049"
or newfips="39061"
or newfips="39081"
or newfips="39087"
or newfips="39099"
or newfips="39153"
or newfips="40017"
or newfips="40027"
or newfips="40109"
or newfips="41051"
or newfips="42003"
or newfips="42043"
or newfips="42045"
or newfips="42101"
or newfips="44007"
or newfips="45019"
or newfips="45079"
or newfips="45085"
or newfips="47037"
or newfips="47065"
or newfips="47093"
or newfips="47157"
or newfips="48029"
or newfips="48085"
or newfips="48113"
or newfips="48121"
or newfips="48141"
or newfips="48157"
or newfips="48201"
or newfips="48245"
or newfips="48309"
or newfips="48355"
or newfips="48361"
or newfips="48439"
or newfips="48453"
or newfips="48491"
or newfips="49057"
or newfips="51710"
or newfips="51740"
or newfips="51760"
or newfips="53033"
or newfips="53053"
or newfips="53077"
or newfips="54009"
or newfips="54011"
or newfips="54039"
or newfips="54099"
or newfips="55079"


or newfips="01117"
or newfips="04027"
or newfips="08005"
or newfips="08059"
or newfips="08035"
or newfips="11031"
or newfips="12025"
or newfips="13063"
or newfips="13135"
or newfips="13177"
or newfips="17005"
or newfips="17043"
or newfips="17097"
or newfips="18057"
or newfips="24005"
or newfips="26125"
or newfips="27003"
or newfips="27163"
or newfips="28121"
or newfips="31153"
or newfips="32009"
or newfips="35043"
or newfips="36105"
or newfips="36001"
or newfips="36079"
or newfips="37179"
or newfips="39085"
or newfips="39041"
or newfips="39025"
or newfips="39155"
or newfips="41005"
or newfips="44003"
or newfips="45063"
or newfips="47187"
or newfips="48251"
or newfips="48367"
or newfips="51810"
or newfips="51041"
or newfips="51087"
or newfips="55133";
run;

**************3-B)Eliminating EINs that appear in both the SU(not submaster)
and MU files,keeping MU information suggested by Miranda(2002);
%let yr=1997;
proc sort data=work.ssllbd&yr OUT=work.ssllbd&yr;by EIN;
proc means data=work.ssllbd&yr noprint;
by EIN;
output out=work.dups(drop=_TYPE_ _FREQ_)
n(EMPLOYMENT)=EIN_COUNT;
run;

data ssllbd&yr;
merge work.ssllbd&yr (in=a) work.dups(in=b);
by EIN;
*We are concerned about EINs that are in the SU(not submaster) and MU;
if EIN_COUNT>1 & SU2=1 & PDIV^='M' then delete;
run;


*save the merged ssllbd data;
data "/rdcprojects/mc00535/data/ssllbd/ssllbd&yr "(compress=yes);
set ssllbd&yr;
drop fromlbd97_s fromlbd97_m frommussl97nt fromsussl97nt  SU2 MU2 srecnum mrecnum EIN_COUNT srecnumx mrecnumx recnumx mux stgeox ctygeox;
run;

proc datasets lib=work;
delete
dups lbd1997c lbd1997c_rec lbd97_m lbd97_s
mussl97nt sussl97nt mu_ssllbd1997 su_ssllbd1997
ssl1997mu ssl1997su ssllbd1997;
run;



