**** This do file prepares the tractlevel LBD/SSL for merge with the decennial.
**** Written by: Matias. 


clear
set mem 15G
global dir = "/rdcprojects/mc1/mc00535/data/ssllbd/"
global ezdata = "/rdcprojects/mc1/mc00535/data/ezdata/"
global progs = "/rdcprojects/mc1/mc00535/programs/matias/LBD_data/"
global results = "/rdcprojects/mc1/mc00535/programs/matias/results/"
global censusdir="/rdcprojects/mc1/mc00535/data/decennial/05-Tract_Fixed_Effects/"

cap log close
log using "8_LBD_mergeDecennial.log", text replace

use "$dir/LBD_collapsed.dta", clear
keep if yr<4
replace year = 1980 if year==1987
replace year = 1990 if year==1992
replace year = 2000 if year==1997
foreach var of varlist _all{
ren `var' `var'_1997
}
ren tract1990_1997 tract1990
ren year_1997 year
drop id_ yr_
sort tract1990 year
tempfile data1997
save `data1997', replace

use "$dir/LBD_collapsed.dta", clear
drop if yr==5 | yr==3
replace year = 1980 if year==1987
replace year = 1990 if year==1992
replace year = 2000 if year==2000
foreach var of varlist _all{
ren `var' `var'_2000
}
ren tract1990_2000 tract1990
ren year_2000 year
drop id_ yr_
sort tract1990 year
merge 1:1 tract1990 year using `data1997'
drop _merge
sort tract1990 year
save `data1997', replace

cap drop population_city_1990_2000 
cap drop _fillin_2000
cap drop population_city_1990_1997 
cap drop _fillin_1997
cap drop emp_change5_*

ren tract1990 tractid90
cap drop progid_cons_1997 progid_power_1997 progname_1997 program1995_1997 program1999_1997 program2001_1997 application_tract_1997 assigned_tract_1997
rename progid_cons_2000 progid_cons
rename progid_power_2000 progid_power
rename progname_2000 progname
rename program1995_2000 program1995
rename program1999_2000 program1999
rename program2001_2000 program2001
rename application_tract_2000 application_tract
rename assigned_tract_2000 assigned_tract

order tractid90 year
sort tractid90 year
save "$dir/LBD_4DEC.dta", replace

cap log close


