clear
clear matrix
set mem 2g
global codes  = "/rdcprojects/mc1/mc00535/programs_organize/2.data/4.BuildWork/"


forval year=1980(10)2000 {
use "$intermediate/por`year'_tract.dta", clear

joinby tractid90 year using "$ezdata/admin4merge.dta", unmatched(both)
tab _m
drop if _m==2
drop _m

joinby tractid90 using "$ezdata/cities.dta", unmatched(both)
tab _m
drop if _m==2
drop _m


local byvar="county90"
*Compute tract level median of housing values in county excluding treatment and control zones
egen aux=median(lnvalue) if assigned_tract==., by(`byvar')
egen lnvalue_medcity=mean(aux), by(ncity)
drop aux
egen aux=median(lnrent) if assigned_tract==., by(`byvar')
egen lnrent_medcity=mean(aux), by(county90)
drop aux

egen aux=median(lnwage2) if assigned_tract==., by(`byvar')
egen lnwage2_medcity=mean(aux), by(county90)
drop aux

keep tractid90 year lnrent_medcity lnvalue_medcity lnwage2_medcity
tempfile `year'
save ``year''
}

use `1980', clear
append using `1990'
append using `2000'
sort tractid90 year
save "$intermediate/city_median_lnvalue.dta", replace



