clear mata
clear matrix
clear
version 10.1
set mem 2g
global codes  = "/rdcprojects/mc1/mc00535/programs_organize/2.data/4.BuildWork/"
cap log close
log using "$codes/logs/7.compile_work_tracts.log", replace
run "$codes/library.ado"
timer clear
timer on 1


**** Make a cross-walk
	**** Get cities from admin data
	use "$ezdata/admin4merge.dta", clear
	keep tractid90 year city 
	keep if year==2000
	drop year
	ren city city_adm
	tempfile f1
	save`f1', replace

	**** get cities from city-level data (old NCDB)
	use "$ezdata/city_level_data", clear
	drop city ncity     //ncity is an old variable we used in the NCDB. We won't use it any longer.
	ren true_city city
	keep tractid year city
	keep if year==4
	ren tractid tractid00
	joinby tractid00 using "$ctrfdir/CTRF_unique_00to90.dta", unmatched(using)
	tab _m
	drop _m
	drop tractid00
	sort tractid90

	**** merge
	joinby tractid90 using `f1', unmatched(both) 
	tab _m
	drop _m

	**** make a cross-walk
	sort tractid90 
	gen st=substr(tractid90,1,2)
	gen one = 1
	collapse one, by(city city_adm st)

	**expand atlanta area in order to get placebos**
	*county 13089
	replace city_adm="Atlanta city" if city=="Avondale Estates city"&st=="13"
	replace city_adm="Atlanta city" if city=="Belvedere Park CDP"&st=="13"
	replace city_adm="Atlanta city" if city=="Candler-McAfee CDP"&st=="13"
	replace city_adm="Atlanta city" if city=="Chamblee city"     &st=="13"
	replace city_adm="Atlanta city" if city=="Clarkston city"    &st=="13"
	replace city_adm="Atlanta city" if city=="Decatur city"      &st=="13"
	replace city_adm="Atlanta city" if city=="Doraville city"    &st=="13"
	replace city_adm="Atlanta city" if city=="Druid Hills CDP"   &st=="13"
	replace city_adm="Atlanta city" if city=="Dunwoody CDP"      &st=="13"
	replace city_adm="Atlanta city" if city=="Gresham Park CDP"  &st=="13"
	replace city_adm="Atlanta city" if city=="North Atlanta CDP" &st=="13"
	replace city_adm="Atlanta city" if city=="North Decatur CDP" &st=="13"
	replace city_adm="Atlanta city" if city=="North Druid Hills CDP"&st=="13"
	replace city_adm="Atlanta city" if city=="Panthersville CDP"    &st=="13"
	replace city_adm="Atlanta city" if city=="Redan CDP"            &st=="13"
	replace city_adm="Atlanta city" if city=="Scottdale CDP"        &st=="13"
	replace city_adm="Atlanta city" if city=="Stone Mountain city"  &st=="13"
	replace city_adm="Atlanta city" if city=="Tucker CDP"           &st=="13"

	*county 13121
	replace city_adm="Atlanta city" if city=="Alpharetta city"      &st=="13"
	replace city_adm="Atlanta city" if city=="College Park city"    &st=="13"
	replace city_adm="Atlanta city" if city=="East Point city"      &st=="13"
	replace city_adm="Atlanta city" if city=="Fairburn city"        &st=="13"
	replace city_adm="Atlanta city" if city=="Hapeville city"       &st=="13"
	replace city_adm="Atlanta city" if city=="Roswell city"         &st=="13"
	replace city_adm="Atlanta city" if city=="Sandy Springs CDP"    &st=="13"
	replace city_adm="Atlanta city" if city=="Union city"           &st=="13"

	*And we're back
	drop if city=="" | city_adm ==""
	drop if city=="East St. Louis city"&city_adm=="East St. Louis city" 
	drop one               
	sort city              
	list                   
	duplicates list city st
	tempfile crosswalk     
	save `crosswalk'       
                        
                        
                        
                        
**** City level data collapsed by city
	use "$ezdata/city_level_data", clear
	drop city              
	ren true_city city     
	gen st=substr(tractid,1,2)
	collapse (mean) *_city, by(city st year)
	drop if city==""	
	sort city year
	tempfile citylevel
	save `citylevel' , replace




**** APPEND POW - noweight***
use "$intermediate/pow1980_tract_noweight.dta", clear
append using "$intermediate/pow1990_tract_noweight.dta"
append using "$intermediate/pow2000_tract_noweight.dta"
duplicates report tractid90 year
tempfile POW_noweight
save `POW_noweight', replace

**** APPEND POR - noweight***
use "$intermediate/por1980_tract_noweight.dta", clear
append using "$intermediate/por1990_tract_noweight.dta"
append using "$intermediate/por2000_tract_noweight.dta"
tempfile POR_noweight
save `POR_noweight', replace

**** APPEND POW***
use "$intermediate/pow1980_tract.dta", clear
append using "$intermediate/pow1990_tract.dta"
append using "$intermediate/pow2000_tract.dta"
duplicates report tractid90 year
tempfile POW
save `POW', replace

**** APPEND POR***
use "$intermediate/por1980_tract.dta", clear
append using "$intermediate/por1990_tract.dta"
append using "$intermediate/por2000_tract.dta"
duplicates report tractid90 year


**** MERGE POW 
**** The _merge==2 tracts are tracts with zero weights. 
joinby tractid90 year using `POW_noweight', unmatched(both)
tab _merge
drop if _merge==2
drop _merge
duplicates report tractid90 year

**** MERGE POW
**** The _merge==2 tracts are tracts with zero weights. 
joinby tractid90 year using `POR_noweight', unmatched(both)
tab _merge
drop if _merge==2
drop _merge
duplicates report tractid90 year

**** MERGE POW
joinby tractid90 year using `POW', unmatched(both)
tab _merge
drop _merge
duplicates report tractid90 year

**** MERGE tract areas
joinby tractid90 using "$geodir/Tract1990_Areas.dta", unmatched(master)
tab _merge
drop _merge

**** MERGE CBD flags and dist to CBD
joinby tractid90 using "$geodir/Tract_dist_to_Sample_County_CBDs.dta", unmatched(master)
tab _merge
drop _merge

**** Merge tract latitude and longitude
joinby tractid90 using "$geodir/Tract1990_XY.dta", unmatched(master)
ren X longitude
ren Y latitude
replace longitude = longitude/1000000
replace latitude  = latitude/1000000
replace longitude = -longitude if longitude>0
tab _merge
drop _merge

**** MERGE tract FEs for variables with definitions involving POW
gen powtractid90=tractid90
joinby powtractid90 year using "$intermediate/lnwage2_local_nonlocal_FE.dta", unmatched(master)
tab _merge
drop _merge

joinby tractid90 year using "$intermediate/lnwage2_outside_FE.dta", unmatched(master)
tab _merge
drop _merge
duplicates report tractid90 year

**** MERGE tract FEs for non-POW based variables
joinby tractid90 year using "$intermediate/person_fe_90_fullcounties.dta", unmatched(master)
tab _merge
drop _merge
joinby tractid90 year using "$intermediate/housing_fe_90_fullcounties.dta", unmatched(master)
tab _merge
drop _merge

duplicates report tractid90 year

**** MERGE Migration logits
gen baseyear=year-10

joinby tractid90 baseyear using "$intermediate/baseyear80_allbetas.dta", unmatched(master)
tab _merge if year==1990
drop _merge

joinby tractid90 baseyear using "$intermediate/baseyear90_allbetas.dta", unmatched(master) update
tab _merge if year==2000
drop _merge

joinby tractid90 baseyear using "$intermediate/baseyear80_dropoutbetas.dta", unmatched(master)
tab _merge if year==1990
drop _merge

joinby tractid90 baseyear using "$intermediate/baseyear90_dropoutbetas.dta", unmatched(master) update
tab _merge if year==2000
drop _merge

joinby tractid90 baseyear using "$intermediate/baseyear80_youngbetas.dta", unmatched(master)
tab _merge if year==1990
drop _merge

joinby tractid90 baseyear using "$intermediate/baseyear90_youngbetas.dta", unmatched(master) update
tab _merge if year==2000
drop _merge

**** Merge LBD (from master_lbd.do)
sort tractid90 year
merge tractid90 year using "$dirLBD/LBD_4DEC.dta"
tab _merge
drop if _m==2
drop _m


**** Add housing variables computed from 100% housing file
joinby tractid90 year using "/rdcprojects/mc1/mc00535/data/decennial/07-Shortform_Housing/shortform_housing.dta", unmatched(master)
tab _m
drop _m
foreach var in lnrent lnrent2 lnvalue lnvalue2 {
replace `var'_100pct = `var' if year==2000
}
drop progid_cons progid_power progname program1995 program1999 program2001 application_tract assigned_tract





**** MERGE ON ADMIN DATA ***
merge 1:1 tractid90 year using  "$ezdata/admin4merge.dta" //admin data has manually recoded city names for winlose tracts
list tractid90 year city if _merge==2 //these tracts don't show up in the micro data. Seem to be very low population tracts according to CTRF. Plausible they were not sampled in one year or another.
drop if _merge==2
drop _merge
drop *_city //don't want these city variables
drop city //don't want this city identifier


**** MERGE ON CITY DATA ****
duplicates report tractid90 year
merge m:1 tractid90 using "$ctrfdir/CTRF_unique_90to00.dta" //many to one because of year
*list tractid90 assigned_tract year N_pop if _merge==1
tab assigned_tract if _merge==1, miss //who is missing from CTRF? ANSWER: These guys have tractids ending in 99 which is for guys on boats. OK to drop them.
drop if _merge==2|_merge==1 //IMPORTANT: dropping tracts we can't merge to CTRF
drop _merge



ren tractid00 tractid
recode year 1980=2 1990=3 2000=4
merge m:1 tractid year using "$ezdata/city_level_data" //get city identifiers

drop if _merge==2
drop _merge

replace city=true_city

drop *_city //wait until names are corrected to get city level variables.


ren tractid tractid00
gen st=substr(tractid00,1,2)
merge m:1 city st using `crosswalk' //use admin city names
drop if _merge==2 //drops three small cities in Georgia that don't get sampled in the microdata

drop _merge

replace city=city_adm
drop city_adm

**minor fixes to city names**
replace city="Charleston city" if city=="Charleston city (WV)"

replace city="Seattle city" if city=="Richmond city"&st=="53" //this fixes a mistake in the admin file with progname
replace progname=111 if progname==88&st=="53" //fix progname for Seattle
replace progid_power=115 if progid_power==92&st=="53" //fix progid_power for Seattle

gen st2=st
replace st2="29" if city=="St. Louis city"&st=="17" //East St. Louis needs to be assigned the variables from St. Louis

replace st2="29" if city=="Kansas city"&st=="20" //Give Kansas city to side with more tracts

replace city="Norfolk city" if city=="Portsmouth city"&st=="51" //make Portsmouth Norfolk


replace st2="39" if city=="Weirton city"&st=="54"
replace city="Steubenville city" if city=="Weirton city"&st=="54"

replace city="Columbia city" if city=="Sumter city"&st=="45"

replace st2="54" if city=="Ironton city"&st=="39"
replace city="Huntington city" if city=="Ironton city"&st=="39"

replace st2="42" if city=="Camden city" //combine Camden with Philly
replace city="Philadelphia city" if city=="Camden city" //combine Camden with Philly

replace city="New York city" if city=="Yonkers city"&st=="36" //combine Yonkers with New York

replace city="Gary city" if city=="Hammond city"&st=="18"
replace city="Gary city" if city=="East Chicago city"&st=="18"

replace city="Albuquerque city" if city=="South Valley CDP"&st=="35"

*drop if city=="" //IMPORTANT: dropping if not in a city


ren st st_old
ren st2 st

merge m:1 city st year using `citylevel' //merge on characteristics of recoded city/state

drop st
ren st_old st
replace city="Springfield (MA) city" if city=="Springfield city"&st=="25" //distinguish between the two Springfields
replace city="Springfield (IL) city" if city=="Springfield city"&st=="17" //distinguish between the two Springfields
replace city="Charleston (WV) city" if city=="Charleston city"&st=="54" //distinguish between the two Charlestons
replace city="Charleston (SC) city" if city=="Charleston city"&st=="45" //distinguish between the two Charlestons

drop if _merge==2
drop _merge
duplicates report tractid90 year


/*
**** Minor Fixes
encode city, gen(ncity)
drop city
ren ncity city
*/

replace county90 = substr(tractid90,1,5) if county90==""
/*
gen state = real(substr(tractid90 ,1,2))

foreach var in black_city crime_total_city manufacture_city pctgov_city population_city {
 cap drop aux
 egen aux = mean(`var'), by(county90 year)
 replace `var' = aux if `var'==.
}
*replace city=999999 if city==.


drop aux state
*/

replace progid_power = 1000+real(substr(county90,1,2)) if progid_power==.
sort tractid90 year

recode year 2=1980 3=1990 4=2000

gen yr=2 if year==1980
replace yr=3 if year==1990
replace yr=4 if year==2000


**Make County Group**
levelsof city, local(citylist)
local i=1
gen cg=.
foreach city of local citylist{
	levelsof county90 if city=="`city'", local(countylist)
	foreach county of local countylist{
		replace cg=`i' if county90=="`county'"
	}
	local ++i
}


egen id=group(tractid90)
tsset id yr
compress
save "$output/workfile_90_fullcounties.dta", replace
timer off 1
timer list
di "MINUTES="r(t1)/60
di "HOURS="r(t1)/60/60
cap log close
