
*** define globals
global data   = "/rdcprojects/mc1/mc00535/data/decennial/03-State_Files/"
global intermediate = "/rdcprojects/mc1/mc00535/data/decennial/04-Intermediate/"
global output = "/rdcprojects/mc1/mc00535/data/decennial/05-Output/"
global placebo= "/rdcprojects/mc1/mc00535/data/decennial/06-PlaceboTracts/"
global ezdata = "/rdcprojects/mc1/mc00535/data/ezdata/"
global geodir = "/rdcprojects/mc1/mc00535/data/Tract1990_Centroids/"
global dirLBD = "/rdcprojects/mc1/mc00535/data/ssllbd/"
global codes  = "/rdcprojects/mc1/mc00535/programs_organize/2.data/4.BuildWork/"
global ctrfdir = "/rdcprojects/mc1/mc00535/data/CTRF/"
global placebo="/rdcprojects/mc1/mc00535/programs_organize/3.estimation/3.workfile/"

** This program reweights variables so that they can be collapsed with a rawsum
cap program drop reweightvar
program define reweightvar
{
  syntax, var(string) weight(string) by(string)
  cap drop notmiss
  cap drop wsum
  gen notmiss=`var'!=.
  egen double wsum=sum(`weight') if notmiss==1, by(`by')
  replace `var'=`var'*`weight'/wsum
}
end


** This program is used in the migration logits
cap program drop miglogit_lf
program miglogit_lf
     version 9.1
     args lnf theta1
     qui replace `lnf' = ln( ( ( 1/(1+exp(-`theta1') ) )  /  (1 + ( 1/(1+exp(-`theta1') ) ) ) )^($ML_y1)    *      ( 1  /  (1 + ( 1/(1+exp(-`theta1') ) ) ) )^(1-$ML_y1) )
end

