

cap program drop bo2
program define bo2, eclass
syntax varlist(ts) [if/] [aweight], Treatment(string) [cluster(string)] [gen(string) keepC]

version 10.2

 ***-control of varlist
   gettoken Y X : varlist

 ***-control of option if
   if "`if'"=="" local if = ""
   if "`if'"!="" local andif = "& `if'"
   if "`if'"!="" local if = "if `if'"
 ***-control of treatment
   local T = "`treatment'"
 ***-control of cluster
 if "`cluster'"==""{
         gen _cluster = _n
         local cluster = "_cluster"
 }
 
di "`X'" 
 ***-Interact Xs
  if "`keepC'"==""{
  cap drop _C_*
    foreach x in `X'{
      qui gen _C_`x' = `x'*(1-`T') `if'
   }
  qui gen _C_=1-`T'
 }


  reg `Y' _C_* `T' `if' [`weight'`exp'], hascons cluster(`cluster')

  mat b=e(b)
  mat V=e(V)

  cap drop _mark
  gen _mark=e(sample)*`T'
  recode _mark .=0 //mata selectvar will pull anything !=0

  order `X'
  local K: word count `X'
  di `K'

  tempvar aw
  if "`weight'"!=""{
	di "`aw'`exp'"
	gen `aw'`exp'
	
	}
  else{
	gen `aw'=1
	}

  gen _mark2=e(sample)*(1-`T')
  gen _mark3=e(sample)
  recode _mark2 _mark3 (.=0)

  mata: aw=st_data(.,"`aw'","_mark3")
  mata: aw0=st_data(.,"`aw'","_mark2")
  mata: aw1=st_data(.,"`aw'","_mark")

if "`gen'"!=""{
	cap drop `gen'
	mata: x1=st_data(.,1..`K',"_mark")
	mata: c1=J(rows(x1),1,1)
	mata: X1=(c1, x1)

	mata: x0=st_data(.,1..`K',"_mark2")
	mata: c0=J(rows(x0),1,1)
	mata: X0=(c0, x0)

	mata: x=st_data(.,1..`K',"_mark3")
	mata: c=J(rows(x),1,1)
	mata: Xbig=(c, x)


	mata: D=st_data(.,"_mark","_mark3")
	mata: N1=sum(D)
	*mata: w=D'*Xbig*invsym(X0'*X0)*X0'/N1
	mata: w=(cross(D,aw,Xbig)*invsym(cross(X0,aw0,X0))*X0'/sum(aw1)):*aw0'
	mata: st_addvar("double","`gen'")
	mata: st_store(.,"`gen'","_mark2",w')

}
	drop _mark2 _mark3


  mata: x=st_data(.,1..`K',"_mark")
  mata: D=J(rows(x),1,1)
  mata: X=(x, D)

  mata: b=st_matrix("b")
  mata: b0=b[.,1..`K'+1]
  mata: mu1=b[.,`K'+2]
    
  mata: mu0=D'*X*b0'/(D'*D)
  mata: delt=mu1-mu0

  mata: V=st_matrix("V")
  mata: V0=V[1..`K'+1,1..`K'+1]  
  *mata: v0=D'*X*V0*X'*D/(D'*D)^2
  mata: v0=cross(D,aw1,X)*V0*cross(X,aw1,D)/(cross(D,aw1,D))^2
  mata: v1=V[`K'+2,`K'+2]
  mata: se=sqrt(v1+v0)
  scalar drop _all
  mata: st_numscalar("_delt",delt)
  mata: st_numscalar("_se",se)
  mata: st_numscalar("_mu0",mu0)

  ereturn scalar delt=_delt
  ereturn scalar se=_se
  ereturn scalar mu0=_mu0
  ereturn scalar t=abs(_delt/_se)
  ereturn scalar p=2*(1-normal(abs(_delt/_se)) )
end


#delimit cr
