**** Auxiliary programs
cap program drop logit2
program define logit2
syntax varlist(ts), spec(real) cluster(string) [trimpointU(string) trimpointL(string) STANDardize]

    gettoken Tvar varlist : varlist

    ** (1) first step
    *logit `Tvar' `varlist' if yr==4, cluster(`cluster') asis
    reg `Tvar' `varlist' if yr==4, cluster(`cluster')
    predict phat99 if e(sample)==1
    qui replace phat99=1e-6 if phat99<=0
    qui replace phat99=1-1e-6 if phat99>=1&phat99!=.
    cap noisily covariates, name(X)

    ** (2) trim
    qui sum phat99 if `Tvar'==0, de
    if "`trimpointU'"=="maxC"  local trimpointU = r(max)
    if "`trimpointU'"=="p99C"  local trimpointU = r(p99)
    if "`trimpointL'"=="p25C"   local trimpointL = r(p25)
    if "`trimpointL'"=="p10C"   local trimpointL = r(p10)
    qui sum phat99 if `Tvar'==1, det
    if "`trimpointL'"=="minT"  local trimpointL = r(min)
    if "`trimpointL'"=="p1T"   local trimpointL = r(p1)
    if "`trimpointU'"=="p90T"  local trimpointU = r(p90)
    if "`trimpointU'"=="p75T"  local trimpointU = r(p75)

    
    gen badp = 0
    replace badp = 1 if ((phat99>`trimpointU') | (phat99<`trimpointL') | phat99==.) & yr==4
    egen drop = max(badp), by(id)
    gen touse = 1 if drop==0 

    ** (3) Overlap in the untrimmmed sample
    overlap phat99 if phat99<., treatment(`Tvar')
    ** These are the number of bad tracts in each treated city
    //tab city badp if `Tvar'==1 & yr==4
    //table city if `Tvar'==1 & yr==4, c(mean badp)
    drop badp drop

    ** (4) Second step: actual estimation
    //logit `Tvar' `varlist' if yr==4 & touse==1, cluster(city)
    //predict phat`spec' if e(sample)==1
    gen phat`spec' = phat99 if yr==4 & touse==1
end


cap program drop covariates
program define covariates
syntax, name(string)
    matrix b = e(b)'
    matrix r = rowsof(b)-1
    matrix b = b[1..r[1,1],.]
    global `name': rownames b
end
