cap program drop overlap
program define overlap, rclass

syntax varlist(max=1) [if/], treatment(string)
{
if "`if'" == "" local if = "_n==_n"

qui tabstat `varlist' if `if', statistics(min p1 p5 p10 p25 p50 p75 p90 p95 p99 max n ) by(`treatment') nototal save
matrix P0 = r(Stat1)
matrix P1 = r(Stat2)
matrix O = P1, P0, P1-P0
matrix colnames O = P1 P0 P1-P0
matrix list O, format(%9.3f)
return matrix O = O

qui{
    matrix D0= r(Stat1)
    local p99_T0 = el(P0,9,1)
    count if `varlist'>`p99_T0' & `varlist'<. & `treatment'==1 & `if'
    local N = r(N)
    count if `treatment'==1 & `varlist'!=. & `if'
    local N1 = r(N)
    local ratio = round(`N'/`N1',0.001)*100
    }
di in ye "% of treated units with no counterparts among the control= `ratio'% (`N' out of `N1')" 
}
end
