cap prog drop wild
prog def wild, eclass
syntax varlist [if] [in] [aweight], cluster(varname) d(varname) [re] reps(integer)

tempvar u pos ynew xb e reject

gettoken y x : varlist

*estimate full model

if "`re'"=="re"{
xtreg `y' `x' `d' `if' `in', cluster(`cluster') re i(`cluster')
}
else{
reg `y' `x' `d' `if' `in' [`weight'`exp'], cluster(`cluster')
}
local abst=abs(_b[`d']/_se[`d'])
mat b=e(b)
mat V=e(V)
local N=e(N)

*get restricted residuals

if "`re'"=="re"{
qui xtreg `y' `x' `if' `in', re i(`cluster')
qui predict `e', e
}
else{
qui reg `y' `x' `if' `in' [`weight'`exp'] //note: OLS = 2SLS for restricted linear model
qui predict `e', resid
}

qui predict `xb', xb

*Bootstrap
mat Ts=J(`reps',2,.)

qui gen `u'=.
qui gen int `pos'=1
qui gen `ynew'=.
sort `cluster'

forvalues i=1/`reps'{
qui{
by `cluster': replace `u'=uniform()
by `cluster': replace `pos'=`u'[1]>.5

replace `ynew'=`xb'+(2*`pos'-1)*`e'
}

if "`re'"=="re"{
qui xtreg `ynew' `x' `d' `if' `in', cluster(`cluster') re i(`cluster')
}
else{
qui reg `ynew' `x' `d' `if' `in' [`weight'`exp'], cluster(`cluster')
}
mat Ts[`i',1]=abs(_b[`d']/_se[`d'])
mat Ts[`i',2]=_b[`d']
}

*Save results
svmat Ts
qui gen `reject'=Ts1>`abst' if Ts1!=.
qui sum Ts1

ereturn post b V, obs(`N')
qui sum `reject'
ereturn scalar p=r(mean)
qui sum Ts2
ereturn scalar se=r(sd)
drop Ts1 Ts2

end
