
cap prog drop wild_bo
prog def wild_bo, eclass
syntax varlist [if] [in] [aweight], cluster(varname) d(varname) reps(integer)

tempvar u pos ynew xb e

gettoken y varlist: varlist
*tokenize `varlist'
*local y `1'
*macro shift
*local x `*'

*estimate full model

bo2 `y' `varlist' `if' `in' [`weight'`exp'], cluster(`cluster') treatment(`d')
global abst=e(t)
global delt=e(delt)
global se_analit=e(se)
global mu0=e(mu0)

//*estimate restricted model and get residuals
//if "`if'"!=""{
// 	local if2 "`if'&`d'==1"
// }
// else{
// 	local if2 "if `d'==1"
// }


**Get efficient restricted estimates via 2SLS**
**(yields improved size control in Oaxaca model)**
cap drop hold
ren _C_ hold
ivregress 2sls `y' (`varlist'=_C_* `d') `if', perfect
ren hold _C_

predict `e', resid //restricted residual
predict `xb', xb //restricted prediction

*Bootstrap
mat Ts=J(`reps',2,.)


qui{
gen `u'=.
gen int `pos'=1
gen `ynew'=.
sort `cluster'
}


forvalues i=1/`reps'{

qui{
by `cluster': replace `u'=uniform()
by `cluster': replace `pos'=`u'[1]>.5

replace `ynew'=`xb'+(2*`pos'-1)*`e'
}

qui bo2 `ynew' `varlist' `if' `in' [`weight'`exp'], cluster(`cluster') treatment(`d') keepC

mat Ts[`i',1]=abs(e(delt)/e(se))
mat Ts[`i',2]=_b[`d']
}

*Save results
svmat Ts
gen reject=Ts1>$abst if Ts1!=.


ereturn scalar delt=$delt
ereturn scalar abst=$abst
ereturn scalar mu0=$mu0

sum reject
ereturn scalar p=r(mean)
sum Ts2
ereturn scalar se=r(sd)
drop Ts1 Ts2 reject
ereturn scalar se_analit=$se_analit
end

