cap prog drop wild_ci
prog def wild_ci, eclass
syntax varlist [if] [in] [aweight], cluster(varname) d(varname) reps(integer) alpha(real)

gettoken y x : varlist

qui reg `y' `x' `d' `if' `in' [`weight'`exp'], cluster(`cluster')
local b=_b[`d']
local se=_se[`d']

local target=`alpha'
local crit=abs(invnorm(`target'))
local guess_l=`b'-1.96*`se'
local guess_u=`b'+1.96*`se'

di "I'm going to construct an approximate " (1-`alpha')*100 "% CI for `y'"
di "Under normality, critical abs(T) would be `crit'"
di "CI would be [`guess_l',`guess_u']"
di "Going to conduct grid search in each direction"
di "Impose the null and wild bootstrap"


cap drop _ynull
qui gen _ynull=.


**FIND LOWER TAIL**

local dev=1
di "Lower Limit  p-value  gap"
while abs(`dev')>.005{
	set seed 12345 //want same seed when searching for critical value
	qui replace _ynull=`y'-`guess_l'*`d'
	qui wild _ynull `x' `if' `in' [`weight'`exp'], cluster(`cluster') d(`d') reps(`reps')
	local p=e(p)
	local dev=`p'-`target'
	di `guess_l' " " `p' " " `dev'
	local guess_l=`guess_l' - `dev'/10
}
local p_l=`p'
di "OK, lower limit is `guess_l'"

**FIND UPPER TAIL**

local dev=1
di "Upper Limit  p-value  gap"
while abs(`dev')>.005{
	set seed 12345 //want same seed when searching for critical value
	qui replace _ynull=`y'-`guess_u'*`d'
	qui wild _ynull `x' `if' `in' [`weight'`exp'], cluster(`cluster') d(`d') reps(`reps')
	local p=e(p)
	local dev=`p'-`target'
	di `guess_u' " " `p' " " `dev'
	local guess_u=`guess_u' + `dev'/10
}
local p_u=`p'
di "OK, upper limit is `guess_u'"


drop _ynull

di (1-`alpha')*100 "% CI is [`guess_l',`guess_u']"

ereturn scalar ul=`guess_u'
ereturn scalar ll=`guess_l'
ereturn scalar delt=`b'

end
