**This file computes balance for second moments**
clear
clear matrix
set more off

cap run "/rdcprojects/mc1/mc00535/programs_organize/3.estimation/1.setup.do"
if _rc!=0 di in red "run 1.setup.do"

local results="$winloseresults"
local NAME="winlose_bo_wild_on"
local SPEC="spec1_0_1"

run "$dofiles/3.pscore.do" 1 ols 0 1 winlose_gt10 wild_off

** Declare a local with unique variables to be generated  
   foreach X in $X_BAL{
     local str = regexr("`X'","_sma","")
     local str = regexr("`str'","l2_","")
     local str = regexr("`str'","l_","")
     local str = regexr("`str'","d_","")
     global Xs "$Xs `str'"
    }
   global Xs: list uniq global Xs

   tsset id yr
   foreach var of global Xs{
     cap drop mu 
     drop d_`var' l_`var' l2_`var' l_d_`var'
     egen mu=mean(`var'), by(yr assigned_tract)
     replace `var'=`var'^2
     cap gen d_`var'   = d.`var'
     if _rc!=0 di in red "d_`var' was already generated"
     gen l_`var'   = l.`var'
     gen l2_`var'  =l2.`var'
     gen l_d_`var' =l.d_`var'
   }

di "$REPS REPS USED IN THIS TABLE"

balance $X_BAL1 if yr==4 & touse==1 & phat!=., by(assigned_tract) controls($X) cluster($cluster) wild(on) reps($REPS) dir("`results'/`SPEC'/BAL1_`SPEC'_`NAME'_secondmom.dta")

balance $X_BAL2 if yr==4 & touse==1 & phat!=., by(assigned_tract) controls($X) cluster($cluster) wild(on) reps($REPS) dir("`results'/`SPEC'/BAL2_`SPEC'_`NAME'_secondmom.dta")

balance $X_BAL3 if yr==4 & touse==1 & phat!=., by(assigned_tract) controls($X) cluster($cluster) wild(on) reps($REPS) dir("`results'/`SPEC'/BAL3_`SPEC'_`NAME'_secondmom.dta")



