
cap run "/rdcprojects/mc1/mc00535/programs_organize/3.estimation/1.setup.do"
if _rc!=0 di in red "run 1.setup.do"
cap log close

local switch = "on"
local SPEC = "1_0_1"
local withobs = "on"
global results = "/rdcprojects/mc1/mc00535/programs_organize/3.estimation/2.results/"

cap program drop recover_obs
program define recover_obs
  syntax  ,col(integer) preserve(string)
  gen Obs = col`col'_ols if stat=="   obs"
  replace Obs = regexr(Obs,"\(","")
  replace Obs = regexr(Obs,"\)","")
  replace Obs = Obs[_n+2] if Obs=="" & stat==" coeff"
  if "`preserve'"=="not"{
   drop if stat=="   obs"
   drop stat
  }
end

**** COMPILE RESULTS: OLS/BO for WINLOSE/PLACEBO/PERCENTILE/REJECTED/withSEZ/noNY
        foreach sample in winlose placebo percentile rejected withSEZ noNY{
	   if "`sample'"=="winlose" local suffix = "wild_`switch'"
	   if "`sample'"=="placebo" local suffix = "wild_off"
	   if "`sample'"=="percentile" local suffix = "wild_off"
	   if "`sample'"=="rejected" local suffix = "wild_off"
	   if "`sample'"=="withSEZ"  local suffix = "wild_off"
	   if "`sample'"=="noNY"     local suffix = "wild_off"
	   global dir = "`sample'results"
		use "${$dir}/spec`SPEC'/formatresults_SPEC`SPEC'_`sample'_gt10_wild_`suffix'.dta", clear
		di in ye "I'M COMPILING `sample'"
		forvalues i = 1(1)6{
		   ren col`i' col`i'_ols
		}
		sort table order
		tempfile ols
		save `ols', replace

		use "${$dir}/spec`SPEC'/formatresults_SPEC`SPEC'_`sample'_gt10_wildbo_wild_off.dta", clear
		forvalues i = 1(1)6{
		   ren col`i' col`i'_bo
		}
		sort table order
		merge 1:1 table order using `ols'
		gen aux = real(substr(outcome,1,1))
		drop if aux!=.
		drop aux
		
		if "`sample'"=="placebo" | "`sample'"=="percentile"{
			replace col2_bo= col4_bo if table==6 | table==25
			replace col2_ols= col4_ols if table==6 | table==25
    		        foreach var in estimator coeff se N pvalue star adjusted samehouse mig_logit lbd gender ord  _m col3* col4* col5* col6* col1_bo{
			   cap drop `var'
			  }
			gen fillin = outcome
			replace fillin = fillin[_n-1] if fillin[_n]=="" & fillin[_n-1]!=""
			ren fillin fillin_`sample'
			drop fillin_`sample'
			egen ord = group(table order)
			drop table order
			ren ord order
			order order
			sort order
		}

		if "`sample'"=="rejected" | "`sample'"=="noNY" | "`sample'"=="withSEZ"{
			gen fillin = outcome
			replace fillin = fillin[_n-1] if fillin[_n]=="" & fillin[_n-1]!=""
			foreach var in estimator coeff se N pvalue star adjusted samehouse mig_logit lbd gender ord  _m {
			   cap drop `var'
			  }
			  
			gen type = 1 if col3_bo==""
			replace type = 2 if col3_bo!=""
			replace type = 2 if fillin=="qd"
			egen max = max(type), by(table fillin)
			replace type = max
			drop max

			preserve
			keep if type == 1
			drop col1_bo col3* col4* col5* col6*
			ren col1_ols Naive_`sample'
			ren col2_ols OLS_`sample'
			ren col2_bo PW_`sample'
			tempfile f1
			save `f1', replace
			restore

			keep if type == 2
			drop col1_bo col2_bo col3_bo
			ren col1_ols naive_unadjusted
			ren col2_ols naive_adjusted	
			ren col3_ols naive_comp
			ren col4_ols ols_unadjusted
			ren col5_ols ols_adjusted
			ren col6_ols ols_comp
			ren col4_bo PW_unadjusted
			ren col5_bo PW_adjusted
			ren col6_bo PW_comp

			local i = 2
			foreach type in unadjusted adjusted comp{
			  preserve
			  keep outcome stat PW_`type' table naive_`type' ols_`type' fillin type 
			  ren PW_`type' PW_`sample'
			  ren naive_`type' Naive_`sample'
			  ren ols_`type' OLS_`sample'
			  replace outcome = fillin if outcome!=""
			  replace fillin = fillin+"_`type'"
			  tempfile f`i'
			  save `f`i'', replace
			  local i = `i'+1
			  restore
			}
			use `f1', clear
			append using `f2'
			append using `f3'
			append using `f4'
			replace outcome= fillin if outcome!=""
			gen col1_ols = OLS_`sample'  
		        recover_obs, col(1) preserve(not)
			drop col1_ols
			ren Obs Obs_`sample'
			egen group = group(fillin)
			egen count = count(group), by(group)
			egen max = max(table), by(group)
			drop if max==table & count==4  & Naive_`sample' ==""
			drop group count max
			** preserve order
			gen aux = real(substr(fillin,1,1))
			drop if aux!=.
			drop aux
			gen aux = _n
			sort table fillin aux
			by table fillin: gen order2=_n
			sort table aux
			by table:  gen order1=1 if _n==1
			replace order1= order1[_n-1] if order2==2
			replace order1= order1[_n-1] if order2==3
			replace order1= order1[_n-3]+1 if order1==.
			drop aux     
			drop if regexm(fillin,"_comp")==1       
			order table order1 order2 outcome Naive_`sample' OLS_`sample' PW_`sample' Obs_`sample' outcome
			sort table order1 order2
			cap drop order
			cap drop type
			gen wage = (regexm(fillin,"wage")==1 | regexm(fillin,"qd")==1 | regexm(fillin,"incw")==1)
		}		
		save "${$dir}/spec`SPEC'/formatresults_`sample'.dta", replace
	}

**** COMPILE BALANCE
	use "$winloseresults/spec`SPEC'/balance_table_SPEC`SPEC'_winlose_gt10_wild_wild_`switch'.dta", clear
	drop if covariate=="treatedcity"
	ren T EZ
	ren C Rejected_Future
	ren Cadj Rejected_Future_reweighted
	ren praw pvalue_raw_diff
	ren padj pvalue_adj_diff
	replace covariate  = regexr(covariate,"d_","")
	drop staradj
	gen order1 = _n
	sort table order
	by table: gen order = _n
	drop order1
	ren covariate outcome
	drop if outcome=="treatedcity"
	save "$winloseresults/spec`SPEC'/balance.dta", replace

*** Table 3: Balance 
	use "$winloseresults/spec`SPEC'/balance.dta" if table==2, clear
	foreach var in * {
	 cap ren `var' `var'_D
	 cap label var `var'_D "`var' Change"
	}
	ren order_D order
	sort order 
	tempfile part2
	save `part2', replace

	use "$winloseresults/spec`SPEC'/balance.dta" if table==1, clear
	foreach var in * {
	 cap ren `var' `var'_L
	 cap label var `var'_L "`var' Level"
	}
	ren order_L order
	sort order 
	merge 1:1 order using `part2'
	drop _m table* order* outcome_D
	ren outcome_L outcome
	formatvarnames
	gen C = .
	order outcome EZ_L Rejected_Future_L Rejected_Future_reweighted_L pvalue_raw_diff_L pvalue_adj_diff_L C EZ_D Rejected_Future_D Rejected_Future_reweighted_D pvalue_raw_diff_D pvalue_adj_diff_D 
	export excel using  "$results/RESULTS_SPEC`SPEC'.xls",  sheet("T3") firstrow(var) replace

**** TABLE 4: LBD outcomes
	use "$winloseresults/spec`SPEC'/formatresults_winlose.dta" if table==4, clear
        recover_obs, col(1) preserve(not)
	drop col1_bo col3* col4* col5* col6* _merge table order
	ren col1_ols Naive
	ren col2_ols OLS
	ren col2_bo  PW
	formatvarnames
        if "`withobs'"!="on" drop Obs
	gen C = .
	order outcome Naive OLS PW C 
	export excel using  "$results/RESULTS_SPEC`SPEC'.xls", sheet("T4") firstrow(var)

*** Table 5: Jobs JTW
	use "$winloseresults/spec`SPEC'/formatresults_winlose.dta" if table==5, clear
        recover_obs, col(1) preserve(not)
	drop col1_bo col3* col4* col5* col6* _merge table order
	ren col1_ols Naive
	ren col2_ols OLS
	ren col2_bo  PW
	order outcome Naive OLS PW Obs
	formatvarnames
        if "`withobs'"!="on" drop Obs
	gen C = .
	order outcome Naive OLS PW C 
	export excel using "$results/RESULTS_SPEC`SPEC'.xls", sheet("T5") firstrow(var)

*** Table 6: Weekly and Annual Wages
	use "$winloseresults/spec`SPEC'/formatresults_winlose.dta" if table==25, clear
        recover_obs, col(1) preserve(not)
	replace outcome = outcome[_n-1] if outcome==""
        drop if outcome=="lnhhincp2" | outcome=="lnhhincw2" | outcome=="lnincw2" | outcome=="lnincw2_pow" | outcome=="qd"
	replace outcome = "" if substr(col1_bo,1,1)==""
	replace outcome = "" if substr(col1_bo,1,1)=="["

	drop col1_bo col2_bo col3_bo
	
	ren col1_ols Unadjusted_naive
	ren col2_ols Adjusted_naive
	ren col3_ols Composition_naive

	ren col4_ols Unadjusted_OLS
	ren col5_ols Adjusted_OLS
	ren col6_ols Composition_OLS

	ren col4_bo Unadjusted_PW
	ren col5_bo Adjusted_PW
	ren col6_bo Composition_PW

	formatvarnames
        gen C1 = .
        gen C2 = .
        gen C3 = .
        order outcome Unadjusted_naive Unadjusted_OLS Unadjusted_PW C1 Adjusted_naive Adjusted_OLS Adjusted_PW C2 Composition_naive Composition_OLS Composition_PW C3 Obs
        if "`withobs'"!="on" drop *Obs
	drop order table _merge
	export excel using  "$results/RESULTS_SPEC`SPEC'.xls", sheet("T6") firstrow(var)

*** Table 7: Housing
	use "$winloseresults/spec`SPEC'/formatresults_winlose.dta" if table==7 | table==23, clear
        recover_obs, col(1) preserve(not)
	replace outcome = outcome[_n-1] if outcome==""
	drop if outcome =="employed" | outcome=="lnhh"  | outcome=="lnpop" | outcome=="lnwage2" | outcome=="poverty" | outcome=="samehouse" | outcome=="unemployed" | outcome=="vacant"
	drop col5* col6* _merge
	replace col1_bo  = col2_bo if table==23
	replace col1_ols = col2_ols if table==23
	replace col3_bo = col4_bo if table==23
	replace col3_ols = col4_ols if table==23
	replace col2_bo  = col3_bo if table==23
	replace col2_ols = col3_ols if table==23
	drop col3* col4*
	drop col1_bo
	ren col1_ols Naive
	ren col2_ols OLS
	ren col2_bo  PW
	tab outcome 
	replace outcome = "lnrent2_new_unadjusted" if outcome=="lnrent2_unadjusted" & table==23 
	replace outcome = "lnrent2_new_adjusted" if outcome=="lnrent2_adjusted" & table==23 
	replace outcome = "lnrent2_new_comp" if outcome=="lnrent2_comp" & table==23 
	replace outcome = "lnvalue2_new_unadjusted" if outcome=="lnvalue2_unadjusted" & table==23 
	replace outcome = "lnvalue2_new_adjusted" if outcome=="lnvalue2_adjusted" & table==23 
	replace outcome = "lnvalue2_new_comp" if outcome=="lnvalue2_comp" & table==23 
	drop table order
	gen  type = "_unadjusted" if regexm(outcome,"_unadjusted")==1
	replace  type = "_adjusted" if regexm(outcome,"_adjusted")==1
	replace  type = "_comp" if regexm(outcome,"_comp")==1
	replace  outcome = regexr(outcome,"_comp","")
	replace  outcome = regexr(outcome,"_adjusted","")
	replace  outcome = regexr(outcome,"_unadjusted","")
	gen order = 3 if substr(Naive,1,1)==""
	replace order = 2 if substr(Naive,1,1)=="["
	replace order = 1 if order==.
	reshape wide Naive OLS PW Obs, i(outcome order) j(type) string
	gen C1 = .
	gen C2 = .
	gen C3 = .
	drop Obs_adjusted Obs_comp
	ren Obs_unadjusted Obs
        order outcome Naive_unadjusted OLS_unadjusted PW_unadjusted C1  Naive_adjusted OLS_adjusted PW_adjusted C2 Naive_comp OLS_comp PW_comp C3 Obs 
	formatvarnames
        if "`withobs'"!="on" drop Obs
	replace outcome = "" if order!=1
	drop order
	export excel using  "$results/RESULTS_SPEC`SPEC'.xls", sheet("T7") firstrow(var)

*** Table 8: Population and Mobility
	use "$winloseresults/spec`SPEC'/formatresults_winlose.dta" if table==7 | table==22, clear
        recover_obs, col(1) preserve(not)
	replace outcome = outcome[_n-1] if outcome==""
	drop if outcome =="beta_all" | regexm(outcome,"lnrent")==1 | regexm(outcome,"lnvalue")==1
	drop col1_bo col3* col4* col5* col6* _merge table order
	ren col1_ols Naive
	ren col2_ols OLS
	ren col2_bo  PW
	formatvarnames
        if "`withobs'"!="on" drop *Obs
	gen C1=.
	order outcome Naive OLS PW C1 Obs
	replace outcome = "" if substr(Naive,1,1)==""
	replace outcome = "" if substr(Naive,1,1)=="["
	export excel using  "$results/RESULTS_SPEC`SPEC'.xls", sheet("T8") firstrow(var)

*** Table 9: SEZ (non-wage outcomes)
	use "$results/samplewithSEZ/spec`SPEC'/formatresults_withSEZ.dta" if wage==0, clear
	sort table order1 order2
        drop table order1 order2 fillin wage
	formatvarnames
	ren OLS_withSEZ  OLS
	ren PW_withSEZ  PW
	ren Naive_withSEZ Naive
	ren Obs_withSEZ Obs
	gen C = .
	order outcome Naive OLS PW C Obs 
        export excel using  "$results/RESULTS_SPEC`SPEC'.xls", sheet("T9") firstrow(var)

*** Table 9: SEZ (wage outcomes)
	use "$results/samplewithSEZ/spec`SPEC'/formatresults_withSEZ.dta" if wage==1, clear
	sort table order1 order2
        drop table order1 order2 fillin wage
	formatvarnames
	ren OLS_withSEZ  OLS
	ren PW_withSEZ  PW
	ren Naive_withSEZ Naive
	ren Obs_withSEZ Obs
	gen C = .
	order outcome Naive OLS PW C Obs 
        export excel using  "$results/RESULTS_SPEC`SPEC'.xls", sheet("T9W") firstrow(var)

*** Table 10: Placebo and Percentile
	use "$placeboresults/spec`SPEC'/formatresults_placebo.dta" , clear
        recover_obs, col(1) preserve(not)
	ren col1_ols Placebo_Naive
	ren col2_ols Placebo_OLS
	ren col2_bo  Placebo_PW
	ren Obs Placebo_Obs
	tempfile placebo
	save `placebo', replace
	
	use "$percentileresults/spec`SPEC'/formatresults_percentile.dta", clear
        recover_obs, col(1) preserve(not)
	ren col1_ols Percentile_Naive
	ren col2_ols Percentile_OLS
	ren col2_bo  Percentile_PW
	ren Obs Percentile_Obs
	
	merge 1:1 order using `placebo'
	drop _m  ord
	formatvarnames
        order outcome Placebo_Naive Placebo_OLS Placebo_PW Placebo_Obs outcome Percentile_Naive Percentile_OLS Percentile_PW Percentile_Obs 
        if "`withobs'"!="on" drop *Obs
	gen C = .
	order outcome Placebo_Naive Placebo_OLS Placebo_PW C 
	export excel using  "$results/RESULTS_SPEC`SPEC'.xls", sheet("T10") firstrow(var)	

*** Table 11: Totals for Welfare
	use "$results/winlose/descriptives/totals.dta", clear
	xpose, clear varname
	format v1 v2 v3 %20.3g
	ren _varname outcome
        formatvarnames
	order outcome
	export excel using  "$results/RESULTS_SPEC`SPEC'.xls", sheet("T11-tots") 

*** Table 11: Welfare Confidence Intervals
        use "$results/winlose/CIs/CIs.dta", clear
        gen outcome = regexr(names,"d_","")
        order outcome 
	drop names 
	formatvarnames
        export excel using  "$results/RESULTS_SPEC`SPEC'.xls", sheet("T11-CI") firstrow(var)


*** Figure 1 and A2: Balance plots
	use "$winloseresults/spec`SPEC'/balance_plot_SPEC`SPEC'_winlose_gt10.dta", clear
	sort figure outcome
	ren meanEZ EZ
	ren meannonEZ nonEZ
	ren meannonEZReweighted nonEZ_PW
	formatvarnames
	replace figure =1 if outcome=="Economic Index (Workers) -LBD"
	export excel using "$results/RESULTS_SPEC`SPEC'.xls",  sheet("F1&FA2") firstrow(var)

*** Figure 2. Data for Figure for Annual LBD plot
        use "$results/winlose/annual_lbd_plots/data_annual_lbd_plot.dta", clear
	order outcome year
        gen y = year
        drop year
        ren y year	
	formatvarnames
	ren ez EZ
	ren nonez nonEZ
	ren nonez_rw nonEZ_PW
	order outcome year
	export excel using  "$results/RESULTS_SPEC`SPEC'.xls", sheet("F2") firstrow(var)

*** Figure A2 footnote: pvals for POW variables
	use "$winloseresults/spec`SPEC'/balance.dta" if table==3 & _n<=6, clear
	drop table order
	formatvarnames
	export excel using "$results/RESULTS_SPEC`SPEC'.xls",  sheet("FA2-foot") firstrow(var)


*** Table A2: BALANCE Second Moments
	use "$results/winlose/spec`SPEC'/BAL1_spec`SPEC'_winlose_bo_wild_on_secondmom.dta", clear
	drop staradj
	ren T EZ
	ren C Rejected_Future
	ren Cadj Rejected_Future_reweighted
	ren praw pvalue_raw_diff
	ren padj pvalue_adj_diff
	ren covariate outcome
	order outcome
	drop if outcome=="treatedcity"
	formatvarnames	
        export excel using  "$results/RESULTS_SPEC`SPEC'.xls", sheet("TA2") firstrow(var)

*** Table A3: Robustness Samples
	use "$results/samplerejected/spec`SPEC'/formatresults_rejected.dta", clear
	merge 1:1 table fillin order2 using "$results/samplenoNY/spec`SPEC'/formatresults_noNY.dta"
	tab _m
	drop if _m!=3
	drop _m
	sort table order1 order2
        preserve
	keep if wage==0
	drop table order1 order2 fillin wage
	formatvarnames
        gen C = .
        order outcome Naive_rejected OLS_rejected PW_rejected Obs_rejected C
        export excel using  "$results/RESULTS_SPEC`SPEC'.xls", sheet("TA3") firstrow(var)
        restore
	
	keep if wage==1
	drop table order1 order2 fillin wage
	formatvarnames
        gen C = .
        order outcome Naive_rejected OLS_rejected PW_rejected Obs_rejected C
        export excel using  "$results/RESULTS_SPEC`SPEC'.xls", sheet("TA3W") firstrow(var)
	
	
*** Table A4: Gender
	use "$winloseresults/spec`SPEC'/formatresults_winlose.dta" if table==21, clear
	drop col5* col6* col1_bo col2_bo _merge table order
        recover_obs, col(1) preserve(on)
	ren Obs Female_Obs
        recover_obs, col(2) preserve(not)
	ren Obs Male_Obs
	ren col1_ols Female_Naive
	ren col2_ols Male_Naive
	ren col3_ols Female_OLS
	ren col4_ols Male_OLS
	ren col3_bo  Female_PW
	ren col4_bo  Male_PW
	order outcome Female_Naive Female_OLS Female_PW  Female_Obs Male_Naive Male_OLS Male_PW Male_Obs
	formatvarnames
        if "`withobs'"!="on" drop *Obs
        gen C = .
	order outcome Female_Naive Female_OLS Female_PW Female_Obs C
	export excel using  "$results/RESULTS_SPEC`SPEC'.xls", sheet("TA4")  firstrow(var)

*** Table A5: Amenities
	use "$winloseresults/spec`SPEC'/formatresults_winlose.dta" if table==24, clear
        recover_obs, col(1) preserve(not)
	drop col1_bo col3* col4* col5* col6* _merge table order
	ren col1_ols Naive
	ren col2_ols OLS
	ren col2_bo  PW
	order outcome Naive OLS PW
	formatvarnames
        if "`withobs'"!="on" drop *Obs
	gen C = .
	order outcome Naive OLS PW C Obs
	export excel using  "$results/RESULTS_SPEC`SPEC'.xls",  sheet("TA5") firstrow(var)

*** Table A6: Hourly Wages
	use "$winloseresults/spec`SPEC'/formatresults_winlose.dta" if table==6, clear
        recover_obs, col(1) preserve(not)
	drop col1_bo col2_bo col3_bo 
	
	ren col1_ols Unadjusted_naive
	ren col2_ols Adjusted_naive
	ren col3_ols Composition_naive
        
	ren col4_ols Unadjusted_OLS
	ren col5_ols Adjusted_OLS
	ren col6_ols Composition_OLS

	ren col4_bo Unadjusted_PW
	ren col5_bo Adjusted_PW
	ren col6_bo Composition_PW

	drop order table _merge
	formatvarnames	
        if "`withobs'"!="on" drop Obs
        gen C1 = .
        gen C2 = .
        gen C3 = .
        order outcome Unadjusted_naive Unadjusted_OLS Unadjusted_PW C1 Adjusted_naive Adjusted_OLS Adjusted_PW C2 Composition_naive Composition_OLS Composition_PW C3 Obs
	export excel using  "$results/RESULTS_SPEC`SPEC'.xls", sheet("TA6") firstrow(var)
	
*** Table A7: Other Income variables (including QD)
	use "$winloseresults/spec`SPEC'/formatresults_winlose.dta" if table==25, clear
        recover_obs, col(1) preserve(not)
	replace outcome = outcome[_n-1] if outcome==""
        keep if outcome=="lnhhincp2" | outcome=="lnhhincw2" | outcome=="lnincw2" | outcome=="lnincw2_pow" | outcome=="qd"
	replace outcome = "" if substr(col1_bo,1,1)==""
	replace outcome = "" if substr(col1_bo,1,1)=="["

	drop col1_bo col2_bo col3_bo
	
	ren col1_ols Unadjusted_naive
	ren col2_ols Adjusted_naive
	ren col3_ols Composition_naive

	ren col4_ols Unadjusted_OLS
	ren col5_ols Adjusted_OLS
	ren col6_ols Composition_OLS

	ren col4_bo Unadjusted_PW
	ren col5_bo Adjusted_PW
	ren col6_bo Composition_PW

	drop order table _merge
	formatvarnames	
        if "`withobs'"!="on" drop *Obs
        gen C1 = .
        gen C2 = .
        gen C3 = .
        order outcome Unadjusted_naive Unadjusted_OLS Unadjusted_PW C1 Adjusted_naive Adjusted_OLS Adjusted_PW C2 Composition_naive Composition_OLS Composition_PW C3 Obs
	export excel using  "$results/RESULTS_SPEC`SPEC'.xls", sheet("TA7") firstrow(var)

*** Table A8: Unimputed Local Wages
	use "$winloseresults/spec`SPEC'/formatresults_winlose.dta" if table==26, clear
        recover_obs, col(1) preserve(not)
	drop col1_bo col2_bo col3_bo 
	
	ren col1_ols Unadjusted_naive
	ren col2_ols Adjusted_naive
	ren col3_ols Composition_naive
        
	ren col4_ols Unadjusted_OLS
	ren col5_ols Adjusted_OLS
	ren col6_ols Composition_OLS

	ren col4_bo Unadjusted_PW
	ren col5_bo Adjusted_PW
	ren col6_bo Composition_PW
        order outcome outcome Unadjusted_naive Unadjusted_OLS Unadjusted_PW Adjusted_naive Adjusted_OLS Adjusted_PW Composition_naive Composition_OLS Composition_PW Obs

	drop order table _merge
	formatvarnames	
        if "`withobs'"!="on" drop Obs
	export excel using  "$results/RESULTS_SPEC`SPEC'.xls", sheet("TA8") firstrow(var)

*** Table A10: Same House
	use "$winloseresults/spec`SPEC'/formatresults_winlose.dta" if table==23 , clear
	drop col5* col6* col1_bo col2_bo _merge table order
        drop if col3_bo !="" & col4_bo ==""
        recover_obs, col(1) preserve(on)
        ren Obs SameHouse_Obs
        recover_obs, col(2) preserve(not)
        ren Obs NewArrival_Obs
	ren col1_ols SameHouse_Naive
	ren col2_ols NewArrival_Naive
	ren col3_ols SameHouse_OLS
	ren col4_ols NewArrival_OLS
	ren col3_bo  SameHouse_PW
	ren col4_bo  NewArrival_PW
	drop NewArrival_Naive NewArrival_OLS NewArrival_PW NewArrival_Obs
	order outcome SameHouse_Naive SameHouse_OLS SameHouse_PW  SameHouse_Obs 
	formatvarnames
        if "`withobs'"!="on" drop *Obs
	export excel using  "$results/RESULTS_SPEC`SPEC'.xls",  sheet("TA10")  firstrow(var)

*** Table with sample sizes	
        use "$results/samplesizes.dta", clear
	drop n
	order sample
	export excel using  "$results/RESULTS_SPEC`SPEC'.xls", sheet("desc") firstrow(var)

*** Table Variables names and labels
       insheet using "/rdcprojects/mc1/mc00535/programs_organize/1.library/formatvarnames.ado", clear delimiter(" ")
       drop v1 v2 v3 v5 v11
       drop if v4==""
	forvalues i = 6(1)13{
	cap replace v`i' = "" if trim(v`i')=="if"
	cap replace v`i' = "" if trim(v`i')=="|"
	}

	replace v6 = "" if regexm(v6,"if")==1
	
	forvalues i = 7(1)13{
	cap replace v6 = v`i' if v6=="" & v`i'!=""
	}
       keep v4 v6
       ren v4 varlabel
       ren v6 varname
       drop if _n==1
       order varname
       export excel using  "$results/RESULTS_SPEC`SPEC'.xls", sheet("varmap") firstrow(var)

** Get Covariates used in OLS/BO
       run "$dofiles/3.pscore.do" 1 ols 0 1 winlose_gt10 wild_off
       collapse $X
       xpose, varname clear
       drop v1
       export excel using  "$results/RESULTS_SPEC`SPEC'.xls", sheet("Xs") firstrow(var)
       
*** Erase auxiliary datasets
	erase "$winloseresults/spec`SPEC'/balance.dta"
	erase "$winloseresults/spec`SPEC'/formatresults_winlose.dta"
	erase "$placeboresults/spec`SPEC'/formatresults_placebo.dta"
	erase "$percentileresults/spec`SPEC'/formatresults_percentile.dta"
	erase "$rejectedresults/spec`SPEC'/formatresults_rejected.dta"
	erase "$withSEZresults/spec`SPEC'/formatresults_withSEZ.dta"
	erase "$noNYresults/spec`SPEC'/formatresults_noNY.dta"      
	
	 
