cap run "/rdcprojects/mc1/mc00535/programs_organize/3.estimation/1.setup.do"
if _rc!=0 di in red "run 1.setup.do"

use "$censusdir/workfile_90_fullcounties_prepped.dta", clear

** Prepare data for percentile estimation
   egen count = sum(assigned_tract!=.), by(cg)
   keep if count>=1 & count<. // dropping cities in sample counties that do not contain an EZ or control
   drop count

** Construct pctiles
   tsset id yr
   foreach var of global outcomes1{
     di in ye "pctile `var' was just done"
     qui egen rank = rank(`var') if `var'!=., by(cg yr)
     qui egen count = count(`var') if `var'!=., by(cg yr)
     qui gen pct_`var' = rank / count
     qui gen d_pctile = pct_`var' - L.pct_`var'
     qui replace d_`var' = d_pctile
     qui label var d_`var' "Change in percentile of `var'"
     qui drop rank count d_pctile pct_`var'
   }

save "$censusdir/workfile_90_percentile.dta", replace

