** 1. Setup and open main file ------------------------------------------------------------------------------------------------------
global censusdir = "/rdcprojects/mc1/mc00535/programs_organize/3.estimation/3.workfile"

tsset id yr

** 3. Make covariate indices for balance table
cap drop housingindex d_housingindex
gen housingindex=0
gen d_housingindex=0
local housingvars "lnrent2 lnvalue2 -vacant"
local num: word count local housingvars
foreach var of local housingvars{
	local sign=""
	if regexm("`var'","-"){	
	local sign="-"
	local var=regexr("`var'","-","")
	di "`var' has a minus, sign is `sign'"
	}

	cap drop sd
	qui sum `var' if yr==3&assigned_tract==1
	gen sd=r(sd)
	qui replace housingindex=housingindex+`sign' `var'/sd/`num'

	qui sum d.`var' if yr==3&assigned_tract==1
	replace sd=r(sd)
	qui replace d_housingindex=d_housingindex+`sign' d.`var'/sd/`num'
}
qui sum housingindex if yr==3&assigned_tract==1
qui replace housingindex=(housingindex-r(mean))/r(sd)
qui sum d_housingindex if yr==3&assigned_tract==1
qui replace d_housingindex=(d_housingindex-r(mean))/r(sd)

cap drop econindex1 d_econindex1
gen econindex1=0
gen d_econindex1=0
local econvars1 "employed -unemployed -poverty"
local num: word count local econvars1
foreach var of local econvars1{
	local sign=""
	if regexm("`var'","-"){	
	local sign="-"
	local var=regexr("`var'","-","")
	di "`var' has a minus, sign is `sign'"
	}

	cap drop sd
	qui sum `var' if yr==3&assigned_tract==1
	gen sd=r(sd)	
	qui replace econindex1=econindex1+`sign' `var'/sd/`num'
	
	qui sum d.`var' if yr==3&assigned_tract==1
	replace sd=r(sd)
	qui replace d_econindex1=d_econindex1+`sign' d.`var'/sd/`num'	
}
qui sum econindex1 if yr==3&assigned_tract==1
qui replace econindex1=(econindex1-r(mean))/r(sd)
qui sum d_econindex1 if yr==3&assigned_tract==1
qui replace d_econindex1=(d_econindex1-r(mean))/r(sd)


cap drop econindex2 d_econindex2
gen econindex2=0
gen d_econindex2=0
local econvars2 "lnjobs lnwkwage2 lnwkwage2_pow"
local num: word count local econvars2
foreach var of local econvars2{
	cap drop sd
	qui sum `var' if yr==3&assigned_tract==1
	gen sd=r(sd)		
	qui replace econindex2=econindex2+`var'/sd/`num'
	
	qui sum d.`var' if yr==3&assigned_tract==1
	replace sd=r(sd)
	qui replace d_econindex2=d_econindex2+d.`var'/sd/`num'	
}
qui sum econindex2 if yr==3&assigned_tract==1
qui replace econindex2=(econindex2-r(mean))/r(sd)
qui sum d_econindex2 if yr==3&assigned_tract==1
qui replace d_econindex2=(d_econindex2-r(mean))/r(sd)


cap drop econindex3 d_econindex3
gen econindex3=0
gen d_econindex3=0
local econvars3 "lnemplbd lnest lnavrgwage"
local num: word count local econvars3
foreach var of local econvars3{
	cap drop sd
	qui sum `var' if yr==3&assigned_tract==1
	gen sd=r(sd)		
	qui replace econindex3=econindex3+`var'/sd/`num'
	
	qui sum d.`var' if yr==3&assigned_tract==1
	replace sd=r(sd)
	qui replace d_econindex3=d_econindex3+d.`var'/sd/`num'	
}
qui sum econindex3 if yr==3&assigned_tract==1
qui replace econindex3=(econindex3-r(mean))/r(sd)
qui sum d_econindex3 if yr==3&assigned_tract==1
qui replace d_econindex3=(d_econindex3-r(mean))/r(sd)


cap drop demoindex d_demoindex
gen demoindex=0
gen d_demoindex=0
local demovars "-female_head college -dropout -black -hisp"
local num: word count local demovars
foreach var of local demovars{
	local sign=""
	if regexm("`var'","-"){	
	local sign="-"
	local var=regexr("`var'","-","")
	di "`var' has a minus, sign is `sign'"
	}

	cap drop sd
	qui sum `var' if yr==3&assigned_tract==1
	gen sd=r(sd)	
	qui replace demoindex=demoindex+`sign' `var'/sd/`num'
	

	qui sum d.`var' if yr==3&assigned_tract==1
	replace sd=r(sd)
	qui replace d_demoindex=d_demoindex+`sign' d.`var'/sd/`num'
}
qui sum demoindex if yr==3&assigned_tract==1
qui replace demoindex=(demoindex-r(mean))/r(sd)
qui sum d_demoindex if yr==3&assigned_tract==1
qui replace d_demoindex=(d_demoindex-r(mean))/r(sd)

cap drop popindex d_popindex
gen popindex=0
gen d_popindex=0
local popvars "lnpop lnhh samehouse"
local num: word count local popvars
foreach var of local popvars{
	cap drop sd
	qui sum `var' if yr==3&assigned_tract==1
	gen sd=r(sd)		
	qui replace popindex=popindex+`var'/sd/`num'

	qui sum d.`var' if yr==3&assigned_tract==1
	replace sd=r(sd)
	qui replace d_popindex=d_popindex+d.`var'/sd/`num'
}
qui sum popindex if yr==3&assigned_tract==1
qui replace popindex=(popindex-r(mean))/r(sd)
qui sum d_popindex if yr==3&assigned_tract==1
qui replace d_popindex=(d_popindex-r(mean))/r(sd)

cap drop sd
compress


** 4. Generate covariates -------------------------------------------------------------------------------------------------
   foreach var in housingindex econindex1 econindex2 econindex3 demoindex popindex{
        cap drop l_`var' l2_`var' l_d_`var'
        gen l_`var'   = l.`var'
        gen l2_`var'  =l2.`var'
        gen l_d_`var' =l.d_`var'
     }

cap drop _merge
