
args SPECIFICATION TrimLO TrimHI TYPE

**** setup
if "`TYPE'"=="winlose_gt10"          local results = "$winloseresults"
if "`TYPE'"=="placebo_gt10"          local results = "$placeboresults"
if "`TYPE'"=="percentile_gt10"       local results = "$percentileresults"
if "`TYPE'"=="noNY_gt10"             local results = "$noNYresults"
if "`TYPE'"=="withSEZ_gt10"          local results = "$withSEZresults"
if "`TYPE'"=="rejected_gt10"         local results = "$rejectedresults"
local NAME= "SPEC`SPECIFICATION'_`TrimLO'_`TrimHI'_`TYPE'"

if "`SPECIFICATION'"!="buildplacebo"{
***************************************************************************
**                              BALANCE PLOT                             **
***************************************************************************
tempname memhold
tempfile resultsbalance
postfile `memhold' str20(outcome) year meanEZ meannonEZ d using `resultsbalance'
foreach var in $PLOT1{
   forvalues y = 2(1)4{
      if `y'==4 local ts = ""
      if `y'==3 local ts = "l_"
      if `y'==2 local ts = "l2_"
        cap drop _cluster
	qui sum `ts'`var' if yr==4 & touse==1 & phat!=. & assigned_tract==1
	local mu1 = r(mean)
	qui sum `ts'`var' if yr==4 & touse==1 & phat!=. & assigned_tract==0
	local mu0 = r(mean)
	qui bo2 `ts'`var' $X if yr==4 & touse==1 & phat!=., t(assigned_tract)
	local d = e(delt)
	post `memhold' ("`var'") (`y') (`mu1') (`mu0') (`d')
  }
 }
postclose `memhold'
preserve
use `resultsbalance', clear
gen meannonEZReweighted = meanEZ-d
drop d
#delimit ;
gen     figure = 3 if outcome=="lnpop" | outcome=="employed" | 
                      outcome=="lnrent2" | outcome=="lnvalue2" | 
                      outcome=="lnwkwage2" | outcome=="lnjobs";
replace figure = 1 if outcome=="popindex" | outcome=="demoindex" | 
                      outcome=="econindex1" | outcome=="econindex2" | outcome=="econindex3" |  
                      outcome=="housingindex" ;
replace figure = 2 if outcome=="lnjobs_outside" | outcome=="lnjobs_local" | 
                      outcome=="lnjobs_nonlocal" | outcome=="lnwkwage2_outside" | 
                      outcome=="lnwkwage2_local" | outcome=="lnwkwage2_nonlocal";
replace outcome = "Ln(Population)"  if outcome=="lnpop";
replace outcome = "Employment Rate" if outcome=="employed";
replace outcome = "Ln(Rent)"        if outcome=="lnrent2";
replace outcome = "Ln(Housing Value)" if outcome=="lnvalue2";
replace outcome = "Ln(Wage)"          if outcome=="lnwage2";
replace outcome = "Ln(WkWage)"          if outcome=="lnwkwage2";
replace outcome = "Ln(Jobs)"          if outcome=="lnjobs";
replace outcome = "Ln(Jobs | Outside)"   if outcome=="lnjobs_outside";
replace outcome = "Ln(Jobs | Local)"     if outcome=="lnjobs_local";
replace outcome = "Ln(Jobs | Non-local)" if outcome=="lnjobs_nonlocal";
replace outcome = "Ln(WkWage | Outside)"   if outcome=="lnwkwage2_outside";
replace outcome = "Ln(WkWage | Local)"     if outcome=="lnwkwage2_local";
replace outcome = "Ln(WkWage | Non-local)" if outcome=="lnwkwage2_nonlocal";

replace outcome = "Population Index" if outcome=="popindex";
replace outcome = "Demographic Index" if outcome=="demoindex";
replace outcome = "Economic Index (Residents)" if outcome=="econindex1";
replace outcome = "Economic Index (Workers)" if outcome=="econindex2";
replace outcome = "Economic Index (Workers - LBD)" if outcome=="econindex3";
replace outcome = "Housing Index" if outcome=="housingindex";

replace year = 1980 if year==2;
replace year = 1990 if year==3;
replace year = 2000 if year==4;
label var meanEZ "EZ";
label var meannonEZ "non-EZ";
label var meannonEZReweighted "non-EZ reweighted";

twoway (line meanEZ meannonEZ meannonEZReweighted year if figure==1, 
        lpattern(solid dot dash)), xtitle(Year) xtitle(, size(vsmall)) 
        by(, title(Balance of Levels and Trends, size(medium)) 
        caption(" ") note(" ") ) legend(rows(1) size(small)) scheme(s2mono) 
        by(outcome, style(rescale) iylabel) subtitle(, size(small) nobox) 
        graphregion(margin(sides));
graph export "`results'/balance1_`NAME'.eps", as(eps) preview(off) replace;
!epstopdf "`results'/balance1_`NAME'.eps";
erase "`results'/balance1_`NAME'.eps";

twoway (line meanEZ meannonEZ meannonEZReweighted year if figure==2,
        lpattern(solid dot dash)), xtitle(Year) xtitle(, size(vsmall)) 
        by(, title(Balance of Levels and Trends, size(medium)) 
        caption("Local: Zone residents working inside the zone. Non-local: Zone non-residents" 
                "working inside the zone. Outside: Zone residents working outside the zone.", 
        size(small)) note(" ")) legend(rows(1) size(small)) scheme(s2mono) 
        by(outcome, style(rescale) iylabel) subtitle(, size(small) nobox) 
        graphregion(margin(sides));
graph export "`results'/balance2_`NAME'.eps", as(eps) preview(off) replace;
!epstopdf "`results'/balance2_`NAME'.eps";
erase "`results'/balance2_`NAME'.eps";

twoway (line meanEZ meannonEZ meannonEZReweighted year if figure==3, 
        lpattern(solid dot dash)), xtitle(Year) xtitle(, size(vsmall)) 
        by(, title(Balance of Levels and Trends, size(medium)) 
        caption(" ") note(" ") ) legend(rows(1) size(small)) scheme(s2mono) 
        by(outcome, style(rescale) iylabel) subtitle(, size(small) nobox) 
        graphregion(margin(sides));
graph export "`results'/balance3_`NAME'.eps", as(eps) preview(off) replace;
!epstopdf "`results'/balance3_`NAME'.eps";
erase "`results'/balance3_`NAME'.eps";


save "`results'/balance_plot_`NAME'.dta", replace;
restore;
#delimit cr
}
