args SPECIFICATION ESTIMATOR TrimLO TrimHI TYPE flag

**** setup
if "`TYPE'"=="winlose_gt10"          local results = "$winloseresults"
if "`TYPE'"=="placebo_gt10"          local results = "$placeboresults"
if "`TYPE'"=="percentile_gt10"       local results = "$percentileresults"
if "`TYPE'"=="noNY_gt10"             local results = "$noNYresults"
if "`TYPE'"=="withSEZ_gt10"          local results = "$withSEZresults"
if "`TYPE'"=="rejected_gt10"         local results = "$rejectedresults"
local NAME= "SPEC`SPECIFICATION'_`TrimLO'_`TrimHI'_`TYPE'_`ESTIMATOR'_`flag'"

**** pscore estimation
do "$dofiles/3.pscore.do" `SPECIFICATION' `ESTIMATOR' `TrimLO' `TrimHI' `TYPE' `flag'

tempname memhold
postfile `memhold' str30(outcome estimator) double(coeff se N pvalue) using "`results'/results_`NAME'.dta", replace 

if ("`TYPE'"=="placebo_gt10" | "`TYPE'"=="percentile_gt10") global outcomes "$outcomes1"
if ("`TYPE'"=="rejected_gt10" | "`TYPE'"=="withSEZ_gt10" | "`TYPE'"=="noNY_gt10") global outcomes "$outcomes1 $outcomes2"
if ("`TYPE'"=="winlose_gt10" ) global outcomes "$outcomes1 $outcomes2 $outcomes3"

if "$REPS"=="" global REPS = 2
di "REPS=$REPS"

foreach var of global outcomes {
*** NAIVE ***
   if ("`ESTIMATOR'"!="wild" & "`ESTIMATOR'"!="wildbo") {
	qui reg d_`var' assigned_tract if yr==4, cluster($cluster)
	post `memhold' ("d_`var'") ("1.naive") (_b[assigned_tract]) (_se[assigned_tract]) (e(N)) (.)
   }
   else {
	qui wild d_`var' if yr==4, cluster($cluster) d(assigned_tract) reps($REPS)
	post `memhold' ("d_`var'") ("1.naive") (_b[assigned_tract]) (_se[assigned_tract]) (e(N)) (e(p))
   }

*** OLS (reg Y T X) ***
   if "`ESTIMATOR'"=="ols"{
        qui reg d_`var' assigned_tract $X if yr==4, cluster($cluster)
	post `memhold' ("d_`var'") ("2.ols") (_b[assigned_tract]) (_se[assigned_tract]) (e(N)) (.)
   }
*** OLS (reg Y T X) WILD BOOTSTRAP***
   if "`ESTIMATOR'"=="wild"{
	qui wild d_`var' $X if yr==4, cluster($cluster) d(assigned_tract) reps($REPS)
	post `memhold' ("d_`var'") ("2.wild") (_b[assigned_tract]) (_se[assigned_tract]) (e(N)) (e(p))
    }
*** BLINDER-OAXACA ***
   if "`ESTIMATOR'"=="bo"{
	qui bo2 d_`var' $X if yr==4, treatment(assigned_tract) cluster($cluster)
	post `memhold' ("d_`var'") ("2.bo") (e(delt)) (e(se)) (e(N)) (.)
    }
*** BLINDER-OAXACA WILD BOOTSTRAP***
   if "`ESTIMATOR'"=="wildbo"{
	qui wild_bo d_`var' $X if yr==4, d(assigned_tract) cluster($cluster) reps($REPS)
	post `memhold' ("d_`var'") ("2.wildbo") (e(delt)) (e(se_analit)) (e(N)) (e(p))
   }
}
postclose `memhold'

**** build tables
do "$dofiles/6.tables.do" `SPECIFICATION' `ESTIMATOR' `TrimLO' `TrimHI' `TYPE' `flag'
